import _extends from "@babel/runtime/helpers/esm/extends";
import React from 'react';
import { getHeight, getWidth, getRectX, getRectY, translate } from '../utils/Utils';
import useChartContext from '../utils/chartContext'; //

export default function BarComponent(_ref) {
  var primaryAxis = _ref.primaryAxis,
      secondaryAxis = _ref.secondaryAxis,
      allSeries = _ref.series;

  var _useChartContext = useChartContext(),
      getSeriesStatusStyle = _useChartContext.getSeriesStatusStyle,
      getDatumStatusStyle = _useChartContext.getDatumStatusStyle,
      useFocusedDatumAtom = _useChartContext.useFocusedDatumAtom,
      gridDimensions = _useChartContext.gridDimensions;

  var _useFocusedDatumAtom = useFocusedDatumAtom(),
      focusedDatum = _useFocusedDatumAtom[0];

  return /*#__PURE__*/React.createElement("g", {
    style: {
      transform: translate(gridDimensions.gridX, gridDimensions.gridY)
    }
  }, allSeries.map(function (series, i) {
    var style = getSeriesStatusStyle(series, focusedDatum);
    return /*#__PURE__*/React.createElement("g", {
      key: "lines-" + i
    }, series.datums.map(function (datum, i) {
      var _getRectX, _getRectY, _getWidth, _getHeight;

      var dataStyle = getDatumStatusStyle(datum, focusedDatum);
      var x = (_getRectX = getRectX(datum, primaryAxis, secondaryAxis)) != null ? _getRectX : NaN;
      var y = (_getRectY = getRectY(datum, primaryAxis, secondaryAxis)) != null ? _getRectY : NaN;
      var width = (_getWidth = getWidth(datum, primaryAxis, secondaryAxis)) != null ? _getWidth : NaN;
      var height = (_getHeight = getHeight(datum, primaryAxis, secondaryAxis)) != null ? _getHeight : NaN;
      return /*#__PURE__*/React.createElement("rect", {
        ref: function ref(el) {
          datum.element = el;
        },
        key: i,
        x: x,
        y: y,
        width: width,
        height: height,
        style: _extends({
          strokeWidth: 0
        }, style, style.rectangle, dataStyle, dataStyle.rectangle)
      });
    }));
  }));
}