"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];

exports.__esModule = true;
exports["default"] = Line;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _d3Shape = require("d3-shape");

var _react = _interopRequireDefault(require("react"));

var _Utils = require("../utils/Utils");

var _chartContext = _interopRequireDefault(require("../utils/chartContext"));

var _curveMonotone = require("../utils/curveMonotone");

//
var pathDefaultStyle = {
  strokeWidth: 2
};

function Line(_ref) {
  var _secondaryAxis$curve;

  var primaryAxis = _ref.primaryAxis,
      secondaryAxis = _ref.secondaryAxis,
      allSeries = _ref.series;

  var _useChartContext = (0, _chartContext["default"])(),
      getSeriesStatusStyle = _useChartContext.getSeriesStatusStyle,
      getDatumStatusStyle = _useChartContext.getDatumStatusStyle,
      useFocusedDatumAtom = _useChartContext.useFocusedDatumAtom,
      gridDimensions = _useChartContext.gridDimensions;

  var curve = (_secondaryAxis$curve = secondaryAxis.curve) != null ? _secondaryAxis$curve : _curveMonotone.monotoneX;

  var _useFocusedDatumAtom = useFocusedDatumAtom(),
      focusedDatum = _useFocusedDatumAtom[0];

  return /*#__PURE__*/_react["default"].createElement("g", {
    style: {
      transform: (0, _Utils.translate)(gridDimensions.gridX, gridDimensions.gridY)
    }
  }, allSeries.map(function (series, i) {
    var _line$curve;

    var style = getSeriesStatusStyle(series, focusedDatum);
    var lineStyle = (0, _extends2["default"])({}, pathDefaultStyle, style, style.line, {
      fill: 'none'
    });
    var linePath = (_line$curve = (0, _d3Shape.line)(function (datum) {
      var _getX;

      return (_getX = (0, _Utils.getX)(datum, primaryAxis, secondaryAxis)) != null ? _getX : NaN;
    }, function (datum) {
      var _getY;

      return (_getY = (0, _Utils.getY)(datum, primaryAxis, secondaryAxis)) != null ? _getY : NaN;
    }).curve(curve)(series.datums)) != null ? _line$curve : undefined;
    return /*#__PURE__*/_react["default"].createElement("g", {
      key: "lines-" + i
    }, series.datums.map(function (datum, i) {
      var _secondaryAxis$showDa;

      var dataStyle = getDatumStatusStyle(datum, focusedDatum);
      return /*#__PURE__*/_react["default"].createElement("circle", {
        key: i,
        ref: function ref(el) {
          datum.element = el;
        },
        r: 2,
        cx: (0, _Utils.getX)(datum, primaryAxis, secondaryAxis),
        cy: (0, _Utils.getY)(datum, primaryAxis, secondaryAxis),
        stroke: "rgba(33,33,33,0.5)",
        fill: "transparent",
        style: (0, _extends2["default"])({
          // @ts-ignore
          r: 2
        }, style, style.circle, dataStyle, dataStyle.circle, !((_secondaryAxis$showDa = secondaryAxis.showDatumElements) != null ? _secondaryAxis$showDa : true) ? {
          opacity: 0
        } : {})
      });
    }), /*#__PURE__*/_react["default"].createElement("path", {
      d: linePath,
      style: lineStyle
    }));
  }));
}