import { Axis, Datum, DatumFocusStatus, DatumStyles, Series, SeriesFocusStatus, SeriesStyles } from '../types';
export declare function getSeriesStatus<TDatum>(series: Series<TDatum>, focusedDatum: Datum<TDatum> | null): SeriesFocusStatus;
export declare function getDatumStatus<TDatum>(datum: Datum<TDatum>, focusedDatum: Datum<TDatum> | null): DatumFocusStatus;
export declare function materializeStyles(style?: SeriesStyles | DatumStyles, defaults?: SeriesStyles | DatumStyles): SeriesStyles | DatumStyles;
export declare function isValidPoint(d: any): boolean;
export declare function translateX(x: number): string;
export declare function translateY(y: number): string;
export declare function translate(x: number, y: number): string;
export declare function getSecondaryStart<TDatum>(datum: Datum<TDatum>, secondaryAxis: Axis<TDatum>): number;
export declare function getSecondary<TDatum>(datum: Datum<TDatum>, secondaryAxis: Axis<TDatum>): number;
export declare function getPrimary<TDatum>(datum: Datum<TDatum>, primaryAxis: Axis<TDatum>): number;
export declare function getPrimaryStart<TDatum>(datum: Datum<TDatum>, primaryAxis: Axis<TDatum>): number;
export declare function getPrimaryLength<TDatum>(_datum: Datum<TDatum>, primaryAxis: Axis<TDatum>): number;
export declare function getSecondaryLength<TDatum>(datum: Datum<TDatum>, secondaryAxis: Axis<TDatum>): number;
export declare function getX<TDatum>(datum: Datum<TDatum>, primaryAxis: Axis<TDatum>, secondaryAxis: Axis<TDatum>): number;
export declare function getXStart<TDatum>(datum: Datum<TDatum>, primaryAxis: Axis<TDatum>, secondaryAxis: Axis<TDatum>): number;
export declare function getY<TDatum>(datum: Datum<TDatum>, primaryAxis: Axis<TDatum>, secondaryAxis: Axis<TDatum>): number;
export declare function getYStart<TDatum>(datum: Datum<TDatum>, primaryAxis: Axis<TDatum>, secondaryAxis: Axis<TDatum>): number;
export declare function getRectX<TDatum>(datum: Datum<TDatum>, primaryAxis: Axis<TDatum>, secondaryAxis: Axis<TDatum>): number;
export declare function getRectY<TDatum>(datum: Datum<TDatum>, primaryAxis: Axis<TDatum>, secondaryAxis: Axis<TDatum>): number;
export declare function getWidth<TDatum>(datum: Datum<TDatum>, primaryAxis: Axis<TDatum>, secondaryAxis: Axis<TDatum>): number;
export declare function getHeight<TDatum>(datum: Datum<TDatum>, primaryAxis: Axis<TDatum>, secondaryAxis: Axis<TDatum>): number;
export declare function getTickPx<TDatum>(scale: Axis<TDatum>['scale'], value: any): number;
