(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react'), require('react-dom')) :
  typeof define === 'function' && define.amd ? define(['exports', 'react', 'react-dom'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.ReactCharts = {}, global.React, global.ReactDOM));
}(this, (function (exports, React, ReactDOM) { 'use strict';

  function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

  function _interopNamespace(e) {
    if (e && e.__esModule) return e;
    var n = Object.create(null);
    if (e) {
      Object.keys(e).forEach(function (k) {
        if (k !== 'default') {
          var d = Object.getOwnPropertyDescriptor(e, k);
          Object.defineProperty(n, k, d.get ? d : {
            enumerable: true,
            get: function () {
              return e[k];
            }
          });
        }
      });
    }
    n['default'] = e;
    return Object.freeze(n);
  }

  var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
  var React__namespace = /*#__PURE__*/_interopNamespace(React);
  var ReactDOM__default = /*#__PURE__*/_interopDefaultLegacy(ReactDOM);

  function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length) len = arr.length;

    for (var i = 0, arr2 = new Array(len); i < len; i++) {
      arr2[i] = arr[i];
    }

    return arr2;
  }

  function _unsupportedIterableToArray(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(o);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
  }

  function _createForOfIteratorHelperLoose(o, allowArrayLike) {
    var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];
    if (it) return (it = it.call(o)).next.bind(it);

    if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
      if (it) o = it;
      var i = 0;
      return function () {
        if (i >= o.length) return {
          done: true
        };
        return {
          done: false,
          value: o[i++]
        };
      };
    }

    throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  function _objectWithoutPropertiesLoose$2(source, excluded) {
    if (source == null) return {};
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;

    for (i = 0; i < sourceKeys.length; i++) {
      key = sourceKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      target[key] = source[key];
    }

    return target;
  }

  function _extends$3() {
    _extends$3 = Object.assign || function (target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i];

        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }

      return target;
    };

    return _extends$3.apply(this, arguments);
  }

  function ascending (a, b) {
    return a < b ? -1 : a > b ? 1 : a >= b ? 0 : NaN;
  }

  function bisector (f) {
    let delta = f;
    let compare = f;

    if (f.length === 1) {
      delta = (d, x) => f(d) - x;

      compare = ascendingComparator(f);
    }

    function left(a, x, lo, hi) {
      if (lo == null) lo = 0;
      if (hi == null) hi = a.length;

      while (lo < hi) {
        const mid = lo + hi >>> 1;
        if (compare(a[mid], x) < 0) lo = mid + 1;else hi = mid;
      }

      return lo;
    }

    function right(a, x, lo, hi) {
      if (lo == null) lo = 0;
      if (hi == null) hi = a.length;

      while (lo < hi) {
        const mid = lo + hi >>> 1;
        if (compare(a[mid], x) > 0) hi = mid;else lo = mid + 1;
      }

      return lo;
    }

    function center(a, x, lo, hi) {
      if (lo == null) lo = 0;
      if (hi == null) hi = a.length;
      const i = left(a, x, lo, hi - 1);
      return i > lo && delta(a[i - 1], x) > -delta(a[i], x) ? i - 1 : i;
    }

    return {
      left,
      center,
      right
    };
  }

  function ascendingComparator(f) {
    return (d, x) => ascending(f(d), x);
  }

  function number$2 (x) {
    return x === null ? NaN : +x;
  }
  function* numbers(values, valueof) {
    if (valueof === undefined) {
      for (let value of values) {
        if (value != null && (value = +value) >= value) {
          yield value;
        }
      }
    } else {
      let index = -1;

      for (let value of values) {
        if ((value = valueof(value, ++index, values)) != null && (value = +value) >= value) {
          yield value;
        }
      }
    }
  }

  const ascendingBisect = bisector(ascending);
  const bisectRight = ascendingBisect.right;
  bisector(number$2).center;

  function extent (values, valueof) {
    let min;
    let max;

    if (valueof === undefined) {
      for (const value of values) {
        if (value != null) {
          if (min === undefined) {
            if (value >= value) min = max = value;
          } else {
            if (min > value) min = value;
            if (max < value) max = value;
          }
        }
      }
    } else {
      let index = -1;

      for (let value of values) {
        if ((value = valueof(value, ++index, values)) != null) {
          if (min === undefined) {
            if (value >= value) min = max = value;
          } else {
            if (min > value) min = value;
            if (max < value) max = value;
          }
        }
      }
    }

    return [min, max];
  }

  class InternMap extends Map {
    constructor(entries, key = keyof) {
      super();
      Object.defineProperties(this, {
        _intern: {
          value: new Map()
        },
        _key: {
          value: key
        }
      });
      if (entries != null) for (const [key, value] of entries) this.set(key, value);
    }

    get(key) {
      return super.get(intern_get(this, key));
    }

    has(key) {
      return super.has(intern_get(this, key));
    }

    set(key, value) {
      return super.set(intern_set(this, key), value);
    }

    delete(key) {
      return super.delete(intern_delete(this, key));
    }

  }

  function intern_get({
    _intern,
    _key
  }, value) {
    const key = _key(value);

    return _intern.has(key) ? _intern.get(key) : value;
  }

  function intern_set({
    _intern,
    _key
  }, value) {
    const key = _key(value);

    if (_intern.has(key)) return _intern.get(key);

    _intern.set(key, value);

    return value;
  }

  function intern_delete({
    _intern,
    _key
  }, value) {
    const key = _key(value);

    if (_intern.has(key)) {
      value = _intern.get(value);

      _intern.delete(key);
    }

    return value;
  }

  function keyof(value) {
    return value !== null && typeof value === "object" ? value.valueOf() : value;
  }

  function identity$2 (x) {
    return x;
  }

  function groups(values, ...keys) {
    return nest(values, Array.from, identity$2, keys);
  }

  function nest(values, map, reduce, keys) {
    return function regroup(values, i) {
      if (i >= keys.length) return reduce(values);
      const groups = new InternMap();
      const keyof = keys[i++];
      let index = -1;

      for (const value of values) {
        const key = keyof(value, ++index, values);
        const group = groups.get(key);
        if (group) group.push(value);else groups.set(key, [value]);
      }

      for (const [key, values] of groups) {
        groups.set(key, regroup(values, i));
      }

      return map(groups);
    }(values, 0);
  }

  function permute (source, keys) {
    return Array.from(keys, key => source[key]);
  }

  function sort(values, ...F) {
    if (typeof values[Symbol.iterator] !== "function") throw new TypeError("values is not iterable");
    values = Array.from(values);
    let [f = ascending] = F;

    if (f.length === 1 || F.length > 1) {
      const index = Uint32Array.from(values, (d, i) => i);

      if (F.length > 1) {
        F = F.map(f => values.map(f));
        index.sort((i, j) => {
          for (const f of F) {
            const c = ascending(f[i], f[j]);
            if (c) return c;
          }
        });
      } else {
        f = values.map(f);
        index.sort((i, j) => ascending(f[i], f[j]));
      }

      return permute(values, index);
    }

    return values.sort(f);
  }

  var e10 = Math.sqrt(50),
      e5 = Math.sqrt(10),
      e2 = Math.sqrt(2);
  function ticks (start, stop, count) {
    var reverse,
        i = -1,
        n,
        ticks,
        step;
    stop = +stop, start = +start, count = +count;
    if (start === stop && count > 0) return [start];
    if (reverse = stop < start) n = start, start = stop, stop = n;
    if ((step = tickIncrement(start, stop, count)) === 0 || !isFinite(step)) return [];

    if (step > 0) {
      let r0 = Math.round(start / step),
          r1 = Math.round(stop / step);
      if (r0 * step < start) ++r0;
      if (r1 * step > stop) --r1;
      ticks = new Array(n = r1 - r0 + 1);

      while (++i < n) ticks[i] = (r0 + i) * step;
    } else {
      step = -step;
      let r0 = Math.round(start * step),
          r1 = Math.round(stop * step);
      if (r0 / step < start) ++r0;
      if (r1 / step > stop) --r1;
      ticks = new Array(n = r1 - r0 + 1);

      while (++i < n) ticks[i] = (r0 + i) / step;
    }

    if (reverse) ticks.reverse();
    return ticks;
  }
  function tickIncrement(start, stop, count) {
    var step = (stop - start) / Math.max(0, count),
        power = Math.floor(Math.log(step) / Math.LN10),
        error = step / Math.pow(10, power);
    return power >= 0 ? (error >= e10 ? 10 : error >= e5 ? 5 : error >= e2 ? 2 : 1) * Math.pow(10, power) : -Math.pow(10, -power) / (error >= e10 ? 10 : error >= e5 ? 5 : error >= e2 ? 2 : 1);
  }
  function tickStep(start, stop, count) {
    var step0 = Math.abs(stop - start) / Math.max(0, count),
        step1 = Math.pow(10, Math.floor(Math.log(step0) / Math.LN10)),
        error = step0 / step1;
    if (error >= e10) step1 *= 10;else if (error >= e5) step1 *= 5;else if (error >= e2) step1 *= 2;
    return stop < start ? -step1 : step1;
  }

  function max(values, valueof) {
    let max;

    if (valueof === undefined) {
      for (const value of values) {
        if (value != null && (max < value || max === undefined && value >= value)) {
          max = value;
        }
      }
    } else {
      let index = -1;

      for (let value of values) {
        if ((value = valueof(value, ++index, values)) != null && (max < value || max === undefined && value >= value)) {
          max = value;
        }
      }
    }

    return max;
  }

  function min(values, valueof) {
    let min;

    if (valueof === undefined) {
      for (const value of values) {
        if (value != null && (min > value || min === undefined && value >= value)) {
          min = value;
        }
      }
    } else {
      let index = -1;

      for (let value of values) {
        if ((value = valueof(value, ++index, values)) != null && (min > value || min === undefined && value >= value)) {
          min = value;
        }
      }
    }

    return min;
  }

  // ISC license, Copyright 2018 Vladimir Agafonkin.

  function quickselect(array, k, left = 0, right = array.length - 1, compare = ascending) {
    while (right > left) {
      if (right - left > 600) {
        const n = right - left + 1;
        const m = k - left + 1;
        const z = Math.log(n);
        const s = 0.5 * Math.exp(2 * z / 3);
        const sd = 0.5 * Math.sqrt(z * s * (n - s) / n) * (m - n / 2 < 0 ? -1 : 1);
        const newLeft = Math.max(left, Math.floor(k - m * s / n + sd));
        const newRight = Math.min(right, Math.floor(k + (n - m) * s / n + sd));
        quickselect(array, k, newLeft, newRight, compare);
      }

      const t = array[k];
      let i = left;
      let j = right;
      swap(array, left, k);
      if (compare(array[right], t) > 0) swap(array, left, right);

      while (i < j) {
        swap(array, i, j), ++i, --j;

        while (compare(array[i], t) < 0) ++i;

        while (compare(array[j], t) > 0) --j;
      }

      if (compare(array[left], t) === 0) swap(array, left, j);else ++j, swap(array, j, right);
      if (j <= k) left = j + 1;
      if (k <= j) right = j - 1;
    }

    return array;
  }

  function swap(array, i, j) {
    const t = array[i];
    array[i] = array[j];
    array[j] = t;
  }

  function quantile(values, p, valueof) {
    values = Float64Array.from(numbers(values, valueof));
    if (!(n = values.length)) return;
    if ((p = +p) <= 0 || n < 2) return min(values);
    if (p >= 1) return max(values);
    var n,
        i = (n - 1) * p,
        i0 = Math.floor(i),
        value0 = max(quickselect(values, i0).subarray(0, i0 + 1)),
        value1 = min(values.subarray(i0 + 1));
    return value0 + (value1 - value0) * (i - i0);
  }

  function median (values, valueof) {
    return quantile(values, 0.5, valueof);
  }

  function d3Range (start, stop, step) {
    start = +start, stop = +stop, step = (n = arguments.length) < 2 ? (stop = start, start = 0, 1) : n < 3 ? 1 : +step;
    var i = -1,
        n = Math.max(0, Math.ceil((stop - start) / step)) | 0,
        range = new Array(n);

    while (++i < n) {
      range[i] = start + i * step;
    }

    return range;
  }

  function sum(values, valueof) {
    let sum = 0;

    if (valueof === undefined) {
      for (let value of values) {
        if (value = +value) {
          sum += value;
        }
      }
    } else {
      let index = -1;

      for (let value of values) {
        if (value = +valueof(value, ++index, values)) {
          sum += value;
        }
      }
    }

    return sum;
  }

  const pi = Math.PI,
        tau = 2 * pi,
        epsilon = 1e-6,
        tauEpsilon = tau - epsilon;

  function Path() {
    this._x0 = this._y0 = // start of current subpath
    this._x1 = this._y1 = null; // end of current subpath

    this._ = "";
  }

  function path() {
    return new Path();
  }

  Path.prototype = path.prototype = {
    constructor: Path,
    moveTo: function (x, y) {
      this._ += "M" + (this._x0 = this._x1 = +x) + "," + (this._y0 = this._y1 = +y);
    },
    closePath: function () {
      if (this._x1 !== null) {
        this._x1 = this._x0, this._y1 = this._y0;
        this._ += "Z";
      }
    },
    lineTo: function (x, y) {
      this._ += "L" + (this._x1 = +x) + "," + (this._y1 = +y);
    },
    quadraticCurveTo: function (x1, y1, x, y) {
      this._ += "Q" + +x1 + "," + +y1 + "," + (this._x1 = +x) + "," + (this._y1 = +y);
    },
    bezierCurveTo: function (x1, y1, x2, y2, x, y) {
      this._ += "C" + +x1 + "," + +y1 + "," + +x2 + "," + +y2 + "," + (this._x1 = +x) + "," + (this._y1 = +y);
    },
    arcTo: function (x1, y1, x2, y2, r) {
      x1 = +x1, y1 = +y1, x2 = +x2, y2 = +y2, r = +r;
      var x0 = this._x1,
          y0 = this._y1,
          x21 = x2 - x1,
          y21 = y2 - y1,
          x01 = x0 - x1,
          y01 = y0 - y1,
          l01_2 = x01 * x01 + y01 * y01; // Is the radius negative? Error.

      if (r < 0) throw new Error("negative radius: " + r); // Is this path empty? Move to (x1,y1).

      if (this._x1 === null) {
        this._ += "M" + (this._x1 = x1) + "," + (this._y1 = y1);
      } // Or, is (x1,y1) coincident with (x0,y0)? Do nothing.
      else if (!(l01_2 > epsilon)) ; // Or, are (x0,y0), (x1,y1) and (x2,y2) collinear?
        // Equivalently, is (x1,y1) coincident with (x2,y2)?
        // Or, is the radius zero? Line to (x1,y1).
        else if (!(Math.abs(y01 * x21 - y21 * x01) > epsilon) || !r) {
            this._ += "L" + (this._x1 = x1) + "," + (this._y1 = y1);
          } // Otherwise, draw an arc!
          else {
              var x20 = x2 - x0,
                  y20 = y2 - y0,
                  l21_2 = x21 * x21 + y21 * y21,
                  l20_2 = x20 * x20 + y20 * y20,
                  l21 = Math.sqrt(l21_2),
                  l01 = Math.sqrt(l01_2),
                  l = r * Math.tan((pi - Math.acos((l21_2 + l01_2 - l20_2) / (2 * l21 * l01))) / 2),
                  t01 = l / l01,
                  t21 = l / l21; // If the start tangent is not coincident with (x0,y0), line to.

              if (Math.abs(t01 - 1) > epsilon) {
                this._ += "L" + (x1 + t01 * x01) + "," + (y1 + t01 * y01);
              }

              this._ += "A" + r + "," + r + ",0,0," + +(y01 * x20 > x01 * y20) + "," + (this._x1 = x1 + t21 * x21) + "," + (this._y1 = y1 + t21 * y21);
            }
    },
    arc: function (x, y, r, a0, a1, ccw) {
      x = +x, y = +y, r = +r, ccw = !!ccw;
      var dx = r * Math.cos(a0),
          dy = r * Math.sin(a0),
          x0 = x + dx,
          y0 = y + dy,
          cw = 1 ^ ccw,
          da = ccw ? a0 - a1 : a1 - a0; // Is the radius negative? Error.

      if (r < 0) throw new Error("negative radius: " + r); // Is this path empty? Move to (x0,y0).

      if (this._x1 === null) {
        this._ += "M" + x0 + "," + y0;
      } // Or, is (x0,y0) not coincident with the previous point? Line to (x0,y0).
      else if (Math.abs(this._x1 - x0) > epsilon || Math.abs(this._y1 - y0) > epsilon) {
          this._ += "L" + x0 + "," + y0;
        } // Is this arc empty? We’re done.


      if (!r) return; // Does the angle go the wrong way? Flip the direction.

      if (da < 0) da = da % tau + tau; // Is this a complete circle? Draw two arcs to complete the circle.

      if (da > tauEpsilon) {
        this._ += "A" + r + "," + r + ",0,1," + cw + "," + (x - dx) + "," + (y - dy) + "A" + r + "," + r + ",0,1," + cw + "," + (this._x1 = x0) + "," + (this._y1 = y0);
      } // Is this arc non-empty? Draw an arc!
      else if (da > epsilon) {
          this._ += "A" + r + "," + r + ",0," + +(da >= pi) + "," + cw + "," + (this._x1 = x + r * Math.cos(a1)) + "," + (this._y1 = y + r * Math.sin(a1));
        }
    },
    rect: function (x, y, w, h) {
      this._ += "M" + (this._x0 = this._x1 = +x) + "," + (this._y0 = this._y1 = +y) + "h" + +w + "v" + +h + "h" + -w + "Z";
    },
    toString: function () {
      return this._;
    }
  };

  function constant$1 (x) {
    return function constant() {
      return x;
    };
  }

  function array (x) {
    return typeof x === "object" && "length" in x ? x // Array, TypedArray, NodeList, array-like
    : Array.from(x); // Map, Set, iterable, string, or anything else
  }

  function Linear(context) {
    this._context = context;
  }

  Linear.prototype = {
    areaStart: function () {
      this._line = 0;
    },
    areaEnd: function () {
      this._line = NaN;
    },
    lineStart: function () {
      this._point = 0;
    },
    lineEnd: function () {
      if (this._line || this._line !== 0 && this._point === 1) this._context.closePath();
      this._line = 1 - this._line;
    },
    point: function (x, y) {
      x = +x, y = +y;

      switch (this._point) {
        case 0:
          this._point = 1;
          this._line ? this._context.lineTo(x, y) : this._context.moveTo(x, y);
          break;

        case 1:
          this._point = 2;
        // proceed

        default:
          this._context.lineTo(x, y);

          break;
      }
    }
  };
  function curveLinear (context) {
    return new Linear(context);
  }

  function x(p) {
    return p[0];
  }
  function y(p) {
    return p[1];
  }

  function line (x$1, y$1) {
    var defined = constant$1(true),
        context = null,
        curve = curveLinear,
        output = null;
    x$1 = typeof x$1 === "function" ? x$1 : x$1 === undefined ? x : constant$1(x$1);
    y$1 = typeof y$1 === "function" ? y$1 : y$1 === undefined ? y : constant$1(y$1);

    function line(data) {
      var i,
          n = (data = array(data)).length,
          d,
          defined0 = false,
          buffer;
      if (context == null) output = curve(buffer = path());

      for (i = 0; i <= n; ++i) {
        if (!(i < n && defined(d = data[i], i, data)) === defined0) {
          if (defined0 = !defined0) output.lineStart();else output.lineEnd();
        }

        if (defined0) output.point(+x$1(d, i, data), +y$1(d, i, data));
      }

      if (buffer) return output = null, buffer + "" || null;
    }

    line.x = function (_) {
      return arguments.length ? (x$1 = typeof _ === "function" ? _ : constant$1(+_), line) : x$1;
    };

    line.y = function (_) {
      return arguments.length ? (y$1 = typeof _ === "function" ? _ : constant$1(+_), line) : y$1;
    };

    line.defined = function (_) {
      return arguments.length ? (defined = typeof _ === "function" ? _ : constant$1(!!_), line) : defined;
    };

    line.curve = function (_) {
      return arguments.length ? (curve = _, context != null && (output = curve(context)), line) : curve;
    };

    line.context = function (_) {
      return arguments.length ? (_ == null ? context = output = null : output = curve(context = _), line) : context;
    };

    return line;
  }

  function area (x0, y0, y1) {
    var x1 = null,
        defined = constant$1(true),
        context = null,
        curve = curveLinear,
        output = null;
    x0 = typeof x0 === "function" ? x0 : x0 === undefined ? x : constant$1(+x0);
    y0 = typeof y0 === "function" ? y0 : y0 === undefined ? constant$1(0) : constant$1(+y0);
    y1 = typeof y1 === "function" ? y1 : y1 === undefined ? y : constant$1(+y1);

    function area(data) {
      var i,
          j,
          k,
          n = (data = array(data)).length,
          d,
          defined0 = false,
          buffer,
          x0z = new Array(n),
          y0z = new Array(n);
      if (context == null) output = curve(buffer = path());

      for (i = 0; i <= n; ++i) {
        if (!(i < n && defined(d = data[i], i, data)) === defined0) {
          if (defined0 = !defined0) {
            j = i;
            output.areaStart();
            output.lineStart();
          } else {
            output.lineEnd();
            output.lineStart();

            for (k = i - 1; k >= j; --k) {
              output.point(x0z[k], y0z[k]);
            }

            output.lineEnd();
            output.areaEnd();
          }
        }

        if (defined0) {
          x0z[i] = +x0(d, i, data), y0z[i] = +y0(d, i, data);
          output.point(x1 ? +x1(d, i, data) : x0z[i], y1 ? +y1(d, i, data) : y0z[i]);
        }
      }

      if (buffer) return output = null, buffer + "" || null;
    }

    function arealine() {
      return line().defined(defined).curve(curve).context(context);
    }

    area.x = function (_) {
      return arguments.length ? (x0 = typeof _ === "function" ? _ : constant$1(+_), x1 = null, area) : x0;
    };

    area.x0 = function (_) {
      return arguments.length ? (x0 = typeof _ === "function" ? _ : constant$1(+_), area) : x0;
    };

    area.x1 = function (_) {
      return arguments.length ? (x1 = _ == null ? null : typeof _ === "function" ? _ : constant$1(+_), area) : x1;
    };

    area.y = function (_) {
      return arguments.length ? (y0 = typeof _ === "function" ? _ : constant$1(+_), y1 = null, area) : y0;
    };

    area.y0 = function (_) {
      return arguments.length ? (y0 = typeof _ === "function" ? _ : constant$1(+_), area) : y0;
    };

    area.y1 = function (_) {
      return arguments.length ? (y1 = _ == null ? null : typeof _ === "function" ? _ : constant$1(+_), area) : y1;
    };

    area.lineX0 = area.lineY0 = function () {
      return arealine().x(x0).y(y0);
    };

    area.lineY1 = function () {
      return arealine().x(x0).y(y1);
    };

    area.lineX1 = function () {
      return arealine().x(x1).y(y0);
    };

    area.defined = function (_) {
      return arguments.length ? (defined = typeof _ === "function" ? _ : constant$1(!!_), area) : defined;
    };

    area.curve = function (_) {
      return arguments.length ? (curve = _, context != null && (output = curve(context)), area) : curve;
    };

    area.context = function (_) {
      return arguments.length ? (_ == null ? context = output = null : output = curve(context = _), area) : context;
    };

    return area;
  }

  function stackOffsetNone (series, order) {
    if (!((n = series.length) > 1)) return;

    for (var i = 1, j, s0, s1 = series[order[0]], n, m = s1.length; i < n; ++i) {
      s0 = s1, s1 = series[order[i]];

      for (j = 0; j < m; ++j) {
        s1[j][1] += s1[j][0] = isNaN(s0[j][1]) ? s0[j][0] : s0[j][1];
      }
    }
  }

  function none (series) {
    var n = series.length,
        o = new Array(n);

    while (--n >= 0) o[n] = n;

    return o;
  }

  function stackValue(d, key) {
    return d[key];
  }

  function stackSeries(key) {
    const series = [];
    series.key = key;
    return series;
  }

  function stack () {
    var keys = constant$1([]),
        order = none,
        offset = stackOffsetNone,
        value = stackValue;

    function stack(data) {
      var sz = Array.from(keys.apply(this, arguments), stackSeries),
          i,
          n = sz.length,
          j = -1,
          oz;

      for (const d of data) {
        for (i = 0, ++j; i < n; ++i) {
          (sz[i][j] = [0, +value(d, sz[i].key, j, data)]).data = d;
        }
      }

      for (i = 0, oz = array(order(sz)); i < n; ++i) {
        sz[oz[i]].index = i;
      }

      offset(sz, oz);
      return sz;
    }

    stack.keys = function (_) {
      return arguments.length ? (keys = typeof _ === "function" ? _ : constant$1(Array.from(_)), stack) : keys;
    };

    stack.value = function (_) {
      return arguments.length ? (value = typeof _ === "function" ? _ : constant$1(+_), stack) : value;
    };

    stack.order = function (_) {
      return arguments.length ? (order = _ == null ? none : typeof _ === "function" ? _ : constant$1(Array.from(_)), stack) : order;
    };

    stack.offset = function (_) {
      return arguments.length ? (offset = _ == null ? stackOffsetNone : _, stack) : offset;
    };

    return stack;
  }

  var __defProp = Object.defineProperty;
  var __defProps = Object.defineProperties;
  var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
  var __getOwnPropSymbols = Object.getOwnPropertySymbols;
  var __hasOwnProp = Object.prototype.hasOwnProperty;
  var __propIsEnum = Object.prototype.propertyIsEnumerable;

  var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, {
    enumerable: true,
    configurable: true,
    writable: true,
    value
  }) : obj[key] = value;

  var __spreadValues = (a, b) => {
    for (var prop in b || (b = {})) if (__hasOwnProp.call(b, prop)) __defNormalProp(a, prop, b[prop]);

    if (__getOwnPropSymbols) for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop)) __defNormalProp(a, prop, b[prop]);
    }
    return a;
  };

  var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));

  const hasInitialValue = atom => "init" in atom;

  const IS_EQUAL_PROMISE = Symbol();
  const INTERRUPT_PROMISE = Symbol();

  const isInterruptablePromise = promise => !!promise[INTERRUPT_PROMISE];

  const createInterruptablePromise = promise => {
    let interrupt;
    const interruptablePromise = new Promise((resolve, reject) => {
      interrupt = resolve;
      promise.then(resolve, reject);
    });

    interruptablePromise[IS_EQUAL_PROMISE] = p => p === interruptablePromise || p === promise;

    interruptablePromise[INTERRUPT_PROMISE] = interrupt;
    return interruptablePromise;
  };

  const createState = (initialValues, stateListener) => {
    const state = {
      l: stateListener,
      v: 0,
      a: new WeakMap(),
      m: new WeakMap(),
      p: new Map()
    };

    if (initialValues) {
      for (const [atom, value] of initialValues) {
        const atomState = {
          v: value,
          r: 0,
          d: new Map()
        };

        if (typeof process === "object" && process.env.NODE_ENV !== "production") {
          Object.freeze(atomState);

          if (!hasInitialValue(atom)) {
            console.warn("Found initial value for derived atom which can cause unexpected behavior", atom);
          }
        }

        state.a.set(atom, atomState);
      }
    }

    return state;
  };

  const getAtomState = (state, atom) => state.a.get(atom);

  const wipAtomState = (state, atom, dependencies) => {
    const atomState = getAtomState(state, atom);

    const nextAtomState = __spreadProps(__spreadValues({
      r: 0
    }, atomState), {
      d: dependencies ? new Map(Array.from(dependencies).map(a => {
        var _a, _b;

        return [a, (_b = (_a = getAtomState(state, a)) == null ? void 0 : _a.r) != null ? _b : 0];
      })) : (atomState == null ? void 0 : atomState.d) || new Map()
    });

    return [nextAtomState, (atomState == null ? void 0 : atomState.d) || new Map()];
  };

  const setAtomValue = (state, atom, value, dependencies, promise) => {
    var _a, _b;

    const [atomState, prevDependencies] = wipAtomState(state, atom, dependencies);

    if (promise && !((_a = atomState.p) == null ? void 0 : _a[IS_EQUAL_PROMISE](promise))) {
      return;
    }

    (_b = atomState.c) == null ? void 0 : _b.call(atomState);
    delete atomState.e;
    delete atomState.p;
    delete atomState.c;
    delete atomState.i;

    if (!("v" in atomState) || !Object.is(atomState.v, value)) {
      atomState.v = value;
      ++atomState.r;
    }

    commitAtomState(state, atom, atomState, dependencies && prevDependencies);
  };

  const setAtomReadError = (state, atom, error, dependencies, promise) => {
    var _a, _b;

    const [atomState, prevDependencies] = wipAtomState(state, atom, dependencies);

    if (promise && !((_a = atomState.p) == null ? void 0 : _a[IS_EQUAL_PROMISE](promise))) {
      return;
    }

    (_b = atomState.c) == null ? void 0 : _b.call(atomState);
    delete atomState.p;
    delete atomState.c;
    delete atomState.i;
    atomState.e = error;
    commitAtomState(state, atom, atomState, prevDependencies);
  };

  const setAtomReadPromise = (state, atom, promise, dependencies) => {
    var _a, _b;

    const [atomState, prevDependencies] = wipAtomState(state, atom, dependencies);

    if ((_a = atomState.p) == null ? void 0 : _a[IS_EQUAL_PROMISE](promise)) {
      return;
    }

    (_b = atomState.c) == null ? void 0 : _b.call(atomState);

    if (isInterruptablePromise(promise)) {
      atomState.p = promise;
      delete atomState.c;
    } else {
      const interruptablePromise = createInterruptablePromise(promise);
      atomState.p = interruptablePromise;
      atomState.c = interruptablePromise[INTERRUPT_PROMISE];
    }

    commitAtomState(state, atom, atomState, prevDependencies);
  };

  const setAtomInvalidated = (state, atom) => {
    const [atomState] = wipAtomState(state, atom);
    atomState.i = atomState.r;
    commitAtomState(state, atom, atomState);
  };

  const setAtomWritePromise = (state, atom, promise) => {
    const [atomState] = wipAtomState(state, atom);

    if (promise) {
      atomState.w = promise;
    } else {
      delete atomState.w;
    }

    commitAtomState(state, atom, atomState);
  };

  const scheduleReadAtomState = (state, atom, promise) => {
    promise.finally(() => {
      readAtomState(state, atom, true);
    });
  };

  const readAtomState = (state, atom, force) => {
    if (!force) {
      const atomState = getAtomState(state, atom);

      if (atomState) {
        atomState.d.forEach((_, a) => {
          if (a !== atom) {
            const aState = getAtomState(state, a);

            if (aState && !aState.e && !aState.p && aState.r === aState.i) {
              readAtomState(state, a, true);
            }
          }
        });

        if (Array.from(atomState.d.entries()).every(([a, r]) => {
          const aState = getAtomState(state, a);
          return aState && !aState.e && !aState.p && aState.r !== aState.i && aState.r === r;
        })) {
          return atomState;
        }
      }
    }

    let error;
    let promise;
    let value;
    const dependencies = new Set();

    try {
      const promiseOrValue = atom.read(a => {
        dependencies.add(a);

        if (a !== atom) {
          const aState2 = readAtomState(state, a);

          if (aState2.e) {
            throw aState2.e;
          }

          if (aState2.p) {
            throw aState2.p;
          }

          return aState2.v;
        }

        const aState = getAtomState(state, a);

        if (aState) {
          if (aState.e) {
            throw aState.e;
          }

          if (aState.p) {
            throw aState.p;
          }

          return aState.v;
        }

        if (hasInitialValue(a)) {
          return a.init;
        }

        throw new Error("no atom init");
      });

      if (promiseOrValue instanceof Promise) {
        promise = promiseOrValue.then(value2 => {
          setAtomValue(state, atom, value2, dependencies, promise);
          flushPending(state);
        }).catch(e => {
          if (e instanceof Promise) {
            scheduleReadAtomState(state, atom, e);
            return e;
          }

          setAtomReadError(state, atom, e instanceof Error ? e : new Error(e), dependencies, promise);
          flushPending(state);
        });
      } else {
        value = promiseOrValue;
      }
    } catch (errorOrPromise) {
      if (errorOrPromise instanceof Promise) {
        promise = errorOrPromise;
      } else if (errorOrPromise instanceof Error) {
        error = errorOrPromise;
      } else {
        error = new Error(errorOrPromise);
      }
    }

    if (error) {
      setAtomReadError(state, atom, error, dependencies);
    } else if (promise) {
      setAtomReadPromise(state, atom, promise, dependencies);
    } else {
      setAtomValue(state, atom, value, dependencies);
    }

    return getAtomState(state, atom);
  };

  const readAtom = (state, readingAtom) => {
    const atomState = readAtomState(state, readingAtom);
    return atomState;
  };

  const addAtom = (state, addingAtom) => {
    let mounted = state.m.get(addingAtom);

    if (!mounted) {
      mounted = mountAtom(state, addingAtom);
    }

    flushPending(state);
    return mounted;
  };

  const canUnmountAtom = (atom, mounted) => !mounted.l.size && (!mounted.d.size || mounted.d.size === 1 && mounted.d.has(atom));

  const delAtom = (state, deletingAtom) => {
    const mounted = state.m.get(deletingAtom);

    if (mounted && canUnmountAtom(deletingAtom, mounted)) {
      unmountAtom(state, deletingAtom);
    }

    flushPending(state);
  };

  const invalidateDependents = (state, atom) => {
    const mounted = state.m.get(atom);
    mounted == null ? void 0 : mounted.d.forEach(dependent => {
      if (dependent === atom) {
        return;
      }

      setAtomInvalidated(state, dependent);
      invalidateDependents(state, dependent);
    });
  };

  const writeAtomState = (state, atom, update) => {
    var _a;

    const writePromise = (_a = getAtomState(state, atom)) == null ? void 0 : _a.w;

    if (writePromise) {
      writePromise.then(() => {
        writeAtomState(state, atom, update);
        flushPending(state);
      });
      return;
    }

    const writeGetter = (a, unstable_promise = false) => {
      const aState = readAtomState(state, a);

      if (aState.e) {
        throw aState.e;
      }

      if (aState.p) {
        if (typeof process === "object" && process.env.NODE_ENV !== "production") {
          if (unstable_promise) {
            console.info("promise option in getter is an experimental feature.", a);
          } else {
            console.warn("Reading pending atom state in write operation. We throw a promise for now.", a);
          }
        }

        if (unstable_promise) {
          return aState.p.then(() => writeGetter(a, unstable_promise));
        }

        throw aState.p;
      }

      if ("v" in aState) {
        return aState.v;
      }

      if (typeof process === "object" && process.env.NODE_ENV !== "production") {
        console.warn("[Bug] no value found while reading atom in write operation. This is probably a bug.", a);
      }

      throw new Error("no value found");
    };

    const promiseOrVoid = atom.write(writeGetter, (a, v) => {
      if (a === atom) {
        if (!hasInitialValue(a)) {
          throw new Error("no atom init");
        }

        if (v instanceof Promise) {
          const promise = v.then(resolvedValue => {
            setAtomValue(state, a, resolvedValue);
            invalidateDependents(state, a);
            flushPending(state);
          }).catch(e => {
            setAtomReadError(state, atom, e instanceof Error ? e : new Error(e));
            flushPending(state);
          });
          setAtomReadPromise(state, atom, promise);
        } else {
          setAtomValue(state, a, v);
        }

        invalidateDependents(state, a);
      } else {
        writeAtomState(state, a, v);
      }

      flushPending(state);
    }, update);

    if (promiseOrVoid instanceof Promise) {
      const promise = promiseOrVoid.finally(() => {
        setAtomWritePromise(state, atom);
        flushPending(state);
      });
      setAtomWritePromise(state, atom, promise);
    }
  };

  const writeAtom = (state, writingAtom, update) => {
    writeAtomState(state, writingAtom, update);
    flushPending(state);
  };

  const isActuallyWritableAtom = atom => !!atom.write;

  const mountAtom = (state, atom, initialDependent) => {
    const atomState = readAtomState(state, atom);
    atomState.d.forEach((_, a) => {
      if (a !== atom) {
        const aMounted = state.m.get(a);

        if (aMounted) {
          aMounted.d.add(atom);
        } else {
          mountAtom(state, a, atom);
        }
      }
    });
    const mounted = {
      d: new Set(initialDependent && [initialDependent]),
      l: new Set(),
      u: void 0
    };
    state.m.set(atom, mounted);

    if (isActuallyWritableAtom(atom) && atom.onMount) {
      const setAtom = update => writeAtom(state, atom, update);

      mounted.u = atom.onMount(setAtom);
    }

    return mounted;
  };

  const unmountAtom = (state, atom) => {
    var _a;

    const onUnmount = (_a = state.m.get(atom)) == null ? void 0 : _a.u;

    if (onUnmount) {
      onUnmount();
    }

    state.m.delete(atom);
    const atomState = getAtomState(state, atom);

    if (atomState) {
      atomState.d.forEach((_, a) => {
        if (a !== atom) {
          const mounted = state.m.get(a);

          if (mounted) {
            mounted.d.delete(atom);

            if (canUnmountAtom(a, mounted)) {
              unmountAtom(state, a);
            }
          }
        }
      });
    } else if (typeof process === "object" && process.env.NODE_ENV !== "production") {
      console.warn("[Bug] could not find atom state to unmount", atom);
    }
  };

  const mountDependencies = (state, atom, atomState, prevDependencies) => {
    const dependencies = new Set(atomState.d.keys());
    prevDependencies.forEach((_, a) => {
      if (dependencies.has(a)) {
        dependencies.delete(a);
        return;
      }

      const mounted = state.m.get(a);

      if (mounted) {
        mounted.d.delete(atom);

        if (canUnmountAtom(a, mounted)) {
          unmountAtom(state, a);
        }
      }
    });
    dependencies.forEach(a => {
      const mounted = state.m.get(a);

      if (mounted) {
        const dependents = mounted.d;
        dependents.add(atom);
      } else {
        mountAtom(state, a, atom);
      }
    });
  };

  const commitAtomState = (state, atom, atomState, prevDependencies) => {
    if (typeof process === "object" && process.env.NODE_ENV !== "production") {
      Object.freeze(atomState);
    }

    const isNewAtom = !state.a.has(atom);
    state.a.set(atom, atomState);

    if (state.l) {
      state.l(atom, isNewAtom);
    }

    ++state.v;

    if (!state.p.has(atom)) {
      state.p.set(atom, prevDependencies);
    }
  };

  const flushPending = state => {
    const pending = Array.from(state.p);
    state.p.clear();
    pending.forEach(([atom, prevDependencies]) => {
      const atomState = getAtomState(state, atom);

      if (atomState) {
        if (prevDependencies) {
          mountDependencies(state, atom, atomState, prevDependencies);
        }
      } else if (typeof process === "object" && process.env.NODE_ENV !== "production") {
        console.warn("[Bug] atom state not found in flush", atom);
      }

      const mounted = state.m.get(atom);
      mounted == null ? void 0 : mounted.l.forEach(listener => listener());
    });
  };

  const subscribeAtom = (state, atom, callback) => {
    const mounted = addAtom(state, atom);
    const listeners = mounted.l;
    listeners.add(callback);
    return () => {
      listeners.delete(callback);
      delAtom(state, atom);
    };
  };

  const restoreAtoms = (state, values) => {
    for (const [atom, value] of values) {
      if (hasInitialValue(atom)) {
        setAtomValue(state, atom, value);
        invalidateDependents(state, atom);
      }
    }

    flushPending(state);
  };

  const TARGET = Symbol();
  const GET_VERSION = Symbol();

  const createMutableSource = (target, getVersion) => ({
    [TARGET]: target,
    [GET_VERSION]: getVersion
  });

  const useMutableSource = (source, getSnapshot, subscribe) => {
    const lastVersion = React.useRef(0);
    const currentVersion = source[GET_VERSION](source[TARGET]);
    const [state, setState] = React.useState(() => [source, getSnapshot, subscribe, currentVersion, getSnapshot(source[TARGET])]);
    let currentSnapshot = state[4];

    if (state[0] !== source || state[1] !== getSnapshot || state[2] !== subscribe) {
      currentSnapshot = getSnapshot(source[TARGET]);
      setState([source, getSnapshot, subscribe, currentVersion, currentSnapshot]);
    } else if (currentVersion !== state[3] && currentVersion !== lastVersion.current) {
      currentSnapshot = getSnapshot(source[TARGET]);

      if (!Object.is(currentSnapshot, state[4])) {
        setState([source, getSnapshot, subscribe, currentVersion, currentSnapshot]);
      }
    }

    React.useEffect(() => {
      let didUnsubscribe = false;

      const checkForUpdates = () => {
        if (didUnsubscribe) {
          return;
        }

        try {
          const nextSnapshot = getSnapshot(source[TARGET]);
          const nextVersion = source[GET_VERSION](source[TARGET]);
          lastVersion.current = nextVersion;
          setState(prev => {
            if (prev[0] !== source || prev[1] !== getSnapshot || prev[2] !== subscribe) {
              return prev;
            }

            if (Object.is(prev[4], nextSnapshot)) {
              return prev;
            }

            return [prev[0], prev[1], prev[2], nextVersion, nextSnapshot];
          });
        } catch (e) {
          setState(prev => [...prev]);
        }
      };

      const unsubscribe = subscribe(source[TARGET], checkForUpdates);
      checkForUpdates();
      return () => {
        didUnsubscribe = true;
        unsubscribe();
      };
    }, [source, getSnapshot, subscribe]);
    return currentSnapshot;
  };

  const createStoreForProduction = initialValues => {
    const state = createState(initialValues);
    const stateMutableSource = createMutableSource(state, () => state.v);

    const commitCallback = () => flushPending(state);

    const updateAtom = (atom, update) => writeAtom(state, atom, update);

    return [stateMutableSource, updateAtom, commitCallback];
  };

  const createStoreForDevelopment = initialValues => {
    const stateListener = (updatedAtom, isNewAtom) => {
      ++debugStore.version;

      if (isNewAtom) {
        debugStore.atoms = [...debugStore.atoms, updatedAtom];
      }

      Promise.resolve().then(() => {
        debugStore.listeners.forEach(listener => listener());
      });
    };

    const state = createState(initialValues, stateListener);
    const stateMutableSource = createMutableSource(state, () => state.v);

    const commitCallback = () => flushPending(state);

    const updateAtom = (atom, update) => writeAtom(state, atom, update);

    const debugStore = {
      version: 0,
      atoms: Array.from(initialValues != null ? initialValues : []).map(([a]) => a),
      state,
      listeners: new Set()
    };
    const debugMutableSource = createMutableSource(debugStore, () => debugStore.version);

    const restore = values => restoreAtoms(state, values);

    return [stateMutableSource, updateAtom, commitCallback, debugMutableSource, restore];
  };

  const createStore = typeof process === "object" && process.env.NODE_ENV !== "production" ? createStoreForDevelopment : createStoreForProduction;
  const StoreContextMap = new Map();

  const getStoreContext = scope => {
    if (!StoreContextMap.has(scope)) {
      StoreContextMap.set(scope, React.createContext(createStore()));
    }

    return StoreContextMap.get(scope);
  };

  let keyCount = 0;

  function atom(read, write) {
    const key = `atom${++keyCount}`;
    const config = {
      toString: () => key
    };

    if (typeof read === "function") {
      config.read = read;
    } else {
      config.init = read;

      config.read = get => get(config);

      config.write = (get, set, update) => {
        set(config, typeof update === "function" ? update(get(config)) : update);
      };
    }

    if (write) {
      config.write = write;
    }

    return config;
  }

  const isWritable = atom => !!atom.write;

  function useAtom(atom) {
    const getAtomValue = React.useCallback(state => {
      const atomState = readAtom(state, atom);

      if (atomState.e) {
        throw atomState.e;
      }

      if (atomState.p) {
        throw atomState.p;
      }

      if (atomState.w) {
        throw atomState.w;
      }

      if ("v" in atomState) {
        return atomState.v;
      }

      throw new Error("no atom value");
    }, [atom]);
    const subscribe = React.useCallback((state, callback) => subscribeAtom(state, atom, callback), [atom]);
    const StoreContext = getStoreContext(atom.scope);
    const [mutableSource, updateAtom, commitCallback] = React.useContext(StoreContext);
    const value = useMutableSource(mutableSource, getAtomValue, subscribe);
    React.useEffect(() => {
      commitCallback();
    });
    const setAtom = React.useCallback(update => {
      if (isWritable(atom)) {
        updateAtom(atom, update);
      } else {
        throw new Error("not writable atom");
      }
    }, [updateAtom, atom]);
    React.useDebugValue(value);
    return [value, setAtom];
  }

  function useGetLatest(obj) {
    var ref = React__default['default'].useRef(obj);
    var getterRef = React__default['default'].useRef();
    ref.current = obj;

    if (!getterRef.current) {
      getterRef.current = function () {
        return ref.current;
      };
    }

    return getterRef.current;
  }

  var useIsomorphicLayoutEffect = typeof window !== 'undefined' ? React__default['default'].useLayoutEffect : React__default['default'].useEffect;

  function getSeriesStatus(series, focusedDatum) {
    if ((focusedDatum == null ? void 0 : focusedDatum.seriesId) === series.id) {
      return 'focused';
    }

    return 'none';
  }
  function getDatumStatus(datum, focusedDatum) {
    var _datum$group;

    if (datum === focusedDatum) {
      return 'focused';
    }

    if ((_datum$group = datum.group) != null && _datum$group.some(function (groupDatum) {
      groupDatum.seriesId === (focusedDatum == null ? void 0 : focusedDatum.seriesId) && groupDatum.index === (focusedDatum == null ? void 0 : focusedDatum.index);
    })) {
      return 'groupFocused';
    }

    return 'none';
  }

  function normalizeColor$1(style, defaults) {
    return _extends$3({}, style, {
      stroke: style.stroke || style.color || defaults.stroke || defaults.color,
      fill: style.fill || style.color || defaults.fill || defaults.color
    });
  }

  var elementTypes = ['area', 'line', 'rectangle', 'circle'];
  function materializeStyles(style, defaults) {
    if (style === void 0) {
      style = {};
    }

    if (defaults === void 0) {
      defaults = {};
    }

    style = normalizeColor$1(style, defaults);

    for (var i = 0; i < elementTypes.length; i++) {
      var type = elementTypes[i];

      if (style[type] && defaults[type]) {
        style[type] = materializeStyles(style[type], defaults);
      }
    }

    return style;
  }
  function translate(x, y) {
    return "translate3d(" + Math.round(x) + "px, " + Math.round(y) + "px, 0)";
  }
  function getSecondaryStart(datum, secondaryAxis) {
    var _secondaryAxis$scale2;

    if (secondaryAxis.stacked) {
      var _secondaryAxis$scale, _datum$stackData$, _datum$stackData;

      return (_secondaryAxis$scale = secondaryAxis.scale((_datum$stackData$ = (_datum$stackData = datum.stackData) == null ? void 0 : _datum$stackData[0]) != null ? _datum$stackData$ : NaN)) != null ? _secondaryAxis$scale : NaN;
    }

    return (_secondaryAxis$scale2 = secondaryAxis.scale(0)) != null ? _secondaryAxis$scale2 : NaN;
  }
  function getSecondary(datum, secondaryAxis) {
    var _secondaryAxis$scale4;

    if (secondaryAxis.stacked) {
      var _secondaryAxis$scale3, _datum$stackData$2, _datum$stackData2;

      return (_secondaryAxis$scale3 = secondaryAxis.scale((_datum$stackData$2 = (_datum$stackData2 = datum.stackData) == null ? void 0 : _datum$stackData2[1]) != null ? _datum$stackData$2 : NaN)) != null ? _secondaryAxis$scale3 : NaN;
    }

    return (_secondaryAxis$scale4 = secondaryAxis.scale(secondaryAxis.getValue(datum.originalDatum))) != null ? _secondaryAxis$scale4 : NaN;
  }
  function getPrimary(datum, primaryAxis) {
    var primary;

    if (primaryAxis.stacked) {
      var _primaryAxis$scale, _datum$stackData$3, _datum$stackData3;

      primary = (_primaryAxis$scale = primaryAxis.scale((_datum$stackData$3 = (_datum$stackData3 = datum.stackData) == null ? void 0 : _datum$stackData3[1]) != null ? _datum$stackData$3 : NaN)) != null ? _primaryAxis$scale : NaN;
    } else {
      var _primaryAxis$scale2;

      primary = (_primaryAxis$scale2 = primaryAxis.scale(primaryAxis.getValue(datum.originalDatum))) != null ? _primaryAxis$scale2 : NaN;
    }

    if (primaryAxis.axisFamily === 'band') {
      primary = primary + getPrimaryLength(datum, primaryAxis) / 2;
    }

    return primary;
  }
  function getPrimaryStart(datum, primaryAxis) {
    return getPrimary(datum, primaryAxis) - getPrimaryLength(datum, primaryAxis) / 2;
  }
  function getPrimaryLength(_datum, primaryAxis) {
    if (primaryAxis.axisFamily === 'band') {
      var _primaryAxis$minBandS, _primaryAxis$maxBandS;

      return Math.min(Math.max(primaryAxis.scale.bandwidth(), (_primaryAxis$minBandS = primaryAxis.minBandSize) != null ? _primaryAxis$minBandS : 1), (_primaryAxis$maxBandS = primaryAxis.maxBandSize) != null ? _primaryAxis$maxBandS : 99999999);
    }

    return Math.max(primaryAxis.bandScale.bandwidth(), 1);
  }
  function getSecondaryLength(datum, secondaryAxis) {
    var secondary = [getSecondaryStart(datum, secondaryAxis), getSecondary(datum, secondaryAxis)];
    return Math.abs(secondary[1] - secondary[0]);
  }
  function getX(datum, primaryAxis, secondaryAxis) {
    return primaryAxis.isVertical ? getSecondary(datum, secondaryAxis) : getPrimary(datum, primaryAxis);
  }
  function getY(datum, primaryAxis, secondaryAxis) {
    return primaryAxis.isVertical ? getPrimary(datum, primaryAxis) : getSecondary(datum, secondaryAxis);
  }
  function getRectX(datum, primaryAxis, secondaryAxis) {
    return primaryAxis.isVertical ? getSecondaryStart(datum, secondaryAxis) : getPrimaryStart(datum, primaryAxis);
  }
  function getRectY(datum, primaryAxis, secondaryAxis) {
    return primaryAxis.isVertical ? getPrimaryStart(datum, primaryAxis) : getSecondary(datum, secondaryAxis);
  }
  function getWidth(datum, primaryAxis, secondaryAxis) {
    return primaryAxis.isVertical ? getSecondaryLength(datum, secondaryAxis) : getPrimaryLength(datum, primaryAxis);
  }
  function getHeight(datum, primaryAxis, secondaryAxis) {
    return primaryAxis.isVertical ? getPrimaryLength(datum, primaryAxis) : getSecondaryLength(datum, secondaryAxis);
  }
  function getTickPx(scale, value) {
    var _scale;

    var px = (_scale = scale(value)) != null ? _scale : NaN; // @ts-ignore

    if (scale.bandwidth) {
      // @ts-ignore
      return px + scale.bandwidth() / 2;
    }

    return px;
  }

  var chartContext = /*#__PURE__*/React__namespace.createContext(null);
  function ChartContextProvider(_ref) {
    var value = _ref.value,
        children = _ref.children;
    return /*#__PURE__*/React__namespace.createElement(chartContext.Provider, {
      value: value,
      children: children
    });
  }
  function useChartContext() {
    return React__namespace.useContext(chartContext)();
  }

  // @ts-nocheck
  function sign(x) {
    return x < 0 ? -1 : 1;
  } // Calculate the slopes of the tangents (Hermite-type interpolation) based on
  // the following paper: Steffen, M. 1990. A Simple Method for Monotonic
  // Interpolation in One Dimension. Astronomy and Astrophysics, Vol. 239, NO.
  // NOV(II), P. 443, 1990.


  function slope3(that, x2, y2) {
    var h0 = that._x1 - that._x0,
        h1 = x2 - that._x1,
        s0 = (that._y1 - that._y0) / (h0 || h1 < 0 && -0),
        s1 = (y2 - that._y1) / (h1 || h0 < 0 && -0),
        p = (s0 * h1 + s1 * h0) / (h0 + h1);
    return (sign(s0) + sign(s1)) * Math.min(Math.abs(s0), Math.abs(s1), 0.5 * Math.abs(p)) || 0;
  } // Calculate a one-sided slope.


  function slope2(that, t) {
    var h = that._x1 - that._x0;
    return h ? (3 * (that._y1 - that._y0) / h - t) / 2 : t;
  } // According to https://en.wikipedia.org/wiki/Cubic_Hermite_spline#Representations
  // "you can express cubic Hermite interpolation in terms of cubic Bézier curves
  // with respect to the four values p0, p0 + m0 / 3, p1 - m1 / 3, p1".


  function _point(that, t0, t1) {
    var x0 = that._x0,
        y0 = that._y0,
        x1 = that._x1,
        y1 = that._y1,
        dx = (x1 - x0) / 3;

    that._context.bezierCurveTo(x0 + dx, y0 + dx * t0, x1 - dx, y1 - dx * t1, x1, y1);
  }

  function MonotoneX(context) {
    this._context = context;
  }

  MonotoneX.prototype = {
    areaStart: function areaStart() {
      this._line = 0;
    },
    areaEnd: function areaEnd() {
      this._line = NaN;
    },
    lineStart: function lineStart() {
      this._x0 = this._x1 = this._y0 = this._y1 = this._t0 = NaN;
      this._point = 0;
    },
    lineEnd: function lineEnd() {
      switch (this._point) {
        case 2:
          this._context.lineTo(this._x1, this._y1);

          break;

        case 3:
          _point(this, this._t0, slope2(this, this._t0));

          break;
      }

      if (this._line || this._line !== 0 && this._point === 1) this._context.closePath();
      this._line = 1 - this._line;
    },
    point: function point(x, y) {
      var t1 = NaN;
      x = +x, y = +y;
      if (x === this._x1 && y === this._y1) return; // Ignore coincident points.

      switch (this._point) {
        case 0:
          this._point = 1;
          this._line ? this._context.lineTo(x, y) : this._context.moveTo(x, y);
          break;

        case 1:
          this._point = 2;
          break;

        case 2:
          this._point = 3;

          _point(this, slope2(this, t1 = slope3(this, x, y)), t1);

          break;

        default:
          _point(this, this._t0, t1 = slope3(this, x, y));

          break;
      }
      this._x0 = this._x1, this._x1 = x;
      this._y0 = this._y1, this._y1 = y;
      this._t0 = t1;
    }
  };

  (Object.create(MonotoneX.prototype)).point = function (x, y) {
    MonotoneX.prototype.point.call(this, y, x);
  };
  var monotoneX = function monotoneX(context) {
    return new MonotoneX(context);
  };

  function AreaComponent(_ref) {
    var _secondaryAxis$curve;

    var primaryAxis = _ref.primaryAxis,
        secondaryAxis = _ref.secondaryAxis,
        allSeries = _ref.series;

    var _useChartContext = useChartContext(),
        getSeriesStatusStyle = _useChartContext.getSeriesStatusStyle,
        getDatumStatusStyle = _useChartContext.getDatumStatusStyle,
        useFocusedDatumAtom = _useChartContext.useFocusedDatumAtom,
        gridDimensions = _useChartContext.gridDimensions;

    var curve = (_secondaryAxis$curve = secondaryAxis.curve) != null ? _secondaryAxis$curve : monotoneX;

    var _useFocusedDatumAtom = useFocusedDatumAtom(),
        focusedDatum = _useFocusedDatumAtom[0];

    return /*#__PURE__*/React__default['default'].createElement("g", {
      style: {
        transform: translate(gridDimensions.gridX, gridDimensions.gridY)
      }
    }, allSeries.map(function (series, i) {
      var _area$curve, _line$curve;

      var style = getSeriesStatusStyle(series, focusedDatum);

      var lineStyle = _extends$3({
        strokeWidth: 2
      }, style, style.line, {
        fill: 'none'
      });

      var areaStyle = _extends$3({
        strokeWidth: 2,
        opacity: 0.5
      }, style, style.area);

      var areaPath = (_area$curve = area(function (datum) {
        var _getPrimary;

        return (_getPrimary = getPrimary(datum, primaryAxis)) != null ? _getPrimary : NaN;
      }, function (datum) {
        var _getSecondaryStart;

        return (_getSecondaryStart = getSecondaryStart(datum, secondaryAxis)) != null ? _getSecondaryStart : NaN;
      }, function (datum) {
        var _getSecondary;

        return (_getSecondary = getSecondary(datum, secondaryAxis)) != null ? _getSecondary : NaN;
      }).curve(curve)(series.datums)) != null ? _area$curve : undefined;
      var linePath = (_line$curve = line(function (datum) {
        var _getPrimary2;

        return (_getPrimary2 = getPrimary(datum, primaryAxis)) != null ? _getPrimary2 : NaN;
      }, function (datum) {
        var _getSecondary2;

        return (_getSecondary2 = getSecondary(datum, secondaryAxis)) != null ? _getSecondary2 : NaN;
      }).curve(curve)(series.datums)) != null ? _line$curve : undefined;
      return /*#__PURE__*/React__default['default'].createElement("g", {
        key: "lines-" + i
      }, /*#__PURE__*/React__default['default'].createElement("path", {
        d: areaPath,
        style: areaStyle
      }), /*#__PURE__*/React__default['default'].createElement("path", {
        d: linePath,
        style: lineStyle
      }), series.datums.map(function (datum, i) {
        var _getY, _secondaryAxis$showDa;

        var dataStyle = getDatumStatusStyle(datum, focusedDatum);
        return /*#__PURE__*/React__default['default'].createElement("circle", {
          key: i,
          ref: function ref(el) {
            datum.element = el;
          },
          r: 2,
          cx: getX(datum, primaryAxis, secondaryAxis),
          cy: (_getY = getY(datum, primaryAxis, secondaryAxis)) != null ? _getY : NaN,
          stroke: "rgba(33,33,33,0.5)",
          style: _extends$3({
            // @ts-ignore
            r: 2
          }, style, style.circle, dataStyle, dataStyle.circle, !((_secondaryAxis$showDa = secondaryAxis.showDatumElements) != null ? _secondaryAxis$showDa : false) ? {
            opacity: 0
          } : {})
        });
      }));
    }));
  }

  function BarComponent(_ref) {
    var primaryAxis = _ref.primaryAxis,
        secondaryAxis = _ref.secondaryAxis,
        allSeries = _ref.series;

    var _useChartContext = useChartContext(),
        getSeriesStatusStyle = _useChartContext.getSeriesStatusStyle,
        getDatumStatusStyle = _useChartContext.getDatumStatusStyle,
        useFocusedDatumAtom = _useChartContext.useFocusedDatumAtom,
        gridDimensions = _useChartContext.gridDimensions;

    var _useFocusedDatumAtom = useFocusedDatumAtom(),
        focusedDatum = _useFocusedDatumAtom[0];

    return /*#__PURE__*/React__default['default'].createElement("g", {
      style: {
        transform: translate(gridDimensions.gridX, gridDimensions.gridY)
      }
    }, allSeries.map(function (series, i) {
      var style = getSeriesStatusStyle(series, focusedDatum);
      return /*#__PURE__*/React__default['default'].createElement("g", {
        key: "lines-" + i
      }, series.datums.map(function (datum, i) {
        var _getRectX, _getRectY, _getWidth, _getHeight;

        var dataStyle = getDatumStatusStyle(datum, focusedDatum);
        var x = (_getRectX = getRectX(datum, primaryAxis, secondaryAxis)) != null ? _getRectX : NaN;
        var y = (_getRectY = getRectY(datum, primaryAxis, secondaryAxis)) != null ? _getRectY : NaN;
        var width = (_getWidth = getWidth(datum, primaryAxis, secondaryAxis)) != null ? _getWidth : NaN;
        var height = (_getHeight = getHeight(datum, primaryAxis, secondaryAxis)) != null ? _getHeight : NaN;
        return /*#__PURE__*/React__default['default'].createElement("rect", {
          ref: function ref(el) {
            datum.element = el;
          },
          key: i,
          x: x,
          y: y,
          width: width,
          height: height,
          style: _extends$3({
            strokeWidth: 0
          }, style, style.rectangle, dataStyle, dataStyle.rectangle)
        });
      }));
    }));
  }

  var pathDefaultStyle = {
    strokeWidth: 2
  };
  function Line(_ref) {
    var _secondaryAxis$curve;

    var primaryAxis = _ref.primaryAxis,
        secondaryAxis = _ref.secondaryAxis,
        allSeries = _ref.series;

    var _useChartContext = useChartContext(),
        getSeriesStatusStyle = _useChartContext.getSeriesStatusStyle,
        getDatumStatusStyle = _useChartContext.getDatumStatusStyle,
        useFocusedDatumAtom = _useChartContext.useFocusedDatumAtom,
        gridDimensions = _useChartContext.gridDimensions;

    var curve = (_secondaryAxis$curve = secondaryAxis.curve) != null ? _secondaryAxis$curve : monotoneX;

    var _useFocusedDatumAtom = useFocusedDatumAtom(),
        focusedDatum = _useFocusedDatumAtom[0];

    return /*#__PURE__*/React__default['default'].createElement("g", {
      style: {
        transform: translate(gridDimensions.gridX, gridDimensions.gridY)
      }
    }, allSeries.map(function (series, i) {
      var _line$curve;

      var style = getSeriesStatusStyle(series, focusedDatum);

      var lineStyle = _extends$3({}, pathDefaultStyle, style, style.line, {
        fill: 'none'
      });

      var linePath = (_line$curve = line(function (datum) {
        var _getX;

        return (_getX = getX(datum, primaryAxis, secondaryAxis)) != null ? _getX : NaN;
      }, function (datum) {
        var _getY;

        return (_getY = getY(datum, primaryAxis, secondaryAxis)) != null ? _getY : NaN;
      }).curve(curve)(series.datums)) != null ? _line$curve : undefined;
      return /*#__PURE__*/React__default['default'].createElement("g", {
        key: "lines-" + i
      }, series.datums.map(function (datum, i) {
        var _secondaryAxis$showDa;

        var dataStyle = getDatumStatusStyle(datum, focusedDatum);
        return /*#__PURE__*/React__default['default'].createElement("circle", {
          key: i,
          ref: function ref(el) {
            datum.element = el;
          },
          r: 2,
          cx: getX(datum, primaryAxis, secondaryAxis),
          cy: getY(datum, primaryAxis, secondaryAxis),
          stroke: "rgba(33,33,33,0.5)",
          fill: "transparent",
          style: _extends$3({
            // @ts-ignore
            r: 2
          }, style, style.circle, dataStyle, dataStyle.circle, !((_secondaryAxis$showDa = secondaryAxis.showDatumElements) != null ? _secondaryAxis$showDa : true) ? {
            opacity: 0
          } : {})
        });
      }), /*#__PURE__*/React__default['default'].createElement("path", {
        d: linePath,
        style: lineStyle
      }));
    }));
  }

  function initRange(domain, range) {
    switch (arguments.length) {
      case 0:
        break;

      case 1:
        this.range(domain);
        break;

      default:
        this.range(range).domain(domain);
        break;
    }

    return this;
  }

  const implicit = Symbol("implicit");
  function ordinal() {
    var index = new Map(),
        domain = [],
        range = [],
        unknown = implicit;

    function scale(d) {
      var key = d + "",
          i = index.get(key);

      if (!i) {
        if (unknown !== implicit) return unknown;
        index.set(key, i = domain.push(d));
      }

      return range[(i - 1) % range.length];
    }

    scale.domain = function (_) {
      if (!arguments.length) return domain.slice();
      domain = [], index = new Map();

      for (const value of _) {
        const key = value + "";
        if (index.has(key)) continue;
        index.set(key, domain.push(value));
      }

      return scale;
    };

    scale.range = function (_) {
      return arguments.length ? (range = Array.from(_), scale) : range.slice();
    };

    scale.unknown = function (_) {
      return arguments.length ? (unknown = _, scale) : unknown;
    };

    scale.copy = function () {
      return ordinal(domain, range).unknown(unknown);
    };

    initRange.apply(scale, arguments);
    return scale;
  }

  function band() {
    var scale = ordinal().unknown(undefined),
        domain = scale.domain,
        ordinalRange = scale.range,
        r0 = 0,
        r1 = 1,
        step,
        bandwidth,
        round = false,
        paddingInner = 0,
        paddingOuter = 0,
        align = 0.5;
    delete scale.unknown;

    function rescale() {
      var n = domain().length,
          reverse = r1 < r0,
          start = reverse ? r1 : r0,
          stop = reverse ? r0 : r1;
      step = (stop - start) / Math.max(1, n - paddingInner + paddingOuter * 2);
      if (round) step = Math.floor(step);
      start += (stop - start - step * (n - paddingInner)) * align;
      bandwidth = step * (1 - paddingInner);
      if (round) start = Math.round(start), bandwidth = Math.round(bandwidth);
      var values = d3Range(n).map(function (i) {
        return start + step * i;
      });
      return ordinalRange(reverse ? values.reverse() : values);
    }

    scale.domain = function (_) {
      return arguments.length ? (domain(_), rescale()) : domain();
    };

    scale.range = function (_) {
      return arguments.length ? ([r0, r1] = _, r0 = +r0, r1 = +r1, rescale()) : [r0, r1];
    };

    scale.rangeRound = function (_) {
      return [r0, r1] = _, r0 = +r0, r1 = +r1, round = true, rescale();
    };

    scale.bandwidth = function () {
      return bandwidth;
    };

    scale.step = function () {
      return step;
    };

    scale.round = function (_) {
      return arguments.length ? (round = !!_, rescale()) : round;
    };

    scale.padding = function (_) {
      return arguments.length ? (paddingInner = Math.min(1, paddingOuter = +_), rescale()) : paddingInner;
    };

    scale.paddingInner = function (_) {
      return arguments.length ? (paddingInner = Math.min(1, _), rescale()) : paddingInner;
    };

    scale.paddingOuter = function (_) {
      return arguments.length ? (paddingOuter = +_, rescale()) : paddingOuter;
    };

    scale.align = function (_) {
      return arguments.length ? (align = Math.max(0, Math.min(1, _)), rescale()) : align;
    };

    scale.copy = function () {
      return band(domain(), [r0, r1]).round(round).paddingInner(paddingInner).paddingOuter(paddingOuter).align(align);
    };

    return initRange.apply(rescale(), arguments);
  }

  function define (constructor, factory, prototype) {
    constructor.prototype = factory.prototype = prototype;
    prototype.constructor = constructor;
  }
  function extend(parent, definition) {
    var prototype = Object.create(parent.prototype);

    for (var key in definition) prototype[key] = definition[key];

    return prototype;
  }

  function Color() {}
  var darker = 0.7;
  var brighter = 1 / darker;
  var reI = "\\s*([+-]?\\d+)\\s*",
      reN = "\\s*([+-]?\\d*\\.?\\d+(?:[eE][+-]?\\d+)?)\\s*",
      reP = "\\s*([+-]?\\d*\\.?\\d+(?:[eE][+-]?\\d+)?)%\\s*",
      reHex = /^#([0-9a-f]{3,8})$/,
      reRgbInteger = new RegExp("^rgb\\(" + [reI, reI, reI] + "\\)$"),
      reRgbPercent = new RegExp("^rgb\\(" + [reP, reP, reP] + "\\)$"),
      reRgbaInteger = new RegExp("^rgba\\(" + [reI, reI, reI, reN] + "\\)$"),
      reRgbaPercent = new RegExp("^rgba\\(" + [reP, reP, reP, reN] + "\\)$"),
      reHslPercent = new RegExp("^hsl\\(" + [reN, reP, reP] + "\\)$"),
      reHslaPercent = new RegExp("^hsla\\(" + [reN, reP, reP, reN] + "\\)$");
  var named = {
    aliceblue: 0xf0f8ff,
    antiquewhite: 0xfaebd7,
    aqua: 0x00ffff,
    aquamarine: 0x7fffd4,
    azure: 0xf0ffff,
    beige: 0xf5f5dc,
    bisque: 0xffe4c4,
    black: 0x000000,
    blanchedalmond: 0xffebcd,
    blue: 0x0000ff,
    blueviolet: 0x8a2be2,
    brown: 0xa52a2a,
    burlywood: 0xdeb887,
    cadetblue: 0x5f9ea0,
    chartreuse: 0x7fff00,
    chocolate: 0xd2691e,
    coral: 0xff7f50,
    cornflowerblue: 0x6495ed,
    cornsilk: 0xfff8dc,
    crimson: 0xdc143c,
    cyan: 0x00ffff,
    darkblue: 0x00008b,
    darkcyan: 0x008b8b,
    darkgoldenrod: 0xb8860b,
    darkgray: 0xa9a9a9,
    darkgreen: 0x006400,
    darkgrey: 0xa9a9a9,
    darkkhaki: 0xbdb76b,
    darkmagenta: 0x8b008b,
    darkolivegreen: 0x556b2f,
    darkorange: 0xff8c00,
    darkorchid: 0x9932cc,
    darkred: 0x8b0000,
    darksalmon: 0xe9967a,
    darkseagreen: 0x8fbc8f,
    darkslateblue: 0x483d8b,
    darkslategray: 0x2f4f4f,
    darkslategrey: 0x2f4f4f,
    darkturquoise: 0x00ced1,
    darkviolet: 0x9400d3,
    deeppink: 0xff1493,
    deepskyblue: 0x00bfff,
    dimgray: 0x696969,
    dimgrey: 0x696969,
    dodgerblue: 0x1e90ff,
    firebrick: 0xb22222,
    floralwhite: 0xfffaf0,
    forestgreen: 0x228b22,
    fuchsia: 0xff00ff,
    gainsboro: 0xdcdcdc,
    ghostwhite: 0xf8f8ff,
    gold: 0xffd700,
    goldenrod: 0xdaa520,
    gray: 0x808080,
    green: 0x008000,
    greenyellow: 0xadff2f,
    grey: 0x808080,
    honeydew: 0xf0fff0,
    hotpink: 0xff69b4,
    indianred: 0xcd5c5c,
    indigo: 0x4b0082,
    ivory: 0xfffff0,
    khaki: 0xf0e68c,
    lavender: 0xe6e6fa,
    lavenderblush: 0xfff0f5,
    lawngreen: 0x7cfc00,
    lemonchiffon: 0xfffacd,
    lightblue: 0xadd8e6,
    lightcoral: 0xf08080,
    lightcyan: 0xe0ffff,
    lightgoldenrodyellow: 0xfafad2,
    lightgray: 0xd3d3d3,
    lightgreen: 0x90ee90,
    lightgrey: 0xd3d3d3,
    lightpink: 0xffb6c1,
    lightsalmon: 0xffa07a,
    lightseagreen: 0x20b2aa,
    lightskyblue: 0x87cefa,
    lightslategray: 0x778899,
    lightslategrey: 0x778899,
    lightsteelblue: 0xb0c4de,
    lightyellow: 0xffffe0,
    lime: 0x00ff00,
    limegreen: 0x32cd32,
    linen: 0xfaf0e6,
    magenta: 0xff00ff,
    maroon: 0x800000,
    mediumaquamarine: 0x66cdaa,
    mediumblue: 0x0000cd,
    mediumorchid: 0xba55d3,
    mediumpurple: 0x9370db,
    mediumseagreen: 0x3cb371,
    mediumslateblue: 0x7b68ee,
    mediumspringgreen: 0x00fa9a,
    mediumturquoise: 0x48d1cc,
    mediumvioletred: 0xc71585,
    midnightblue: 0x191970,
    mintcream: 0xf5fffa,
    mistyrose: 0xffe4e1,
    moccasin: 0xffe4b5,
    navajowhite: 0xffdead,
    navy: 0x000080,
    oldlace: 0xfdf5e6,
    olive: 0x808000,
    olivedrab: 0x6b8e23,
    orange: 0xffa500,
    orangered: 0xff4500,
    orchid: 0xda70d6,
    palegoldenrod: 0xeee8aa,
    palegreen: 0x98fb98,
    paleturquoise: 0xafeeee,
    palevioletred: 0xdb7093,
    papayawhip: 0xffefd5,
    peachpuff: 0xffdab9,
    peru: 0xcd853f,
    pink: 0xffc0cb,
    plum: 0xdda0dd,
    powderblue: 0xb0e0e6,
    purple: 0x800080,
    rebeccapurple: 0x663399,
    red: 0xff0000,
    rosybrown: 0xbc8f8f,
    royalblue: 0x4169e1,
    saddlebrown: 0x8b4513,
    salmon: 0xfa8072,
    sandybrown: 0xf4a460,
    seagreen: 0x2e8b57,
    seashell: 0xfff5ee,
    sienna: 0xa0522d,
    silver: 0xc0c0c0,
    skyblue: 0x87ceeb,
    slateblue: 0x6a5acd,
    slategray: 0x708090,
    slategrey: 0x708090,
    snow: 0xfffafa,
    springgreen: 0x00ff7f,
    steelblue: 0x4682b4,
    tan: 0xd2b48c,
    teal: 0x008080,
    thistle: 0xd8bfd8,
    tomato: 0xff6347,
    turquoise: 0x40e0d0,
    violet: 0xee82ee,
    wheat: 0xf5deb3,
    white: 0xffffff,
    whitesmoke: 0xf5f5f5,
    yellow: 0xffff00,
    yellowgreen: 0x9acd32
  };
  define(Color, color, {
    copy: function (channels) {
      return Object.assign(new this.constructor(), this, channels);
    },
    displayable: function () {
      return this.rgb().displayable();
    },
    hex: color_formatHex,
    // Deprecated! Use color.formatHex.
    formatHex: color_formatHex,
    formatHsl: color_formatHsl,
    formatRgb: color_formatRgb,
    toString: color_formatRgb
  });

  function color_formatHex() {
    return this.rgb().formatHex();
  }

  function color_formatHsl() {
    return hslConvert(this).formatHsl();
  }

  function color_formatRgb() {
    return this.rgb().formatRgb();
  }

  function color(format) {
    var m, l;
    format = (format + "").trim().toLowerCase();
    return (m = reHex.exec(format)) ? (l = m[1].length, m = parseInt(m[1], 16), l === 6 ? rgbn(m) // #ff0000
    : l === 3 ? new Rgb(m >> 8 & 0xf | m >> 4 & 0xf0, m >> 4 & 0xf | m & 0xf0, (m & 0xf) << 4 | m & 0xf, 1) // #f00
    : l === 8 ? rgba$1(m >> 24 & 0xff, m >> 16 & 0xff, m >> 8 & 0xff, (m & 0xff) / 0xff) // #ff000000
    : l === 4 ? rgba$1(m >> 12 & 0xf | m >> 8 & 0xf0, m >> 8 & 0xf | m >> 4 & 0xf0, m >> 4 & 0xf | m & 0xf0, ((m & 0xf) << 4 | m & 0xf) / 0xff) // #f000
    : null // invalid hex
    ) : (m = reRgbInteger.exec(format)) ? new Rgb(m[1], m[2], m[3], 1) // rgb(255, 0, 0)
    : (m = reRgbPercent.exec(format)) ? new Rgb(m[1] * 255 / 100, m[2] * 255 / 100, m[3] * 255 / 100, 1) // rgb(100%, 0%, 0%)
    : (m = reRgbaInteger.exec(format)) ? rgba$1(m[1], m[2], m[3], m[4]) // rgba(255, 0, 0, 1)
    : (m = reRgbaPercent.exec(format)) ? rgba$1(m[1] * 255 / 100, m[2] * 255 / 100, m[3] * 255 / 100, m[4]) // rgb(100%, 0%, 0%, 1)
    : (m = reHslPercent.exec(format)) ? hsla$1(m[1], m[2] / 100, m[3] / 100, 1) // hsl(120, 50%, 50%)
    : (m = reHslaPercent.exec(format)) ? hsla$1(m[1], m[2] / 100, m[3] / 100, m[4]) // hsla(120, 50%, 50%, 1)
    : named.hasOwnProperty(format) ? rgbn(named[format]) // eslint-disable-line no-prototype-builtins
    : format === "transparent" ? new Rgb(NaN, NaN, NaN, 0) : null;
  }

  function rgbn(n) {
    return new Rgb(n >> 16 & 0xff, n >> 8 & 0xff, n & 0xff, 1);
  }

  function rgba$1(r, g, b, a) {
    if (a <= 0) r = g = b = NaN;
    return new Rgb(r, g, b, a);
  }

  function rgbConvert(o) {
    if (!(o instanceof Color)) o = color(o);
    if (!o) return new Rgb();
    o = o.rgb();
    return new Rgb(o.r, o.g, o.b, o.opacity);
  }
  function rgb$2(r, g, b, opacity) {
    return arguments.length === 1 ? rgbConvert(r) : new Rgb(r, g, b, opacity == null ? 1 : opacity);
  }
  function Rgb(r, g, b, opacity) {
    this.r = +r;
    this.g = +g;
    this.b = +b;
    this.opacity = +opacity;
  }
  define(Rgb, rgb$2, extend(Color, {
    brighter: function (k) {
      k = k == null ? brighter : Math.pow(brighter, k);
      return new Rgb(this.r * k, this.g * k, this.b * k, this.opacity);
    },
    darker: function (k) {
      k = k == null ? darker : Math.pow(darker, k);
      return new Rgb(this.r * k, this.g * k, this.b * k, this.opacity);
    },
    rgb: function () {
      return this;
    },
    displayable: function () {
      return -0.5 <= this.r && this.r < 255.5 && -0.5 <= this.g && this.g < 255.5 && -0.5 <= this.b && this.b < 255.5 && 0 <= this.opacity && this.opacity <= 1;
    },
    hex: rgb_formatHex,
    // Deprecated! Use color.formatHex.
    formatHex: rgb_formatHex,
    formatRgb: rgb_formatRgb,
    toString: rgb_formatRgb
  }));

  function rgb_formatHex() {
    return "#" + hex(this.r) + hex(this.g) + hex(this.b);
  }

  function rgb_formatRgb() {
    var a = this.opacity;
    a = isNaN(a) ? 1 : Math.max(0, Math.min(1, a));
    return (a === 1 ? "rgb(" : "rgba(") + Math.max(0, Math.min(255, Math.round(this.r) || 0)) + ", " + Math.max(0, Math.min(255, Math.round(this.g) || 0)) + ", " + Math.max(0, Math.min(255, Math.round(this.b) || 0)) + (a === 1 ? ")" : ", " + a + ")");
  }

  function hex(value) {
    value = Math.max(0, Math.min(255, Math.round(value) || 0));
    return (value < 16 ? "0" : "") + value.toString(16);
  }

  function hsla$1(h, s, l, a) {
    if (a <= 0) h = s = l = NaN;else if (l <= 0 || l >= 1) h = s = NaN;else if (s <= 0) h = NaN;
    return new Hsl(h, s, l, a);
  }

  function hslConvert(o) {
    if (o instanceof Hsl) return new Hsl(o.h, o.s, o.l, o.opacity);
    if (!(o instanceof Color)) o = color(o);
    if (!o) return new Hsl();
    if (o instanceof Hsl) return o;
    o = o.rgb();
    var r = o.r / 255,
        g = o.g / 255,
        b = o.b / 255,
        min = Math.min(r, g, b),
        max = Math.max(r, g, b),
        h = NaN,
        s = max - min,
        l = (max + min) / 2;

    if (s) {
      if (r === max) h = (g - b) / s + (g < b) * 6;else if (g === max) h = (b - r) / s + 2;else h = (r - g) / s + 4;
      s /= l < 0.5 ? max + min : 2 - max - min;
      h *= 60;
    } else {
      s = l > 0 && l < 1 ? 0 : h;
    }

    return new Hsl(h, s, l, o.opacity);
  }
  function hsl$1(h, s, l, opacity) {
    return arguments.length === 1 ? hslConvert(h) : new Hsl(h, s, l, opacity == null ? 1 : opacity);
  }

  function Hsl(h, s, l, opacity) {
    this.h = +h;
    this.s = +s;
    this.l = +l;
    this.opacity = +opacity;
  }

  define(Hsl, hsl$1, extend(Color, {
    brighter: function (k) {
      k = k == null ? brighter : Math.pow(brighter, k);
      return new Hsl(this.h, this.s, this.l * k, this.opacity);
    },
    darker: function (k) {
      k = k == null ? darker : Math.pow(darker, k);
      return new Hsl(this.h, this.s, this.l * k, this.opacity);
    },
    rgb: function () {
      var h = this.h % 360 + (this.h < 0) * 360,
          s = isNaN(h) || isNaN(this.s) ? 0 : this.s,
          l = this.l,
          m2 = l + (l < 0.5 ? l : 1 - l) * s,
          m1 = 2 * l - m2;
      return new Rgb(hsl2rgb(h >= 240 ? h - 240 : h + 120, m1, m2), hsl2rgb(h, m1, m2), hsl2rgb(h < 120 ? h + 240 : h - 120, m1, m2), this.opacity);
    },
    displayable: function () {
      return (0 <= this.s && this.s <= 1 || isNaN(this.s)) && 0 <= this.l && this.l <= 1 && 0 <= this.opacity && this.opacity <= 1;
    },
    formatHsl: function () {
      var a = this.opacity;
      a = isNaN(a) ? 1 : Math.max(0, Math.min(1, a));
      return (a === 1 ? "hsl(" : "hsla(") + (this.h || 0) + ", " + (this.s || 0) * 100 + "%, " + (this.l || 0) * 100 + "%" + (a === 1 ? ")" : ", " + a + ")");
    }
  }));
  /* From FvD 13.37, CSS Color Module Level 3 */

  function hsl2rgb(h, m1, m2) {
    return (h < 60 ? m1 + (m2 - m1) * h / 60 : h < 180 ? m2 : h < 240 ? m1 + (m2 - m1) * (240 - h) / 60 : m1) * 255;
  }

  var constant = (x => () => x);

  function linear$2(a, d) {
    return function (t) {
      return a + t * d;
    };
  }

  function exponential(a, b, y) {
    return a = Math.pow(a, y), b = Math.pow(b, y) - a, y = 1 / y, function (t) {
      return Math.pow(a + t * b, y);
    };
  }
  function gamma(y) {
    return (y = +y) === 1 ? nogamma : function (a, b) {
      return b - a ? exponential(a, b, y) : constant(isNaN(a) ? b : a);
    };
  }
  function nogamma(a, b) {
    var d = b - a;
    return d ? linear$2(a, d) : constant(isNaN(a) ? b : a);
  }

  var rgb$1 = (function rgbGamma(y) {
    var color = gamma(y);

    function rgb(start, end) {
      var r = color((start = rgb$2(start)).r, (end = rgb$2(end)).r),
          g = color(start.g, end.g),
          b = color(start.b, end.b),
          opacity = nogamma(start.opacity, end.opacity);
      return function (t) {
        start.r = r(t);
        start.g = g(t);
        start.b = b(t);
        start.opacity = opacity(t);
        return start + "";
      };
    }

    rgb.gamma = rgbGamma;
    return rgb;
  })(1);

  function numberArray (a, b) {
    if (!b) b = [];
    var n = a ? Math.min(b.length, a.length) : 0,
        c = b.slice(),
        i;
    return function (t) {
      for (i = 0; i < n; ++i) c[i] = a[i] * (1 - t) + b[i] * t;

      return c;
    };
  }
  function isNumberArray(x) {
    return ArrayBuffer.isView(x) && !(x instanceof DataView);
  }

  function genericArray(a, b) {
    var nb = b ? b.length : 0,
        na = a ? Math.min(nb, a.length) : 0,
        x = new Array(na),
        c = new Array(nb),
        i;

    for (i = 0; i < na; ++i) x[i] = interpolate$1(a[i], b[i]);

    for (; i < nb; ++i) c[i] = b[i];

    return function (t) {
      for (i = 0; i < na; ++i) c[i] = x[i](t);

      return c;
    };
  }

  function date$1 (a, b) {
    var d = new Date();
    return a = +a, b = +b, function (t) {
      return d.setTime(a * (1 - t) + b * t), d;
    };
  }

  function interpolateNumber (a, b) {
    return a = +a, b = +b, function (t) {
      return a * (1 - t) + b * t;
    };
  }

  function object (a, b) {
    var i = {},
        c = {},
        k;
    if (a === null || typeof a !== "object") a = {};
    if (b === null || typeof b !== "object") b = {};

    for (k in b) {
      if (k in a) {
        i[k] = interpolate$1(a[k], b[k]);
      } else {
        c[k] = b[k];
      }
    }

    return function (t) {
      for (k in i) c[k] = i[k](t);

      return c;
    };
  }

  var reA = /[-+]?(?:\d+\.?\d*|\.?\d+)(?:[eE][-+]?\d+)?/g,
      reB = new RegExp(reA.source, "g");

  function zero(b) {
    return function () {
      return b;
    };
  }

  function one(b) {
    return function (t) {
      return b(t) + "";
    };
  }

  function string (a, b) {
    var bi = reA.lastIndex = reB.lastIndex = 0,
        // scan index for next number in b
    am,
        // current match in a
    bm,
        // current match in b
    bs,
        // string preceding current number in b, if any
    i = -1,
        // index in s
    s = [],
        // string constants and placeholders
    q = []; // number interpolators
    // Coerce inputs to strings.

    a = a + "", b = b + ""; // Interpolate pairs of numbers in a & b.

    while ((am = reA.exec(a)) && (bm = reB.exec(b))) {
      if ((bs = bm.index) > bi) {
        // a string precedes the next number in b
        bs = b.slice(bi, bs);
        if (s[i]) s[i] += bs; // coalesce with previous string
        else s[++i] = bs;
      }

      if ((am = am[0]) === (bm = bm[0])) {
        // numbers in a & b match
        if (s[i]) s[i] += bm; // coalesce with previous string
        else s[++i] = bm;
      } else {
        // interpolate non-matching numbers
        s[++i] = null;
        q.push({
          i: i,
          x: interpolateNumber(am, bm)
        });
      }

      bi = reB.lastIndex;
    } // Add remains of b.


    if (bi < b.length) {
      bs = b.slice(bi);
      if (s[i]) s[i] += bs; // coalesce with previous string
      else s[++i] = bs;
    } // Special optimization for only a single match.
    // Otherwise, interpolate each of the numbers and rejoin the string.


    return s.length < 2 ? q[0] ? one(q[0].x) : zero(b) : (b = q.length, function (t) {
      for (var i = 0, o; i < b; ++i) s[(o = q[i]).i] = o.x(t);

      return s.join("");
    });
  }

  function interpolate$1 (a, b) {
    var t = typeof b,
        c;
    return b == null || t === "boolean" ? constant(b) : (t === "number" ? interpolateNumber : t === "string" ? (c = color(b)) ? (b = c, rgb$1) : string : b instanceof color ? rgb$1 : b instanceof Date ? date$1 : isNumberArray(b) ? numberArray : Array.isArray(b) ? genericArray : typeof b.valueOf !== "function" && typeof b.toString !== "function" || isNaN(b) ? object : interpolateNumber)(a, b);
  }

  function interpolateRound (a, b) {
    return a = +a, b = +b, function (t) {
      return Math.round(a * (1 - t) + b * t);
    };
  }

  function constants(x) {
    return function () {
      return x;
    };
  }

  function number$1(x) {
    return +x;
  }

  var unit = [0, 1];
  function identity$1(x) {
    return x;
  }

  function normalize(a, b) {
    return (b -= a = +a) ? function (x) {
      return (x - a) / b;
    } : constants(isNaN(b) ? NaN : 0.5);
  }

  function clamper(a, b) {
    var t;
    if (a > b) t = a, a = b, b = t;
    return function (x) {
      return Math.max(a, Math.min(b, x));
    };
  } // normalize(a, b)(x) takes a domain value x in [a,b] and returns the corresponding parameter t in [0,1].
  // interpolate(a, b)(t) takes a parameter t in [0,1] and returns the corresponding range value x in [a,b].


  function bimap(domain, range, interpolate) {
    var d0 = domain[0],
        d1 = domain[1],
        r0 = range[0],
        r1 = range[1];
    if (d1 < d0) d0 = normalize(d1, d0), r0 = interpolate(r1, r0);else d0 = normalize(d0, d1), r0 = interpolate(r0, r1);
    return function (x) {
      return r0(d0(x));
    };
  }

  function polymap(domain, range, interpolate) {
    var j = Math.min(domain.length, range.length) - 1,
        d = new Array(j),
        r = new Array(j),
        i = -1; // Reverse descending domains.

    if (domain[j] < domain[0]) {
      domain = domain.slice().reverse();
      range = range.slice().reverse();
    }

    while (++i < j) {
      d[i] = normalize(domain[i], domain[i + 1]);
      r[i] = interpolate(range[i], range[i + 1]);
    }

    return function (x) {
      var i = bisectRight(domain, x, 1, j) - 1;
      return r[i](d[i](x));
    };
  }

  function copy(source, target) {
    return target.domain(source.domain()).range(source.range()).interpolate(source.interpolate()).clamp(source.clamp()).unknown(source.unknown());
  }
  function transformer() {
    var domain = unit,
        range = unit,
        interpolate = interpolate$1,
        transform,
        untransform,
        unknown,
        clamp = identity$1,
        piecewise,
        output,
        input;

    function rescale() {
      var n = Math.min(domain.length, range.length);
      if (clamp !== identity$1) clamp = clamper(domain[0], domain[n - 1]);
      piecewise = n > 2 ? polymap : bimap;
      output = input = null;
      return scale;
    }

    function scale(x) {
      return x == null || isNaN(x = +x) ? unknown : (output || (output = piecewise(domain.map(transform), range, interpolate)))(transform(clamp(x)));
    }

    scale.invert = function (y) {
      return clamp(untransform((input || (input = piecewise(range, domain.map(transform), interpolateNumber)))(y)));
    };

    scale.domain = function (_) {
      return arguments.length ? (domain = Array.from(_, number$1), rescale()) : domain.slice();
    };

    scale.range = function (_) {
      return arguments.length ? (range = Array.from(_), rescale()) : range.slice();
    };

    scale.rangeRound = function (_) {
      return range = Array.from(_), interpolate = interpolateRound, rescale();
    };

    scale.clamp = function (_) {
      return arguments.length ? (clamp = _ ? true : identity$1, rescale()) : clamp !== identity$1;
    };

    scale.interpolate = function (_) {
      return arguments.length ? (interpolate = _, rescale()) : interpolate;
    };

    scale.unknown = function (_) {
      return arguments.length ? (unknown = _, scale) : unknown;
    };

    return function (t, u) {
      transform = t, untransform = u;
      return rescale();
    };
  }
  function continuous() {
    return transformer()(identity$1, identity$1);
  }

  function formatDecimal (x) {
    return Math.abs(x = Math.round(x)) >= 1e21 ? x.toLocaleString("en").replace(/,/g, "") : x.toString(10);
  } // Computes the decimal coefficient and exponent of the specified number x with
  // significant digits p, where x is positive and p is in [1, 21] or undefined.
  // For example, formatDecimalParts(1.23) returns ["123", 0].

  function formatDecimalParts(x, p) {
    if ((i = (x = p ? x.toExponential(p - 1) : x.toExponential()).indexOf("e")) < 0) return null; // NaN, ±Infinity

    var i,
        coefficient = x.slice(0, i); // The string returned by toExponential either has the form \d\.\d+e[-+]\d+
    // (e.g., 1.2e+3) or the form \de[-+]\d+ (e.g., 1e+3).

    return [coefficient.length > 1 ? coefficient[0] + coefficient.slice(2) : coefficient, +x.slice(i + 1)];
  }

  function exponent (x) {
    return x = formatDecimalParts(Math.abs(x)), x ? x[1] : NaN;
  }

  function formatGroup (grouping, thousands) {
    return function (value, width) {
      var i = value.length,
          t = [],
          j = 0,
          g = grouping[0],
          length = 0;

      while (i > 0 && g > 0) {
        if (length + g + 1 > width) g = Math.max(1, width - length);
        t.push(value.substring(i -= g, i + g));
        if ((length += g + 1) > width) break;
        g = grouping[j = (j + 1) % grouping.length];
      }

      return t.reverse().join(thousands);
    };
  }

  function formatNumerals (numerals) {
    return function (value) {
      return value.replace(/[0-9]/g, function (i) {
        return numerals[+i];
      });
    };
  }

  // [[fill]align][sign][symbol][0][width][,][.precision][~][type]
  var re = /^(?:(.)?([<>=^]))?([+\-( ])?([$#])?(0)?(\d+)?(,)?(\.\d+)?(~)?([a-z%])?$/i;
  function formatSpecifier(specifier) {
    if (!(match = re.exec(specifier))) throw new Error("invalid format: " + specifier);
    var match;
    return new FormatSpecifier({
      fill: match[1],
      align: match[2],
      sign: match[3],
      symbol: match[4],
      zero: match[5],
      width: match[6],
      comma: match[7],
      precision: match[8] && match[8].slice(1),
      trim: match[9],
      type: match[10]
    });
  }
  formatSpecifier.prototype = FormatSpecifier.prototype; // instanceof

  function FormatSpecifier(specifier) {
    this.fill = specifier.fill === undefined ? " " : specifier.fill + "";
    this.align = specifier.align === undefined ? ">" : specifier.align + "";
    this.sign = specifier.sign === undefined ? "-" : specifier.sign + "";
    this.symbol = specifier.symbol === undefined ? "" : specifier.symbol + "";
    this.zero = !!specifier.zero;
    this.width = specifier.width === undefined ? undefined : +specifier.width;
    this.comma = !!specifier.comma;
    this.precision = specifier.precision === undefined ? undefined : +specifier.precision;
    this.trim = !!specifier.trim;
    this.type = specifier.type === undefined ? "" : specifier.type + "";
  }

  FormatSpecifier.prototype.toString = function () {
    return this.fill + this.align + this.sign + this.symbol + (this.zero ? "0" : "") + (this.width === undefined ? "" : Math.max(1, this.width | 0)) + (this.comma ? "," : "") + (this.precision === undefined ? "" : "." + Math.max(0, this.precision | 0)) + (this.trim ? "~" : "") + this.type;
  };

  // Trims insignificant zeros, e.g., replaces 1.2000k with 1.2k.
  function formatTrim (s) {
    out: for (var n = s.length, i = 1, i0 = -1, i1; i < n; ++i) {
      switch (s[i]) {
        case ".":
          i0 = i1 = i;
          break;

        case "0":
          if (i0 === 0) i0 = i;
          i1 = i;
          break;

        default:
          if (!+s[i]) break out;
          if (i0 > 0) i0 = 0;
          break;
      }
    }

    return i0 > 0 ? s.slice(0, i0) + s.slice(i1 + 1) : s;
  }

  var prefixExponent;
  function formatPrefixAuto (x, p) {
    var d = formatDecimalParts(x, p);
    if (!d) return x + "";
    var coefficient = d[0],
        exponent = d[1],
        i = exponent - (prefixExponent = Math.max(-8, Math.min(8, Math.floor(exponent / 3))) * 3) + 1,
        n = coefficient.length;
    return i === n ? coefficient : i > n ? coefficient + new Array(i - n + 1).join("0") : i > 0 ? coefficient.slice(0, i) + "." + coefficient.slice(i) : "0." + new Array(1 - i).join("0") + formatDecimalParts(x, Math.max(0, p + i - 1))[0]; // less than 1y!
  }

  function formatRounded (x, p) {
    var d = formatDecimalParts(x, p);
    if (!d) return x + "";
    var coefficient = d[0],
        exponent = d[1];
    return exponent < 0 ? "0." + new Array(-exponent).join("0") + coefficient : coefficient.length > exponent + 1 ? coefficient.slice(0, exponent + 1) + "." + coefficient.slice(exponent + 1) : coefficient + new Array(exponent - coefficient.length + 2).join("0");
  }

  var formatTypes = {
    "%": (x, p) => (x * 100).toFixed(p),
    "b": x => Math.round(x).toString(2),
    "c": x => x + "",
    "d": formatDecimal,
    "e": (x, p) => x.toExponential(p),
    "f": (x, p) => x.toFixed(p),
    "g": (x, p) => x.toPrecision(p),
    "o": x => Math.round(x).toString(8),
    "p": (x, p) => formatRounded(x * 100, p),
    "r": formatRounded,
    "s": formatPrefixAuto,
    "X": x => Math.round(x).toString(16).toUpperCase(),
    "x": x => Math.round(x).toString(16)
  };

  function identity (x) {
    return x;
  }

  var map = Array.prototype.map,
      prefixes$1 = ["y", "z", "a", "f", "p", "n", "µ", "m", "", "k", "M", "G", "T", "P", "E", "Z", "Y"];
  function formatLocale$1 (locale) {
    var group = locale.grouping === undefined || locale.thousands === undefined ? identity : formatGroup(map.call(locale.grouping, Number), locale.thousands + ""),
        currencyPrefix = locale.currency === undefined ? "" : locale.currency[0] + "",
        currencySuffix = locale.currency === undefined ? "" : locale.currency[1] + "",
        decimal = locale.decimal === undefined ? "." : locale.decimal + "",
        numerals = locale.numerals === undefined ? identity : formatNumerals(map.call(locale.numerals, String)),
        percent = locale.percent === undefined ? "%" : locale.percent + "",
        minus = locale.minus === undefined ? "−" : locale.minus + "",
        nan = locale.nan === undefined ? "NaN" : locale.nan + "";

    function newFormat(specifier) {
      specifier = formatSpecifier(specifier);
      var fill = specifier.fill,
          align = specifier.align,
          sign = specifier.sign,
          symbol = specifier.symbol,
          zero = specifier.zero,
          width = specifier.width,
          comma = specifier.comma,
          precision = specifier.precision,
          trim = specifier.trim,
          type = specifier.type; // The "n" type is an alias for ",g".

      if (type === "n") comma = true, type = "g"; // The "" type, and any invalid type, is an alias for ".12~g".
      else if (!formatTypes[type]) precision === undefined && (precision = 12), trim = true, type = "g"; // If zero fill is specified, padding goes after sign and before digits.

      if (zero || fill === "0" && align === "=") zero = true, fill = "0", align = "="; // Compute the prefix and suffix.
      // For SI-prefix, the suffix is lazily computed.

      var prefix = symbol === "$" ? currencyPrefix : symbol === "#" && /[boxX]/.test(type) ? "0" + type.toLowerCase() : "",
          suffix = symbol === "$" ? currencySuffix : /[%p]/.test(type) ? percent : ""; // What format function should we use?
      // Is this an integer type?
      // Can this type generate exponential notation?

      var formatType = formatTypes[type],
          maybeSuffix = /[defgprs%]/.test(type); // Set the default precision if not specified,
      // or clamp the specified precision to the supported range.
      // For significant precision, it must be in [1, 21].
      // For fixed precision, it must be in [0, 20].

      precision = precision === undefined ? 6 : /[gprs]/.test(type) ? Math.max(1, Math.min(21, precision)) : Math.max(0, Math.min(20, precision));

      function format(value) {
        var valuePrefix = prefix,
            valueSuffix = suffix,
            i,
            n,
            c;

        if (type === "c") {
          valueSuffix = formatType(value) + valueSuffix;
          value = "";
        } else {
          value = +value; // Determine the sign. -0 is not less than 0, but 1 / -0 is!

          var valueNegative = value < 0 || 1 / value < 0; // Perform the initial formatting.

          value = isNaN(value) ? nan : formatType(Math.abs(value), precision); // Trim insignificant zeros.

          if (trim) value = formatTrim(value); // If a negative value rounds to zero after formatting, and no explicit positive sign is requested, hide the sign.

          if (valueNegative && +value === 0 && sign !== "+") valueNegative = false; // Compute the prefix and suffix.

          valuePrefix = (valueNegative ? sign === "(" ? sign : minus : sign === "-" || sign === "(" ? "" : sign) + valuePrefix;
          valueSuffix = (type === "s" ? prefixes$1[8 + prefixExponent / 3] : "") + valueSuffix + (valueNegative && sign === "(" ? ")" : ""); // Break the formatted value into the integer “value” part that can be
          // grouped, and fractional or exponential “suffix” part that is not.

          if (maybeSuffix) {
            i = -1, n = value.length;

            while (++i < n) {
              if (c = value.charCodeAt(i), 48 > c || c > 57) {
                valueSuffix = (c === 46 ? decimal + value.slice(i + 1) : value.slice(i)) + valueSuffix;
                value = value.slice(0, i);
                break;
              }
            }
          }
        } // If the fill character is not "0", grouping is applied before padding.


        if (comma && !zero) value = group(value, Infinity); // Compute the padding.

        var length = valuePrefix.length + value.length + valueSuffix.length,
            padding = length < width ? new Array(width - length + 1).join(fill) : ""; // If the fill character is "0", grouping is applied after padding.

        if (comma && zero) value = group(padding + value, padding.length ? width - valueSuffix.length : Infinity), padding = ""; // Reconstruct the final output based on the desired alignment.

        switch (align) {
          case "<":
            value = valuePrefix + value + valueSuffix + padding;
            break;

          case "=":
            value = valuePrefix + padding + value + valueSuffix;
            break;

          case "^":
            value = padding.slice(0, length = padding.length >> 1) + valuePrefix + value + valueSuffix + padding.slice(length);
            break;

          default:
            value = padding + valuePrefix + value + valueSuffix;
            break;
        }

        return numerals(value);
      }

      format.toString = function () {
        return specifier + "";
      };

      return format;
    }

    function formatPrefix(specifier, value) {
      var f = newFormat((specifier = formatSpecifier(specifier), specifier.type = "f", specifier)),
          e = Math.max(-8, Math.min(8, Math.floor(exponent(value) / 3))) * 3,
          k = Math.pow(10, -e),
          prefix = prefixes$1[8 + e / 3];
      return function (value) {
        return f(k * value) + prefix;
      };
    }

    return {
      format: newFormat,
      formatPrefix: formatPrefix
    };
  }

  var locale$1;
  var format;
  var formatPrefix;
  defaultLocale$1({
    thousands: ",",
    grouping: [3],
    currency: ["$", ""]
  });
  function defaultLocale$1(definition) {
    locale$1 = formatLocale$1(definition);
    format = locale$1.format;
    formatPrefix = locale$1.formatPrefix;
    return locale$1;
  }

  function precisionFixed (step) {
    return Math.max(0, -exponent(Math.abs(step)));
  }

  function precisionPrefix (step, value) {
    return Math.max(0, Math.max(-8, Math.min(8, Math.floor(exponent(value) / 3))) * 3 - exponent(Math.abs(step)));
  }

  function precisionRound (step, max) {
    step = Math.abs(step), max = Math.abs(max) - step;
    return Math.max(0, exponent(max) - exponent(step)) + 1;
  }

  function tickFormat(start, stop, count, specifier) {
    var step = tickStep(start, stop, count),
        precision;
    specifier = formatSpecifier(specifier == null ? ",f" : specifier);

    switch (specifier.type) {
      case "s":
        {
          var value = Math.max(Math.abs(start), Math.abs(stop));
          if (specifier.precision == null && !isNaN(precision = precisionPrefix(step, value))) specifier.precision = precision;
          return formatPrefix(specifier, value);
        }

      case "":
      case "e":
      case "g":
      case "p":
      case "r":
        {
          if (specifier.precision == null && !isNaN(precision = precisionRound(step, Math.max(Math.abs(start), Math.abs(stop))))) specifier.precision = precision - (specifier.type === "e");
          break;
        }

      case "f":
      case "%":
        {
          if (specifier.precision == null && !isNaN(precision = precisionFixed(step))) specifier.precision = precision - (specifier.type === "%") * 2;
          break;
        }
    }

    return format(specifier);
  }

  function linearish(scale) {
    var domain = scale.domain;

    scale.ticks = function (count) {
      var d = domain();
      return ticks(d[0], d[d.length - 1], count == null ? 10 : count);
    };

    scale.tickFormat = function (count, specifier) {
      var d = domain();
      return tickFormat(d[0], d[d.length - 1], count == null ? 10 : count, specifier);
    };

    scale.nice = function (count) {
      if (count == null) count = 10;
      var d = domain();
      var i0 = 0;
      var i1 = d.length - 1;
      var start = d[i0];
      var stop = d[i1];
      var prestep;
      var step;
      var maxIter = 10;

      if (stop < start) {
        step = start, start = stop, stop = step;
        step = i0, i0 = i1, i1 = step;
      }

      while (maxIter-- > 0) {
        step = tickIncrement(start, stop, count);

        if (step === prestep) {
          d[i0] = start;
          d[i1] = stop;
          return domain(d);
        } else if (step > 0) {
          start = Math.floor(start / step) * step;
          stop = Math.ceil(stop / step) * step;
        } else if (step < 0) {
          start = Math.ceil(start * step) / step;
          stop = Math.floor(stop * step) / step;
        } else {
          break;
        }

        prestep = step;
      }

      return scale;
    };

    return scale;
  }
  function linear$1() {
    var scale = continuous();

    scale.copy = function () {
      return copy(scale, linear$1());
    };

    initRange.apply(scale, arguments);
    return linearish(scale);
  }

  function nice(domain, interval) {
    domain = domain.slice();
    var i0 = 0,
        i1 = domain.length - 1,
        x0 = domain[i0],
        x1 = domain[i1],
        t;

    if (x1 < x0) {
      t = i0, i0 = i1, i1 = t;
      t = x0, x0 = x1, x1 = t;
    }

    domain[i0] = interval.floor(x0);
    domain[i1] = interval.ceil(x1);
    return domain;
  }

  function transformLog(x) {
    return Math.log(x);
  }

  function transformExp(x) {
    return Math.exp(x);
  }

  function transformLogn(x) {
    return -Math.log(-x);
  }

  function transformExpn(x) {
    return -Math.exp(-x);
  }

  function pow10(x) {
    return isFinite(x) ? +("1e" + x) : x < 0 ? 0 : x;
  }

  function powp(base) {
    return base === 10 ? pow10 : base === Math.E ? Math.exp : function (x) {
      return Math.pow(base, x);
    };
  }

  function logp(base) {
    return base === Math.E ? Math.log : base === 10 && Math.log10 || base === 2 && Math.log2 || (base = Math.log(base), function (x) {
      return Math.log(x) / base;
    });
  }

  function reflect(f) {
    return function (x) {
      return -f(-x);
    };
  }

  function loggish(transform) {
    var scale = transform(transformLog, transformExp),
        domain = scale.domain,
        base = 10,
        logs,
        pows;

    function rescale() {
      logs = logp(base), pows = powp(base);

      if (domain()[0] < 0) {
        logs = reflect(logs), pows = reflect(pows);
        transform(transformLogn, transformExpn);
      } else {
        transform(transformLog, transformExp);
      }

      return scale;
    }

    scale.base = function (_) {
      return arguments.length ? (base = +_, rescale()) : base;
    };

    scale.domain = function (_) {
      return arguments.length ? (domain(_), rescale()) : domain();
    };

    scale.ticks = function (count) {
      var d = domain(),
          u = d[0],
          v = d[d.length - 1],
          r;
      if (r = v < u) i = u, u = v, v = i;
      var i = logs(u),
          j = logs(v),
          p,
          k,
          t,
          n = count == null ? 10 : +count,
          z = [];

      if (!(base % 1) && j - i < n) {
        i = Math.floor(i), j = Math.ceil(j);
        if (u > 0) for (; i <= j; ++i) {
          for (k = 1, p = pows(i); k < base; ++k) {
            t = p * k;
            if (t < u) continue;
            if (t > v) break;
            z.push(t);
          }
        } else for (; i <= j; ++i) {
          for (k = base - 1, p = pows(i); k >= 1; --k) {
            t = p * k;
            if (t < u) continue;
            if (t > v) break;
            z.push(t);
          }
        }
        if (z.length * 2 < n) z = ticks(u, v, n);
      } else {
        z = ticks(i, j, Math.min(j - i, n)).map(pows);
      }

      return r ? z.reverse() : z;
    };

    scale.tickFormat = function (count, specifier) {
      if (specifier == null) specifier = base === 10 ? ".0e" : ",";
      if (typeof specifier !== "function") specifier = format(specifier);
      if (count === Infinity) return specifier;
      if (count == null) count = 10;
      var k = Math.max(1, base * count / scale.ticks().length); // TODO fast estimate?

      return function (d) {
        var i = d / pows(Math.round(logs(d)));
        if (i * base < base - 0.5) i *= base;
        return i <= k ? specifier(d) : "";
      };
    };

    scale.nice = function () {
      return domain(nice(domain(), {
        floor: function (x) {
          return pows(Math.floor(logs(x)));
        },
        ceil: function (x) {
          return pows(Math.ceil(logs(x)));
        }
      }));
    };

    return scale;
  }
  function log() {
    var scale = loggish(transformer()).domain([1, 10]);

    scale.copy = function () {
      return copy(scale, log()).base(scale.base());
    };

    initRange.apply(scale, arguments);
    return scale;
  }

  var t0 = new Date(),
      t1 = new Date();
  function newInterval(floori, offseti, count, field) {
    function interval(date) {
      return floori(date = arguments.length === 0 ? new Date() : new Date(+date)), date;
    }

    interval.floor = function (date) {
      return floori(date = new Date(+date)), date;
    };

    interval.ceil = function (date) {
      return floori(date = new Date(date - 1)), offseti(date, 1), floori(date), date;
    };

    interval.round = function (date) {
      var d0 = interval(date),
          d1 = interval.ceil(date);
      return date - d0 < d1 - date ? d0 : d1;
    };

    interval.offset = function (date, step) {
      return offseti(date = new Date(+date), step == null ? 1 : Math.floor(step)), date;
    };

    interval.range = function (start, stop, step) {
      var range = [],
          previous;
      start = interval.ceil(start);
      step = step == null ? 1 : Math.floor(step);
      if (!(start < stop) || !(step > 0)) return range; // also handles Invalid Date

      do range.push(previous = new Date(+start)), offseti(start, step), floori(start); while (previous < start && start < stop);

      return range;
    };

    interval.filter = function (test) {
      return newInterval(function (date) {
        if (date >= date) while (floori(date), !test(date)) date.setTime(date - 1);
      }, function (date, step) {
        if (date >= date) {
          if (step < 0) while (++step <= 0) {
            while (offseti(date, -1), !test(date)) {} // eslint-disable-line no-empty

          } else while (--step >= 0) {
            while (offseti(date, +1), !test(date)) {} // eslint-disable-line no-empty

          }
        }
      });
    };

    if (count) {
      interval.count = function (start, end) {
        t0.setTime(+start), t1.setTime(+end);
        floori(t0), floori(t1);
        return Math.floor(count(t0, t1));
      };

      interval.every = function (step) {
        step = Math.floor(step);
        return !isFinite(step) || !(step > 0) ? null : !(step > 1) ? interval : interval.filter(field ? function (d) {
          return field(d) % step === 0;
        } : function (d) {
          return interval.count(0, d) % step === 0;
        });
      };
    }

    return interval;
  }

  var millisecond = newInterval(function () {// noop
  }, function (date, step) {
    date.setTime(+date + step);
  }, function (start, end) {
    return end - start;
  }); // An optimized implementation for this simple case.

  millisecond.every = function (k) {
    k = Math.floor(k);
    if (!isFinite(k) || !(k > 0)) return null;
    if (!(k > 1)) return millisecond;
    return newInterval(function (date) {
      date.setTime(Math.floor(date / k) * k);
    }, function (date, step) {
      date.setTime(+date + step * k);
    }, function (start, end) {
      return (end - start) / k;
    });
  };

  const durationSecond = 1000;
  const durationMinute = durationSecond * 60;
  const durationHour = durationMinute * 60;
  const durationDay = durationHour * 24;
  const durationWeek = durationDay * 7;
  const durationMonth = durationDay * 30;
  const durationYear = durationDay * 365;

  var second = newInterval(function (date) {
    date.setTime(date - date.getMilliseconds());
  }, function (date, step) {
    date.setTime(+date + step * durationSecond);
  }, function (start, end) {
    return (end - start) / durationSecond;
  }, function (date) {
    return date.getUTCSeconds();
  });

  var minute = newInterval(function (date) {
    date.setTime(date - date.getMilliseconds() - date.getSeconds() * durationSecond);
  }, function (date, step) {
    date.setTime(+date + step * durationMinute);
  }, function (start, end) {
    return (end - start) / durationMinute;
  }, function (date) {
    return date.getMinutes();
  });

  var hour = newInterval(function (date) {
    date.setTime(date - date.getMilliseconds() - date.getSeconds() * durationSecond - date.getMinutes() * durationMinute);
  }, function (date, step) {
    date.setTime(+date + step * durationHour);
  }, function (start, end) {
    return (end - start) / durationHour;
  }, function (date) {
    return date.getHours();
  });

  var day = newInterval(date => date.setHours(0, 0, 0, 0), (date, step) => date.setDate(date.getDate() + step), (start, end) => (end - start - (end.getTimezoneOffset() - start.getTimezoneOffset()) * durationMinute) / durationDay, date => date.getDate() - 1);

  function weekday(i) {
    return newInterval(function (date) {
      date.setDate(date.getDate() - (date.getDay() + 7 - i) % 7);
      date.setHours(0, 0, 0, 0);
    }, function (date, step) {
      date.setDate(date.getDate() + step * 7);
    }, function (start, end) {
      return (end - start - (end.getTimezoneOffset() - start.getTimezoneOffset()) * durationMinute) / durationWeek;
    });
  }

  var sunday = weekday(0);
  var monday = weekday(1);
  weekday(2);
  weekday(3);
  var thursday = weekday(4);
  weekday(5);
  weekday(6);

  var month = newInterval(function (date) {
    date.setDate(1);
    date.setHours(0, 0, 0, 0);
  }, function (date, step) {
    date.setMonth(date.getMonth() + step);
  }, function (start, end) {
    return end.getMonth() - start.getMonth() + (end.getFullYear() - start.getFullYear()) * 12;
  }, function (date) {
    return date.getMonth();
  });

  var year = newInterval(function (date) {
    date.setMonth(0, 1);
    date.setHours(0, 0, 0, 0);
  }, function (date, step) {
    date.setFullYear(date.getFullYear() + step);
  }, function (start, end) {
    return end.getFullYear() - start.getFullYear();
  }, function (date) {
    return date.getFullYear();
  }); // An optimized implementation for this simple case.

  year.every = function (k) {
    return !isFinite(k = Math.floor(k)) || !(k > 0) ? null : newInterval(function (date) {
      date.setFullYear(Math.floor(date.getFullYear() / k) * k);
      date.setMonth(0, 1);
      date.setHours(0, 0, 0, 0);
    }, function (date, step) {
      date.setFullYear(date.getFullYear() + step * k);
    });
  };

  var utcMinute = newInterval(function (date) {
    date.setUTCSeconds(0, 0);
  }, function (date, step) {
    date.setTime(+date + step * durationMinute);
  }, function (start, end) {
    return (end - start) / durationMinute;
  }, function (date) {
    return date.getUTCMinutes();
  });

  var utcHour = newInterval(function (date) {
    date.setUTCMinutes(0, 0, 0);
  }, function (date, step) {
    date.setTime(+date + step * durationHour);
  }, function (start, end) {
    return (end - start) / durationHour;
  }, function (date) {
    return date.getUTCHours();
  });

  var utcDay = newInterval(function (date) {
    date.setUTCHours(0, 0, 0, 0);
  }, function (date, step) {
    date.setUTCDate(date.getUTCDate() + step);
  }, function (start, end) {
    return (end - start) / durationDay;
  }, function (date) {
    return date.getUTCDate() - 1;
  });

  function utcWeekday(i) {
    return newInterval(function (date) {
      date.setUTCDate(date.getUTCDate() - (date.getUTCDay() + 7 - i) % 7);
      date.setUTCHours(0, 0, 0, 0);
    }, function (date, step) {
      date.setUTCDate(date.getUTCDate() + step * 7);
    }, function (start, end) {
      return (end - start) / durationWeek;
    });
  }

  var utcSunday = utcWeekday(0);
  var utcMonday = utcWeekday(1);
  utcWeekday(2);
  utcWeekday(3);
  var utcThursday = utcWeekday(4);
  utcWeekday(5);
  utcWeekday(6);

  var utcMonth = newInterval(function (date) {
    date.setUTCDate(1);
    date.setUTCHours(0, 0, 0, 0);
  }, function (date, step) {
    date.setUTCMonth(date.getUTCMonth() + step);
  }, function (start, end) {
    return end.getUTCMonth() - start.getUTCMonth() + (end.getUTCFullYear() - start.getUTCFullYear()) * 12;
  }, function (date) {
    return date.getUTCMonth();
  });

  var utcYear = newInterval(function (date) {
    date.setUTCMonth(0, 1);
    date.setUTCHours(0, 0, 0, 0);
  }, function (date, step) {
    date.setUTCFullYear(date.getUTCFullYear() + step);
  }, function (start, end) {
    return end.getUTCFullYear() - start.getUTCFullYear();
  }, function (date) {
    return date.getUTCFullYear();
  }); // An optimized implementation for this simple case.

  utcYear.every = function (k) {
    return !isFinite(k = Math.floor(k)) || !(k > 0) ? null : newInterval(function (date) {
      date.setUTCFullYear(Math.floor(date.getUTCFullYear() / k) * k);
      date.setUTCMonth(0, 1);
      date.setUTCHours(0, 0, 0, 0);
    }, function (date, step) {
      date.setUTCFullYear(date.getUTCFullYear() + step * k);
    });
  };

  function ticker(year, month, week, day, hour, minute) {
    const tickIntervals = [[second, 1, durationSecond], [second, 5, 5 * durationSecond], [second, 15, 15 * durationSecond], [second, 30, 30 * durationSecond], [minute, 1, durationMinute], [minute, 5, 5 * durationMinute], [minute, 15, 15 * durationMinute], [minute, 30, 30 * durationMinute], [hour, 1, durationHour], [hour, 3, 3 * durationHour], [hour, 6, 6 * durationHour], [hour, 12, 12 * durationHour], [day, 1, durationDay], [day, 2, 2 * durationDay], [week, 1, durationWeek], [month, 1, durationMonth], [month, 3, 3 * durationMonth], [year, 1, durationYear]];

    function ticks(start, stop, count) {
      const reverse = stop < start;
      if (reverse) [start, stop] = [stop, start];
      const interval = count && typeof count.range === "function" ? count : tickInterval(start, stop, count);
      const ticks = interval ? interval.range(start, +stop + 1) : []; // inclusive stop

      return reverse ? ticks.reverse() : ticks;
    }

    function tickInterval(start, stop, count) {
      const target = Math.abs(stop - start) / count;
      const i = bisector(([,, step]) => step).right(tickIntervals, target);
      if (i === tickIntervals.length) return year.every(tickStep(start / durationYear, stop / durationYear, count));
      if (i === 0) return millisecond.every(Math.max(tickStep(start, stop, count), 1));
      const [t, step] = tickIntervals[target / tickIntervals[i - 1][2] < tickIntervals[i][2] / target ? i - 1 : i];
      return t.every(step);
    }

    return [ticks, tickInterval];
  }

  const [utcTicks, utcTickInterval] = ticker(utcYear, utcMonth, utcSunday, utcDay, utcHour, utcMinute);
  const [timeTicks, timeTickInterval] = ticker(year, month, sunday, day, hour, minute);

  function localDate(d) {
    if (0 <= d.y && d.y < 100) {
      var date = new Date(-1, d.m, d.d, d.H, d.M, d.S, d.L);
      date.setFullYear(d.y);
      return date;
    }

    return new Date(d.y, d.m, d.d, d.H, d.M, d.S, d.L);
  }

  function utcDate(d) {
    if (0 <= d.y && d.y < 100) {
      var date = new Date(Date.UTC(-1, d.m, d.d, d.H, d.M, d.S, d.L));
      date.setUTCFullYear(d.y);
      return date;
    }

    return new Date(Date.UTC(d.y, d.m, d.d, d.H, d.M, d.S, d.L));
  }

  function newDate(y, m, d) {
    return {
      y: y,
      m: m,
      d: d,
      H: 0,
      M: 0,
      S: 0,
      L: 0
    };
  }

  function formatLocale(locale) {
    var locale_dateTime = locale.dateTime,
        locale_date = locale.date,
        locale_time = locale.time,
        locale_periods = locale.periods,
        locale_weekdays = locale.days,
        locale_shortWeekdays = locale.shortDays,
        locale_months = locale.months,
        locale_shortMonths = locale.shortMonths;
    var periodRe = formatRe(locale_periods),
        periodLookup = formatLookup(locale_periods),
        weekdayRe = formatRe(locale_weekdays),
        weekdayLookup = formatLookup(locale_weekdays),
        shortWeekdayRe = formatRe(locale_shortWeekdays),
        shortWeekdayLookup = formatLookup(locale_shortWeekdays),
        monthRe = formatRe(locale_months),
        monthLookup = formatLookup(locale_months),
        shortMonthRe = formatRe(locale_shortMonths),
        shortMonthLookup = formatLookup(locale_shortMonths);
    var formats = {
      "a": formatShortWeekday,
      "A": formatWeekday,
      "b": formatShortMonth,
      "B": formatMonth,
      "c": null,
      "d": formatDayOfMonth,
      "e": formatDayOfMonth,
      "f": formatMicroseconds,
      "g": formatYearISO,
      "G": formatFullYearISO,
      "H": formatHour24,
      "I": formatHour12,
      "j": formatDayOfYear,
      "L": formatMilliseconds,
      "m": formatMonthNumber,
      "M": formatMinutes,
      "p": formatPeriod,
      "q": formatQuarter,
      "Q": formatUnixTimestamp,
      "s": formatUnixTimestampSeconds,
      "S": formatSeconds,
      "u": formatWeekdayNumberMonday,
      "U": formatWeekNumberSunday,
      "V": formatWeekNumberISO,
      "w": formatWeekdayNumberSunday,
      "W": formatWeekNumberMonday,
      "x": null,
      "X": null,
      "y": formatYear,
      "Y": formatFullYear,
      "Z": formatZone,
      "%": formatLiteralPercent
    };
    var utcFormats = {
      "a": formatUTCShortWeekday,
      "A": formatUTCWeekday,
      "b": formatUTCShortMonth,
      "B": formatUTCMonth,
      "c": null,
      "d": formatUTCDayOfMonth,
      "e": formatUTCDayOfMonth,
      "f": formatUTCMicroseconds,
      "g": formatUTCYearISO,
      "G": formatUTCFullYearISO,
      "H": formatUTCHour24,
      "I": formatUTCHour12,
      "j": formatUTCDayOfYear,
      "L": formatUTCMilliseconds,
      "m": formatUTCMonthNumber,
      "M": formatUTCMinutes,
      "p": formatUTCPeriod,
      "q": formatUTCQuarter,
      "Q": formatUnixTimestamp,
      "s": formatUnixTimestampSeconds,
      "S": formatUTCSeconds,
      "u": formatUTCWeekdayNumberMonday,
      "U": formatUTCWeekNumberSunday,
      "V": formatUTCWeekNumberISO,
      "w": formatUTCWeekdayNumberSunday,
      "W": formatUTCWeekNumberMonday,
      "x": null,
      "X": null,
      "y": formatUTCYear,
      "Y": formatUTCFullYear,
      "Z": formatUTCZone,
      "%": formatLiteralPercent
    };
    var parses = {
      "a": parseShortWeekday,
      "A": parseWeekday,
      "b": parseShortMonth,
      "B": parseMonth,
      "c": parseLocaleDateTime,
      "d": parseDayOfMonth,
      "e": parseDayOfMonth,
      "f": parseMicroseconds,
      "g": parseYear,
      "G": parseFullYear,
      "H": parseHour24,
      "I": parseHour24,
      "j": parseDayOfYear,
      "L": parseMilliseconds,
      "m": parseMonthNumber,
      "M": parseMinutes,
      "p": parsePeriod,
      "q": parseQuarter,
      "Q": parseUnixTimestamp,
      "s": parseUnixTimestampSeconds,
      "S": parseSeconds,
      "u": parseWeekdayNumberMonday,
      "U": parseWeekNumberSunday,
      "V": parseWeekNumberISO,
      "w": parseWeekdayNumberSunday,
      "W": parseWeekNumberMonday,
      "x": parseLocaleDate,
      "X": parseLocaleTime,
      "y": parseYear,
      "Y": parseFullYear,
      "Z": parseZone,
      "%": parseLiteralPercent
    }; // These recursive directive definitions must be deferred.

    formats.x = newFormat(locale_date, formats);
    formats.X = newFormat(locale_time, formats);
    formats.c = newFormat(locale_dateTime, formats);
    utcFormats.x = newFormat(locale_date, utcFormats);
    utcFormats.X = newFormat(locale_time, utcFormats);
    utcFormats.c = newFormat(locale_dateTime, utcFormats);

    function newFormat(specifier, formats) {
      return function (date) {
        var string = [],
            i = -1,
            j = 0,
            n = specifier.length,
            c,
            pad,
            format;
        if (!(date instanceof Date)) date = new Date(+date);

        while (++i < n) {
          if (specifier.charCodeAt(i) === 37) {
            string.push(specifier.slice(j, i));
            if ((pad = pads[c = specifier.charAt(++i)]) != null) c = specifier.charAt(++i);else pad = c === "e" ? " " : "0";
            if (format = formats[c]) c = format(date, pad);
            string.push(c);
            j = i + 1;
          }
        }

        string.push(specifier.slice(j, i));
        return string.join("");
      };
    }

    function newParse(specifier, Z) {
      return function (string) {
        var d = newDate(1900, undefined, 1),
            i = parseSpecifier(d, specifier, string += "", 0),
            week,
            day$1;
        if (i != string.length) return null; // If a UNIX timestamp is specified, return it.

        if ("Q" in d) return new Date(d.Q);
        if ("s" in d) return new Date(d.s * 1000 + ("L" in d ? d.L : 0)); // If this is utcParse, never use the local timezone.

        if (Z && !("Z" in d)) d.Z = 0; // The am-pm flag is 0 for AM, and 1 for PM.

        if ("p" in d) d.H = d.H % 12 + d.p * 12; // If the month was not specified, inherit from the quarter.

        if (d.m === undefined) d.m = "q" in d ? d.q : 0; // Convert day-of-week and week-of-year to day-of-year.

        if ("V" in d) {
          if (d.V < 1 || d.V > 53) return null;
          if (!("w" in d)) d.w = 1;

          if ("Z" in d) {
            week = utcDate(newDate(d.y, 0, 1)), day$1 = week.getUTCDay();
            week = day$1 > 4 || day$1 === 0 ? utcMonday.ceil(week) : utcMonday(week);
            week = utcDay.offset(week, (d.V - 1) * 7);
            d.y = week.getUTCFullYear();
            d.m = week.getUTCMonth();
            d.d = week.getUTCDate() + (d.w + 6) % 7;
          } else {
            week = localDate(newDate(d.y, 0, 1)), day$1 = week.getDay();
            week = day$1 > 4 || day$1 === 0 ? monday.ceil(week) : monday(week);
            week = day.offset(week, (d.V - 1) * 7);
            d.y = week.getFullYear();
            d.m = week.getMonth();
            d.d = week.getDate() + (d.w + 6) % 7;
          }
        } else if ("W" in d || "U" in d) {
          if (!("w" in d)) d.w = "u" in d ? d.u % 7 : "W" in d ? 1 : 0;
          day$1 = "Z" in d ? utcDate(newDate(d.y, 0, 1)).getUTCDay() : localDate(newDate(d.y, 0, 1)).getDay();
          d.m = 0;
          d.d = "W" in d ? (d.w + 6) % 7 + d.W * 7 - (day$1 + 5) % 7 : d.w + d.U * 7 - (day$1 + 6) % 7;
        } // If a time zone is specified, all fields are interpreted as UTC and then
        // offset according to the specified time zone.


        if ("Z" in d) {
          d.H += d.Z / 100 | 0;
          d.M += d.Z % 100;
          return utcDate(d);
        } // Otherwise, all fields are in local time.


        return localDate(d);
      };
    }

    function parseSpecifier(d, specifier, string, j) {
      var i = 0,
          n = specifier.length,
          m = string.length,
          c,
          parse;

      while (i < n) {
        if (j >= m) return -1;
        c = specifier.charCodeAt(i++);

        if (c === 37) {
          c = specifier.charAt(i++);
          parse = parses[c in pads ? specifier.charAt(i++) : c];
          if (!parse || (j = parse(d, string, j)) < 0) return -1;
        } else if (c != string.charCodeAt(j++)) {
          return -1;
        }
      }

      return j;
    }

    function parsePeriod(d, string, i) {
      var n = periodRe.exec(string.slice(i));
      return n ? (d.p = periodLookup.get(n[0].toLowerCase()), i + n[0].length) : -1;
    }

    function parseShortWeekday(d, string, i) {
      var n = shortWeekdayRe.exec(string.slice(i));
      return n ? (d.w = shortWeekdayLookup.get(n[0].toLowerCase()), i + n[0].length) : -1;
    }

    function parseWeekday(d, string, i) {
      var n = weekdayRe.exec(string.slice(i));
      return n ? (d.w = weekdayLookup.get(n[0].toLowerCase()), i + n[0].length) : -1;
    }

    function parseShortMonth(d, string, i) {
      var n = shortMonthRe.exec(string.slice(i));
      return n ? (d.m = shortMonthLookup.get(n[0].toLowerCase()), i + n[0].length) : -1;
    }

    function parseMonth(d, string, i) {
      var n = monthRe.exec(string.slice(i));
      return n ? (d.m = monthLookup.get(n[0].toLowerCase()), i + n[0].length) : -1;
    }

    function parseLocaleDateTime(d, string, i) {
      return parseSpecifier(d, locale_dateTime, string, i);
    }

    function parseLocaleDate(d, string, i) {
      return parseSpecifier(d, locale_date, string, i);
    }

    function parseLocaleTime(d, string, i) {
      return parseSpecifier(d, locale_time, string, i);
    }

    function formatShortWeekday(d) {
      return locale_shortWeekdays[d.getDay()];
    }

    function formatWeekday(d) {
      return locale_weekdays[d.getDay()];
    }

    function formatShortMonth(d) {
      return locale_shortMonths[d.getMonth()];
    }

    function formatMonth(d) {
      return locale_months[d.getMonth()];
    }

    function formatPeriod(d) {
      return locale_periods[+(d.getHours() >= 12)];
    }

    function formatQuarter(d) {
      return 1 + ~~(d.getMonth() / 3);
    }

    function formatUTCShortWeekday(d) {
      return locale_shortWeekdays[d.getUTCDay()];
    }

    function formatUTCWeekday(d) {
      return locale_weekdays[d.getUTCDay()];
    }

    function formatUTCShortMonth(d) {
      return locale_shortMonths[d.getUTCMonth()];
    }

    function formatUTCMonth(d) {
      return locale_months[d.getUTCMonth()];
    }

    function formatUTCPeriod(d) {
      return locale_periods[+(d.getUTCHours() >= 12)];
    }

    function formatUTCQuarter(d) {
      return 1 + ~~(d.getUTCMonth() / 3);
    }

    return {
      format: function (specifier) {
        var f = newFormat(specifier += "", formats);

        f.toString = function () {
          return specifier;
        };

        return f;
      },
      parse: function (specifier) {
        var p = newParse(specifier += "", false);

        p.toString = function () {
          return specifier;
        };

        return p;
      },
      utcFormat: function (specifier) {
        var f = newFormat(specifier += "", utcFormats);

        f.toString = function () {
          return specifier;
        };

        return f;
      },
      utcParse: function (specifier) {
        var p = newParse(specifier += "", true);

        p.toString = function () {
          return specifier;
        };

        return p;
      }
    };
  }
  var pads = {
    "-": "",
    "_": " ",
    "0": "0"
  },
      numberRe = /^\s*\d+/,
      // note: ignores next directive
  percentRe = /^%/,
      requoteRe = /[\\^$*+?|[\]().{}]/g;

  function pad(value, fill, width) {
    var sign = value < 0 ? "-" : "",
        string = (sign ? -value : value) + "",
        length = string.length;
    return sign + (length < width ? new Array(width - length + 1).join(fill) + string : string);
  }

  function requote(s) {
    return s.replace(requoteRe, "\\$&");
  }

  function formatRe(names) {
    return new RegExp("^(?:" + names.map(requote).join("|") + ")", "i");
  }

  function formatLookup(names) {
    return new Map(names.map((name, i) => [name.toLowerCase(), i]));
  }

  function parseWeekdayNumberSunday(d, string, i) {
    var n = numberRe.exec(string.slice(i, i + 1));
    return n ? (d.w = +n[0], i + n[0].length) : -1;
  }

  function parseWeekdayNumberMonday(d, string, i) {
    var n = numberRe.exec(string.slice(i, i + 1));
    return n ? (d.u = +n[0], i + n[0].length) : -1;
  }

  function parseWeekNumberSunday(d, string, i) {
    var n = numberRe.exec(string.slice(i, i + 2));
    return n ? (d.U = +n[0], i + n[0].length) : -1;
  }

  function parseWeekNumberISO(d, string, i) {
    var n = numberRe.exec(string.slice(i, i + 2));
    return n ? (d.V = +n[0], i + n[0].length) : -1;
  }

  function parseWeekNumberMonday(d, string, i) {
    var n = numberRe.exec(string.slice(i, i + 2));
    return n ? (d.W = +n[0], i + n[0].length) : -1;
  }

  function parseFullYear(d, string, i) {
    var n = numberRe.exec(string.slice(i, i + 4));
    return n ? (d.y = +n[0], i + n[0].length) : -1;
  }

  function parseYear(d, string, i) {
    var n = numberRe.exec(string.slice(i, i + 2));
    return n ? (d.y = +n[0] + (+n[0] > 68 ? 1900 : 2000), i + n[0].length) : -1;
  }

  function parseZone(d, string, i) {
    var n = /^(Z)|([+-]\d\d)(?::?(\d\d))?/.exec(string.slice(i, i + 6));
    return n ? (d.Z = n[1] ? 0 : -(n[2] + (n[3] || "00")), i + n[0].length) : -1;
  }

  function parseQuarter(d, string, i) {
    var n = numberRe.exec(string.slice(i, i + 1));
    return n ? (d.q = n[0] * 3 - 3, i + n[0].length) : -1;
  }

  function parseMonthNumber(d, string, i) {
    var n = numberRe.exec(string.slice(i, i + 2));
    return n ? (d.m = n[0] - 1, i + n[0].length) : -1;
  }

  function parseDayOfMonth(d, string, i) {
    var n = numberRe.exec(string.slice(i, i + 2));
    return n ? (d.d = +n[0], i + n[0].length) : -1;
  }

  function parseDayOfYear(d, string, i) {
    var n = numberRe.exec(string.slice(i, i + 3));
    return n ? (d.m = 0, d.d = +n[0], i + n[0].length) : -1;
  }

  function parseHour24(d, string, i) {
    var n = numberRe.exec(string.slice(i, i + 2));
    return n ? (d.H = +n[0], i + n[0].length) : -1;
  }

  function parseMinutes(d, string, i) {
    var n = numberRe.exec(string.slice(i, i + 2));
    return n ? (d.M = +n[0], i + n[0].length) : -1;
  }

  function parseSeconds(d, string, i) {
    var n = numberRe.exec(string.slice(i, i + 2));
    return n ? (d.S = +n[0], i + n[0].length) : -1;
  }

  function parseMilliseconds(d, string, i) {
    var n = numberRe.exec(string.slice(i, i + 3));
    return n ? (d.L = +n[0], i + n[0].length) : -1;
  }

  function parseMicroseconds(d, string, i) {
    var n = numberRe.exec(string.slice(i, i + 6));
    return n ? (d.L = Math.floor(n[0] / 1000), i + n[0].length) : -1;
  }

  function parseLiteralPercent(d, string, i) {
    var n = percentRe.exec(string.slice(i, i + 1));
    return n ? i + n[0].length : -1;
  }

  function parseUnixTimestamp(d, string, i) {
    var n = numberRe.exec(string.slice(i));
    return n ? (d.Q = +n[0], i + n[0].length) : -1;
  }

  function parseUnixTimestampSeconds(d, string, i) {
    var n = numberRe.exec(string.slice(i));
    return n ? (d.s = +n[0], i + n[0].length) : -1;
  }

  function formatDayOfMonth(d, p) {
    return pad(d.getDate(), p, 2);
  }

  function formatHour24(d, p) {
    return pad(d.getHours(), p, 2);
  }

  function formatHour12(d, p) {
    return pad(d.getHours() % 12 || 12, p, 2);
  }

  function formatDayOfYear(d, p) {
    return pad(1 + day.count(year(d), d), p, 3);
  }

  function formatMilliseconds(d, p) {
    return pad(d.getMilliseconds(), p, 3);
  }

  function formatMicroseconds(d, p) {
    return formatMilliseconds(d, p) + "000";
  }

  function formatMonthNumber(d, p) {
    return pad(d.getMonth() + 1, p, 2);
  }

  function formatMinutes(d, p) {
    return pad(d.getMinutes(), p, 2);
  }

  function formatSeconds(d, p) {
    return pad(d.getSeconds(), p, 2);
  }

  function formatWeekdayNumberMonday(d) {
    var day = d.getDay();
    return day === 0 ? 7 : day;
  }

  function formatWeekNumberSunday(d, p) {
    return pad(sunday.count(year(d) - 1, d), p, 2);
  }

  function dISO(d) {
    var day = d.getDay();
    return day >= 4 || day === 0 ? thursday(d) : thursday.ceil(d);
  }

  function formatWeekNumberISO(d, p) {
    d = dISO(d);
    return pad(thursday.count(year(d), d) + (year(d).getDay() === 4), p, 2);
  }

  function formatWeekdayNumberSunday(d) {
    return d.getDay();
  }

  function formatWeekNumberMonday(d, p) {
    return pad(monday.count(year(d) - 1, d), p, 2);
  }

  function formatYear(d, p) {
    return pad(d.getFullYear() % 100, p, 2);
  }

  function formatYearISO(d, p) {
    d = dISO(d);
    return pad(d.getFullYear() % 100, p, 2);
  }

  function formatFullYear(d, p) {
    return pad(d.getFullYear() % 10000, p, 4);
  }

  function formatFullYearISO(d, p) {
    var day = d.getDay();
    d = day >= 4 || day === 0 ? thursday(d) : thursday.ceil(d);
    return pad(d.getFullYear() % 10000, p, 4);
  }

  function formatZone(d) {
    var z = d.getTimezoneOffset();
    return (z > 0 ? "-" : (z *= -1, "+")) + pad(z / 60 | 0, "0", 2) + pad(z % 60, "0", 2);
  }

  function formatUTCDayOfMonth(d, p) {
    return pad(d.getUTCDate(), p, 2);
  }

  function formatUTCHour24(d, p) {
    return pad(d.getUTCHours(), p, 2);
  }

  function formatUTCHour12(d, p) {
    return pad(d.getUTCHours() % 12 || 12, p, 2);
  }

  function formatUTCDayOfYear(d, p) {
    return pad(1 + utcDay.count(utcYear(d), d), p, 3);
  }

  function formatUTCMilliseconds(d, p) {
    return pad(d.getUTCMilliseconds(), p, 3);
  }

  function formatUTCMicroseconds(d, p) {
    return formatUTCMilliseconds(d, p) + "000";
  }

  function formatUTCMonthNumber(d, p) {
    return pad(d.getUTCMonth() + 1, p, 2);
  }

  function formatUTCMinutes(d, p) {
    return pad(d.getUTCMinutes(), p, 2);
  }

  function formatUTCSeconds(d, p) {
    return pad(d.getUTCSeconds(), p, 2);
  }

  function formatUTCWeekdayNumberMonday(d) {
    var dow = d.getUTCDay();
    return dow === 0 ? 7 : dow;
  }

  function formatUTCWeekNumberSunday(d, p) {
    return pad(utcSunday.count(utcYear(d) - 1, d), p, 2);
  }

  function UTCdISO(d) {
    var day = d.getUTCDay();
    return day >= 4 || day === 0 ? utcThursday(d) : utcThursday.ceil(d);
  }

  function formatUTCWeekNumberISO(d, p) {
    d = UTCdISO(d);
    return pad(utcThursday.count(utcYear(d), d) + (utcYear(d).getUTCDay() === 4), p, 2);
  }

  function formatUTCWeekdayNumberSunday(d) {
    return d.getUTCDay();
  }

  function formatUTCWeekNumberMonday(d, p) {
    return pad(utcMonday.count(utcYear(d) - 1, d), p, 2);
  }

  function formatUTCYear(d, p) {
    return pad(d.getUTCFullYear() % 100, p, 2);
  }

  function formatUTCYearISO(d, p) {
    d = UTCdISO(d);
    return pad(d.getUTCFullYear() % 100, p, 2);
  }

  function formatUTCFullYear(d, p) {
    return pad(d.getUTCFullYear() % 10000, p, 4);
  }

  function formatUTCFullYearISO(d, p) {
    var day = d.getUTCDay();
    d = day >= 4 || day === 0 ? utcThursday(d) : utcThursday.ceil(d);
    return pad(d.getUTCFullYear() % 10000, p, 4);
  }

  function formatUTCZone() {
    return "+0000";
  }

  function formatLiteralPercent() {
    return "%";
  }

  function formatUnixTimestamp(d) {
    return +d;
  }

  function formatUnixTimestampSeconds(d) {
    return Math.floor(+d / 1000);
  }

  var locale;
  var timeFormat;
  var utcFormat;
  defaultLocale({
    dateTime: "%x, %X",
    date: "%-m/%-d/%Y",
    time: "%-I:%M:%S %p",
    periods: ["AM", "PM"],
    days: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
    shortDays: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"],
    months: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"],
    shortMonths: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"]
  });
  function defaultLocale(definition) {
    locale = formatLocale(definition);
    timeFormat = locale.format;
    utcFormat = locale.utcFormat;
    return locale;
  }

  function date(t) {
    return new Date(t);
  }

  function number(t) {
    return t instanceof Date ? +t : +new Date(+t);
  }

  function calendar(ticks, tickInterval, year, month, week, day, hour, minute, second, format) {
    var scale = continuous(),
        invert = scale.invert,
        domain = scale.domain;
    var formatMillisecond = format(".%L"),
        formatSecond = format(":%S"),
        formatMinute = format("%I:%M"),
        formatHour = format("%I %p"),
        formatDay = format("%a %d"),
        formatWeek = format("%b %d"),
        formatMonth = format("%B"),
        formatYear = format("%Y");

    function tickFormat(date) {
      return (second(date) < date ? formatMillisecond : minute(date) < date ? formatSecond : hour(date) < date ? formatMinute : day(date) < date ? formatHour : month(date) < date ? week(date) < date ? formatDay : formatWeek : year(date) < date ? formatMonth : formatYear)(date);
    }

    scale.invert = function (y) {
      return new Date(invert(y));
    };

    scale.domain = function (_) {
      return arguments.length ? domain(Array.from(_, number)) : domain().map(date);
    };

    scale.ticks = function (interval) {
      var d = domain();
      return ticks(d[0], d[d.length - 1], interval == null ? 10 : interval);
    };

    scale.tickFormat = function (count, specifier) {
      return specifier == null ? tickFormat : format(specifier);
    };

    scale.nice = function (interval) {
      var d = domain();
      if (!interval || typeof interval.range !== "function") interval = tickInterval(d[0], d[d.length - 1], interval == null ? 10 : interval);
      return interval ? domain(nice(d, interval)) : scale;
    };

    scale.copy = function () {
      return copy(scale, calendar(ticks, tickInterval, year, month, week, day, hour, minute, second, format));
    };

    return scale;
  }
  function time() {
    return initRange.apply(calendar(timeTicks, timeTickInterval, year, month, sunday, day, hour, minute, second, timeFormat).domain([new Date(2000, 0, 1), new Date(2000, 0, 2)]), arguments);
  }

  function utcTime() {
    return initRange.apply(calendar(utcTicks, utcTickInterval, utcYear, utcMonth, utcSunday, utcDay, utcHour, utcMinute, second, utcFormat).domain([Date.UTC(2000, 0, 1), Date.UTC(2000, 0, 2)]), arguments);
  }

  function defaultAxisOptions(options) {
    var _options$elementType, _options$minTickPaddi, _options$tickLabelRot, _options$innerBandPad, _options$outerBandPad, _options$show, _options$stacked;

    return _extends$3({}, options, {
      elementType: (_options$elementType = options.elementType) != null ? _options$elementType : 'line',
      // tickCount: options.tickCount ?? 10,
      // minTickCount: options.minTickCount ?? 1,
      // maxTickCount: options.maxTickCount ?? 99999999,
      // tickSizeInner: options.tickSizeInner ?? 6,
      // tickSizeOuter: options.tickSizeOuter ?? 6,
      minTickPaddingForRotation: (_options$minTickPaddi = options.minTickPaddingForRotation) != null ? _options$minTickPaddi : 10,
      tickLabelRotationDeg: (_options$tickLabelRot = options.tickLabelRotationDeg) != null ? _options$tickLabelRot : 60,
      innerBandPadding: (_options$innerBandPad = options.innerBandPadding) != null ? _options$innerBandPad : 0.6,
      outerBandPadding: (_options$outerBandPad = options.outerBandPadding) != null ? _options$outerBandPad : 0.2,
      // showTicks: options.showTicks ?? true,
      // filterTicks: options.filterTicks ?? (d => d),
      show: (_options$show = options.show) != null ? _options$show : true,
      stacked: (_options$stacked = options.stacked) != null ? _options$stacked : false
    });
  }

  function buildAxisLinear(userOptions, series, gridDimensions, width, height) {
    var options = defaultAxisOptions(userOptions);

    if (!options.position) {
      throw new Error("Chart axes must have a valid 'position' property");
    }

    var isVertical = ['left', 'right'].indexOf(options.position) > -1; // Now we need to figure out the range

    var range = isVertical ? [gridDimensions.gridHeight, 0] : [0, gridDimensions.gridWidth];
    var outerRange = isVertical ? [height, 0] : [0, width]; // Give the scale a home

    return options.scaleType === 'time' || options.scaleType === 'localTime' ? buildTimeAxis(options, series, isVertical, range, outerRange) : options.scaleType === 'linear' || options.scaleType === 'log' ? buildLinearAxis(options, series, isVertical, range, outerRange) : options.scaleType === 'band' ? buildBandAxis(options, series, isVertical, range, outerRange) : function () {
      throw new Error('Invalid scale type');
    }(); // @ts-ignore
    // const scaleFormat = scale.tickFormat ? scale.tickFormat() : d => d
    // const userFormat = options?.format
    // const format = userFormat
    //   ? (value: unknown, index: number) =>
    //       userFormat(value, index, scaleFormat(value))
    //   : scaleFormat
    // const resolvedTickCount = options.tickCount
    // const ticks = options.filterTicks(
    //   options.tickValues ||
    //     // @ts-ignore
    //     (scale.ticks ? scale.ticks(resolvedTickCount) : scale.domain())
    // )
    // const scaleMax =
    //   options.position === 'bottom'
    //     ? -gridDimensions.gridHeight
    //     : options.position === 'left'
    //     ? gridDimensions.gridWidth
    //     : options.position === 'top'
    //     ? gridDimensions.gridHeight
    //     : -gridDimensions.gridWidth
    // // const directionMultiplier =
    // //   options.position === 'top' || options.position === 'left' ? -1 : 1
    // const transform = !isVertical ? translateX : translateY
    // const tickSpacing = Math.max(options.tickSizeInner, 0) + options.tickPadding
    // Pass down the axis config (including the scale itself) for posterity
  }

  function buildTimeAxis(options, series, isVertical, range, outerRange) {
    var scaleFn = options.scaleType === 'localTime' ? time : utcTime; // Now set the range

    var scale = scaleFn(range);
    var allDatums = series.map(function (d) {
      return d.datums;
    }).flat();

    var _extent = extent(allDatums, function (datum) {
      return options.getValue(datum.originalDatum);
    }),
        minValue = _extent[0],
        maxValue = _extent[1];

    var shouldNice = true;

    if (typeof options.min === 'number') {
      minValue = min([options.min, minValue]);
      shouldNice = false;
    }

    if (typeof options.max === 'number') {
      maxValue = max([options.max, maxValue]);
      shouldNice = false;
    }

    if (typeof options.hardMin === 'number') {
      minValue = options.hardMin;
      shouldNice = false;
    }

    if (typeof options.hardMax === 'number') {
      maxValue = options.hardMax;
      shouldNice = false;
    }

    if (minValue === undefined || maxValue === undefined) {
      console.info({
        options: options,
        series: series,
        range: range,
        values: allDatums.map(function (d) {
          return options.getValue(d.originalDatum);
        })
      });
      throw new Error('Invalid scale min/max');
    } // Set the domain


    scale.domain([minValue, maxValue]);

    if (options.invert) {
      scale.domain(Array.from(scale.domain()).reverse());
    }

    if (shouldNice) {
      scale.nice();
    }

    var outerScale = scale.copy().range(outerRange); // Supplmentary band scale

    var bandScale = options.isPrimary ? buildImpliedBandScale(options, scale, series, range) : undefined;
    var defaultFormat = scale.tickFormat();
    var formatters = {};

    var scaleFormat = function scaleFormat(value) {
      var _options$formatters$s, _options$formatters;

      return (_options$formatters$s = (_options$formatters = options.formatters) == null ? void 0 : _options$formatters.scale == null ? void 0 : _options$formatters.scale(value, _extends$3({}, formatters, {
        scale: undefined
      }))) != null ? _options$formatters$s : defaultFormat(value);
    };

    var tooltipFormat = function tooltipFormat(value) {
      var _options$formatters$t, _options$formatters2;

      return (_options$formatters$t = (_options$formatters2 = options.formatters) == null ? void 0 : _options$formatters2.tooltip == null ? void 0 : _options$formatters2.tooltip(value, _extends$3({}, formatters, {
        tooltip: undefined
      }))) != null ? _options$formatters$t : scaleFormat(value);
    };

    var cursorFormat = function cursorFormat(value) {
      var _options$formatters$c, _options$formatters3;

      return (_options$formatters$c = (_options$formatters3 = options.formatters) == null ? void 0 : _options$formatters3.cursor == null ? void 0 : _options$formatters3.cursor(value, _extends$3({}, formatters, {
        cursor: undefined
      }))) != null ? _options$formatters$c : tooltipFormat(value);
    };

    Object.assign(formatters, {
      "default": defaultFormat,
      scale: scaleFormat,
      tooltip: tooltipFormat,
      cursor: cursorFormat
    });
    return _extends$3({}, options, {
      axisFamily: 'time',
      isVertical: isVertical,
      scale: scale,
      range: range,
      outerScale: outerScale,
      bandScale: bandScale,
      formatters: formatters
    });
  }

  function buildLinearAxis(options, series, isVertical, range, outerRange) {
    var scale = options.scaleType === 'log' ? log() : linear$1();
    var allDatums = series.map(function (d) {
      return d.datums;
    }).flat(2);

    var _ref = options.stacked ? extent(series.map(function (s) {
      return s.datums.map(function (datum) {
        var _datum$stackData;

        return (_datum$stackData = datum.stackData) != null ? _datum$stackData : [];
      });
    }).flat(2)) : extent(allDatums, function (datum) {
      return options.getValue(datum.originalDatum);
    }),
        minValue = _ref[0],
        maxValue = _ref[1];

    var shouldNice = true;

    if (typeof options.min === 'number') {
      minValue = min([options.min, minValue]);
      shouldNice = false;
    }

    if (typeof options.max === 'number') {
      maxValue = max([options.max, maxValue]);
      shouldNice = false;
    }

    if (typeof options.minDomainLength === 'number' && !(minValue === undefined || maxValue === undefined)) {
      var mid = median([minValue, maxValue]);
      var top = mid + options.minDomainLength / 2;
      var bottom = mid - options.minDomainLength / 2;
      maxValue = Math.max(top, maxValue);
      minValue = Math.min(bottom, minValue);
    }

    if (typeof options.hardMin === 'number') {
      minValue = options.hardMin;
      shouldNice = false;
    }

    if (typeof options.hardMax === 'number') {
      maxValue = options.hardMax;
      shouldNice = false;
    }

    if (minValue === undefined || maxValue === undefined) {
      console.info({
        options: options,
        series: series,
        range: range,
        values: allDatums.map(function (d) {
          return options.getValue(d.originalDatum);
        })
      });
      throw new Error('Invalid scale min/max');
    } // Set the domain


    scale.domain([minValue, maxValue]);

    if (options.invert) {
      scale.domain(Array.from(scale.domain()).reverse());
    }

    scale.range(range);

    if (shouldNice) {
      scale.nice();
    }

    var outerScale = scale.copy().range(outerRange);
    var bandScale = options.isPrimary ? buildImpliedBandScale(options, scale, series, range) : undefined;
    var defaultFormat = scale.tickFormat();
    var formatters = {};

    var scaleFormat = function scaleFormat(value) {
      var _options$formatters$s2, _options$formatters4;

      return (_options$formatters$s2 = (_options$formatters4 = options.formatters) == null ? void 0 : _options$formatters4.scale == null ? void 0 : _options$formatters4.scale(value, _extends$3({}, formatters, {
        scale: undefined
      }))) != null ? _options$formatters$s2 : defaultFormat(value);
    };

    var tooltipFormat = function tooltipFormat(value) {
      var _options$formatters$t2, _options$formatters5;

      return (_options$formatters$t2 = (_options$formatters5 = options.formatters) == null ? void 0 : _options$formatters5.tooltip == null ? void 0 : _options$formatters5.tooltip(value, _extends$3({}, formatters, {
        tooltip: undefined
      }))) != null ? _options$formatters$t2 : scaleFormat(value);
    };

    var cursorFormat = function cursorFormat(value) {
      var _options$formatters$c2, _options$formatters6;

      return (_options$formatters$c2 = (_options$formatters6 = options.formatters) == null ? void 0 : _options$formatters6.cursor == null ? void 0 : _options$formatters6.cursor(value, _extends$3({}, formatters, {
        cursor: undefined
      }))) != null ? _options$formatters$c2 : tooltipFormat(value);
    };

    Object.assign(formatters, {
      "default": defaultFormat,
      scale: scaleFormat,
      tooltip: tooltipFormat,
      cursor: cursorFormat
    });
    return _extends$3({}, options, {
      axisFamily: 'linear',
      isVertical: isVertical,
      scale: scale,
      range: range,
      outerScale: outerScale,
      bandScale: bandScale,
      formatters: formatters
    });
  }

  function buildBandAxis(options, series, isVertical, range, outerRange) {
    var _options$outerBandPad2, _options$innerBandPad2;

    var domain = Array.from(new Set(series.map(function (d) {
      return d.datums;
    }).flat().map(function (datum) {
      return options.getValue(datum.originalDatum);
    })));
    var scale = band(domain, range).round(false).paddingOuter((_options$outerBandPad2 = options.outerBandPadding) != null ? _options$outerBandPad2 : 0).paddingInner((_options$innerBandPad2 = options.innerBandPadding) != null ? _options$innerBandPad2 : 0); // Invert if necessary

    if (options.invert) {
      scale.domain(Array.from(scale.domain()).reverse());
    }

    var outerScale = scale.copy().range(outerRange);

    var defaultFormat = function defaultFormat(d) {
      return d;
    };

    var formatters = {};

    var scaleFormat = function scaleFormat(value) {
      var _options$formatters$s3, _options$formatters7;

      return (_options$formatters$s3 = (_options$formatters7 = options.formatters) == null ? void 0 : _options$formatters7.scale == null ? void 0 : _options$formatters7.scale(value, _extends$3({}, formatters, {
        scale: undefined
      }))) != null ? _options$formatters$s3 : defaultFormat(value);
    };

    var tooltipFormat = function tooltipFormat(value) {
      var _options$formatters$t3, _options$formatters8;

      return (_options$formatters$t3 = (_options$formatters8 = options.formatters) == null ? void 0 : _options$formatters8.tooltip == null ? void 0 : _options$formatters8.tooltip(value, _extends$3({}, formatters, {
        tooltip: undefined
      }))) != null ? _options$formatters$t3 : scaleFormat(value);
    };

    var cursorFormat = function cursorFormat(value) {
      var _options$formatters$c3, _options$formatters9;

      return (_options$formatters$c3 = (_options$formatters9 = options.formatters) == null ? void 0 : _options$formatters9.cursor == null ? void 0 : _options$formatters9.cursor(value, _extends$3({}, formatters, {
        cursor: undefined
      }))) != null ? _options$formatters$c3 : tooltipFormat(value);
    };

    Object.assign(formatters, {
      "default": defaultFormat,
      scale: scaleFormat,
      tooltip: tooltipFormat,
      cursor: cursorFormat
    });
    return _extends$3({}, options, {
      axisFamily: 'band',
      isVertical: isVertical,
      scale: scale,
      range: range,
      outerScale: outerScale,
      formatters: formatters
    });
  } //


  function buildImpliedBandScale(options, scale, series, range) {
    var _options$outerBandPad3, _options$innerBandPad3;

    // Find the two closest points along axis
    var impliedBandWidth = Math.max.apply(Math, range);
    series.forEach(function (serie) {
      serie.datums.forEach(function (d1) {
        var _options$getValue;

        var one = scale((_options$getValue = options.getValue(d1.originalDatum)) != null ? _options$getValue : NaN);
        serie.datums.forEach(function (d2) {
          var _options$getValue2;

          var two = scale((_options$getValue2 = options.getValue(d2.originalDatum)) != null ? _options$getValue2 : NaN);

          if (one === two) {
            return;
          }

          var r = [one, two].sort();
          var diff = Math.abs(r[1] - r[0]);

          if (diff < impliedBandWidth) {
            impliedBandWidth = diff;
          }
        });
      });
    });
    var bandRange = Math.max.apply(Math, range);
    var bandDomain = d3Range(bandRange / impliedBandWidth);
    var bandScale = band(bandDomain, range).round(false).paddingOuter((_options$outerBandPad3 = options.outerBandPadding) != null ? _options$outerBandPad3 : 0).paddingInner((_options$innerBandPad3 = options.innerBandPadding) != null ? _options$innerBandPad3 : 0);
    return bandScale;
  }

  var getElBox = function getElBox(el) {
    var rect = el.getBoundingClientRect();
    return {
      top: Math.round(rect.top),
      right: Math.round(rect.right),
      bottom: Math.round(rect.bottom),
      left: Math.round(rect.left),
      width: Math.round(rect.width),
      height: Math.round(rect.height),
      x: Math.round(rect.x),
      y: Math.round(rect.y)
    };
  };

  function useMeasure(_ref) {
    var axis = _ref.axis,
        elRef = _ref.elRef,
        gridDimensions = _ref.gridDimensions,
        setShowRotated = _ref.setShowRotated;

    var _useChartContext = useChartContext(),
        useAxisDimensionsAtom = _useChartContext.useAxisDimensionsAtom;

    var _useAxisDimensionsAto = useAxisDimensionsAtom(),
        axisDimensions = _useAxisDimensionsAto[0],
        setAxisDimensions = _useAxisDimensionsAto[1];

    var axisDimension = React__default['default'].useMemo(function () {
      var _axisDimensions;

      return (_axisDimensions = axisDimensions[axis.position]) == null ? void 0 : _axisDimensions[axis.id];
    }, [axisDimensions, axis.position, axis.id]); // const isLooping = useIsLooping()

    var measureRotation = React__default['default'].useCallback(function () {
      var _widestLabel2;

      if (!elRef.current) {
        return;
      }

      var gridSize = !axis.isVertical ? gridDimensions.gridWidth : gridDimensions.gridHeight;
      var staticLabelDims = Array.from(elRef.current.querySelectorAll('.Axis-Group.outer .tickLabel')).map(function (el) {
        return getElBox(el);
      }); // Determine the largest labels on the axis

      var widestLabel;
      staticLabelDims.forEach(function (label) {
        var _widestLabel;

        var resolvedLabel = (_widestLabel = widestLabel) != null ? _widestLabel : {
          width: 0
        };

        if (label.width > 0 && label.width > resolvedLabel.width) {
          widestLabel = label;
        }
      });
      var smallestTickGap = gridSize;

      if (staticLabelDims.length > 1) {
        staticLabelDims.forEach(function (current, i) {
          var prev = staticLabelDims[i - 1];

          if (prev) {
            smallestTickGap = Math.min(smallestTickGap, axis.isVertical ? current.top - prev.top : current.left - prev.left);
          }
        });
      }

      var shouldRotate = (((_widestLabel2 = widestLabel) == null ? void 0 : _widestLabel2.width) || 0) + axis.minTickPaddingForRotation > smallestTickGap; // if (!isLooping) {
      // Rotate ticks for non-time horizontal axes

      if (!axis.isVertical) {
        setShowRotated(shouldRotate);
      } // }

    }, [elRef, axis.isVertical, axis.minTickPaddingForRotation, gridDimensions.gridWidth, gridDimensions.gridHeight, setShowRotated]);
    var measureDimensions = React__default['default'].useCallback(function () {
      if (!elRef.current) {
        if (axisDimension) {
          // If the entire axis is hidden, then we need to remove the axis dimensions
          setAxisDimensions(function (old) {
            var _old$axis$position, _extends2;

            var newAxes = _extends$3({}, (_old$axis$position = old[axis.position]) != null ? _old$axis$position : {});

            delete newAxes[axis.id];
            return _extends$3({}, old, (_extends2 = {}, _extends2[axis.position] = newAxes, _extends2));
          });
        }

        return;
      }

      var newDimensions = {
        width: 0,
        height: 0,
        top: 0,
        bottom: 0,
        left: 0,
        right: 0
      };
      var domainEl = elRef.current.querySelector(".Axis-Group.inner .domain");

      if (!domainEl) {
        return;
      }

      var domainDims = getElBox(domainEl);
      var measureDims = Array.from(elRef.current.querySelectorAll('.Axis-Group.inner .tickLabel')).map(function (el) {
        return getElBox(el);
      }); // Determine the largest labels on the axis

      var widestRealLabel = measureDims[0];
      var tallestRealLabel = measureDims[0];
      measureDims.forEach(function (d) {
        if (d.width > 0 && d.width > widestRealLabel.width) {
          widestRealLabel = d;
        }

        if (d.height > 0 && d.height > tallestRealLabel.height) {
          tallestRealLabel = d;
        }
      }); // Axis overflow measurements

      if (!axis.isVertical) {
        var _tallestRealLabel$hei, _tallestRealLabel;

        if (measureDims.length) {
          var leftMostLabelDim = measureDims.reduce(function (d, labelDim) {
            return labelDim.left < d.left ? labelDim : d;
          });
          var rightMostLabelDim = measureDims.reduce(function (d, labelDim) {
            return labelDim.right > d.right ? labelDim : d;
          });
          newDimensions.left = Math.round(Math.max(0, domainDims.left - (leftMostLabelDim == null ? void 0 : leftMostLabelDim.left)));
          newDimensions.right = Math.round(Math.max(0, (rightMostLabelDim == null ? void 0 : rightMostLabelDim.right) - domainDims.right));
        }

        newDimensions.height = Math.round( // Math.max(axis.tickSizeInner, axis.tickSizeOuter) +
        8 + axis.minTickPaddingForRotation + ((_tallestRealLabel$hei = (_tallestRealLabel = tallestRealLabel) == null ? void 0 : _tallestRealLabel.height) != null ? _tallestRealLabel$hei : 0));
      } else {
        var _widestRealLabel$widt, _widestRealLabel;

        if (measureDims.length) {
          var topMostLabelDim = measureDims.reduce(function (d, labelDim) {
            return labelDim.top < d.top ? labelDim : d;
          });
          var bottomMostLabelDim = measureDims.reduce(function (d, labelDim) {
            return labelDim.bottom > d.bottom ? labelDim : d;
          });
          newDimensions.top = Math.round(Math.max(0, domainDims.top - (topMostLabelDim == null ? void 0 : topMostLabelDim.top)));
          newDimensions.bottom = Math.round(Math.max(0, (bottomMostLabelDim == null ? void 0 : bottomMostLabelDim.bottom) - domainDims.bottom));
        }

        newDimensions.width = Math.round( // Math.max(axis.tickSizeInner, axis.tickSizeOuter) +
        8 + axis.minTickPaddingForRotation + ((_widestRealLabel$widt = (_widestRealLabel = widestRealLabel) == null ? void 0 : _widestRealLabel.width) != null ? _widestRealLabel$widt : 0));
      } // Only update the axisDimensions if something has changed


      if ( // !isLooping &&
      !axisDimensions || !axisDimension || Object.keys(newDimensions).some(function (key) {
        // @ts-ignore
        return newDimensions[key] !== axisDimension[key];
      })) {
        setAxisDimensions(function (old) {
          var _old$axis$position2, _extends3, _extends4;

          return _extends$3({}, old, (_extends4 = {}, _extends4[axis.position] = _extends$3({}, (_old$axis$position2 = old[axis.position]) != null ? _old$axis$position2 : {}, (_extends3 = {}, _extends3[axis.id] = newDimensions, _extends3)), _extends4));
        });
      }
    }, [axis.id, axis.isVertical, axis.position, axis.minTickPaddingForRotation, axisDimension, axisDimensions, elRef, setAxisDimensions]); // Measure after if needed

    useIsomorphicLayoutEffect(function () {
      measureRotation();
    }, [measureRotation]);
    useIsomorphicLayoutEffect(function () {
      measureDimensions();
    }, [measureRotation]);
  }

  function AxisLinearComp(axis) {
    var _React$useState = React__default['default'].useState(false),
        showRotated = _React$useState[0],
        setShowRotated = _React$useState[1];

    var _useChartContext = useChartContext(),
        getOptions = _useChartContext.getOptions,
        gridDimensions = _useChartContext.gridDimensions,
        width = _useChartContext.width,
        height = _useChartContext.height;

    var _getOptions = getOptions(),
        dark = _getOptions.dark,
        showDebugAxes = _getOptions.showDebugAxes;

    var elRef = React__default['default'].useRef(null);
    useMeasure({
      axis: axis,
      elRef: elRef,
      gridDimensions: gridDimensions,
      showRotated: showRotated,
      setShowRotated: setShowRotated
    });

    var renderAxis = function renderAxis(isOuter) {
      var isRotated = !isOuter && showRotated;
      var scale = isOuter ? axis.outerScale : axis.scale;

      var _scale$range = scale.range(),
          rangeStart = _scale$range[0],
          rangeEnd = _scale$range[1];

      var getTicks = function getTicks(scale, num) {
        if (scale.ticks) {
          return scale.ticks(num);
        }

        return scale.domain();
      };

      var resolvedHeight = isOuter ? height : gridDimensions.gridHeight;
      var resolvedWidth = isOuter ? width : gridDimensions.gridWidth;

      var _ref = axis.position === 'left' ? [{
        x: 0,
        y: rangeStart
      }, {
        x: 0,
        y: rangeEnd
      }] : axis.position === 'right' ? [{
        x: resolvedWidth,
        y: rangeStart
      }, {
        x: resolvedWidth,
        y: rangeEnd
      }] : axis.position === 'top' ? [{
        x: rangeStart,
        y: 0
      }, {
        x: rangeEnd,
        y: 0
      }] : [{
        x: rangeStart,
        y: resolvedHeight
      }, {
        x: rangeEnd,
        y: resolvedHeight
      }],
          lineFrom = _ref[0],
          lineTo = _ref[1];

      return /*#__PURE__*/React__default['default'].createElement("g", {
        key: "Axis-Group " + (isOuter ? 'outer' : 'inner'),
        className: "Axis-Group " + (isOuter ? 'outer' : 'inner'),
        style: {
          transform: isOuter ? undefined : translate(gridDimensions.gridX, gridDimensions.gridY)
        }
      }, /*#__PURE__*/React__default['default'].createElement("g", {
        className: "Axis",
        style: _extends$3({}, isOuter ? {
          opacity: showDebugAxes ? 0.5 : 0,
          pointerEvents: 'none'
        } : {
          opacity: 1,
          pointerEvents: 'all'
        })
      }, /*#__PURE__*/React__default['default'].createElement("line", {
        className: "domain",
        x1: lineFrom.x,
        y1: lineFrom.y,
        x2: lineTo.x,
        y2: lineTo.y,
        stroke: dark ? 'rgba(255,255,255, .2)' : 'rgba(0,0,0, .2)'
      }), getTicks(scale, 10).map(function (tick, i) {
        var _axis$showGrid;

        var px = getTickPx(scale, tick);

        var _ref2 = axis.position === 'left' ? [{
          x: 0,
          y: px
        }, {
          x: -8,
          y: px
        }, {
          x: resolvedWidth,
          y: px
        }] : axis.position === 'right' ? [{
          x: resolvedWidth,
          y: px
        }, {
          x: resolvedWidth + 8,
          y: px
        }, {
          x: 0,
          y: px
        }] : axis.position === 'top' ? [{
          x: px,
          y: 0
        }, {
          x: px,
          y: -8
        }, {
          x: px,
          y: resolvedHeight
        }] : [{
          x: px,
          y: resolvedHeight
        }, {
          x: px,
          y: resolvedHeight + 8
        }, {
          x: px,
          y: 0
        }],
            tickFrom = _ref2[0],
            tickTo = _ref2[1],
            gridTo = _ref2[2];

        var tickLabelX = tickTo.x,
            tickLabelY = tickTo.y;

        if (axis.position === 'top') {
          tickLabelY -= 5;
        } else if (axis.position === 'bottom') {
          tickLabelY += 5;
        } else if (axis.position === 'left') {
          tickLabelX -= 5;
        } else if (axis.position === 'right') {
          tickLabelX += 5;
        }

        return /*#__PURE__*/React__default['default'].createElement("g", {
          key: "vx-tick-" + tick + "-" + i,
          className: 'tick'
        }, ((_axis$showGrid = axis.showGrid) != null ? _axis$showGrid : true) && !isOuter ? /*#__PURE__*/React__default['default'].createElement("line", {
          x1: tickFrom.x,
          y1: tickFrom.y,
          x2: gridTo.x,
          y2: gridTo.y,
          stroke: dark ? 'rgba(255,255,255, .05)' : 'rgba(0,0,0, .05)'
        }) : null, !isOuter ? /*#__PURE__*/React__default['default'].createElement("line", {
          x1: tickFrom.x,
          y1: tickFrom.y,
          x2: tickTo.x,
          y2: tickTo.y,
          stroke: dark ? 'rgba(255,255,255, .2)' : 'rgba(0,0,0, .2)'
        }) : null, /*#__PURE__*/React__default['default'].createElement("text", {
          className: "tickLabel",
          style: {
            fontSize: 10,
            fill: dark ? 'rgba(255,255,255, .7)' : 'rgba(0,0,0, .7)',
            dominantBaseline: isRotated ? 'central' : axis.position === 'bottom' ? 'hanging' : axis.position === 'top' ? 'alphabetic' : 'central',
            textAnchor: isRotated ? 'end' : axis.position === 'right' ? 'start' : axis.position === 'left' ? 'end' : 'middle'
          },
          transform: "translate(" + tickLabelX + ", " + tickLabelY + ") rotate(" + (isRotated ? axis.position === 'top' ? 60 : -60 : 0) + ")"
        }, axis.formatters.scale(tick)));
      })));
    };

    return axis.show ? /*#__PURE__*/React__default['default'].createElement("g", {
      ref: elRef
    }, renderAxis(false), renderAxis(true)) : null;
  }

  let updateQueue = makeQueue();

  const raf = fn => schedule(fn, updateQueue);

  let writeQueue = makeQueue();

  raf.write = fn => schedule(fn, writeQueue);

  let onStartQueue = makeQueue();

  raf.onStart = fn => schedule(fn, onStartQueue);

  let onFrameQueue = makeQueue();

  raf.onFrame = fn => schedule(fn, onFrameQueue);

  let onFinishQueue = makeQueue();

  raf.onFinish = fn => schedule(fn, onFinishQueue);

  let timeouts = [];

  raf.setTimeout = (handler, ms) => {
    let time = raf.now() + ms;

    let cancel = () => {
      let i = timeouts.findIndex(t => t.cancel == cancel);
      if (~i) timeouts.splice(i, 1);
      __raf.count -= ~i ? 1 : 0;
    };

    let timeout = {
      time,
      handler,
      cancel
    };
    timeouts.splice(findTimeout(time), 0, timeout);
    __raf.count += 1;
    start();
    return timeout;
  };

  let findTimeout = time => ~(~timeouts.findIndex(t => t.time > time) || ~timeouts.length);

  raf.cancel = fn => {
    updateQueue.delete(fn);
    writeQueue.delete(fn);
  };

  raf.sync = fn => {
    sync = true;
    raf.batchedUpdates(fn);
    sync = false;
  };

  raf.throttle = fn => {
    let lastArgs;

    function queuedFn() {
      try {
        fn(...lastArgs);
      } finally {
        lastArgs = null;
      }
    }

    function throttled(...args) {
      lastArgs = args;
      raf.onStart(queuedFn);
    }

    throttled.handler = fn;

    throttled.cancel = () => {
      onStartQueue.delete(queuedFn);
      lastArgs = null;
    };

    return throttled;
  };

  let nativeRaf = typeof window != 'undefined' ? window.requestAnimationFrame : () => {};

  raf.use = impl => nativeRaf = impl;

  raf.now = typeof performance != 'undefined' ? () => performance.now() : Date.now;

  raf.batchedUpdates = fn => fn();

  raf.catch = console.error;
  raf.frameLoop = 'always';

  raf.advance = () => {
    if (raf.frameLoop !== 'demand') {
      console.warn('Cannot call the manual advancement of rafz whilst frameLoop is not set as demand');
    } else {
      update();
    }
  };

  let ts = -1;
  let sync = false;

  function schedule(fn, queue) {
    if (sync) {
      queue.delete(fn);
      fn(0);
    } else {
      queue.add(fn);
      start();
    }
  }

  function start() {
    if (ts < 0) {
      ts = 0;

      if (raf.frameLoop !== 'demand') {
        nativeRaf(loop);
      }
    }
  }

  function loop() {
    if (~ts) {
      nativeRaf(loop);
      raf.batchedUpdates(update);
    }
  }

  function update() {
    let prevTs = ts;
    ts = raf.now();
    let count = findTimeout(ts);

    if (count) {
      eachSafely(timeouts.splice(0, count), t => t.handler());
      __raf.count -= count;
    }

    onStartQueue.flush();
    updateQueue.flush(prevTs ? Math.min(64, ts - prevTs) : 16.667);
    onFrameQueue.flush();
    writeQueue.flush();
    onFinishQueue.flush();
  }

  function makeQueue() {
    let next = new Set();
    let current = next;
    return {
      add(fn) {
        __raf.count += current == next && !next.has(fn) ? 1 : 0;
        next.add(fn);
      },

      delete(fn) {
        __raf.count -= current == next && next.has(fn) ? 1 : 0;
        return next.delete(fn);
      },

      flush(arg) {
        if (current.size) {
          next = new Set();
          __raf.count -= current.size;
          eachSafely(current, fn => fn(arg) && next.add(fn));
          __raf.count += next.size;
          current = next;
        }
      }

    };
  }

  function eachSafely(values, each) {
    values.forEach(value => {
      try {
        each(value);
      } catch (e) {
        raf.catch(e);
      }
    });
  }

  const __raf = {
    count: 0,

    clear() {
      ts = -1;
      timeouts = [];
      onStartQueue = makeQueue();
      updateQueue = makeQueue();
      onFrameQueue = makeQueue();
      writeQueue = makeQueue();
      onFinishQueue = makeQueue();
      __raf.count = 0;
    }

  };

  function noop() {}

  const defineHidden = (obj, key, value) => Object.defineProperty(obj, key, {
    value,
    writable: true,
    configurable: true
  });

  const is = {
    arr: Array.isArray,
    obj: a => !!a && a.constructor.name === 'Object',
    fun: a => typeof a === 'function',
    str: a => typeof a === 'string',
    num: a => typeof a === 'number',
    und: a => a === undefined
  };

  function isEqual(a, b) {
    if (is.arr(a)) {
      if (!is.arr(b) || a.length !== b.length) return false;

      for (let i = 0; i < a.length; i++) {
        if (a[i] !== b[i]) return false;
      }

      return true;
    }

    return a === b;
  }

  const each = (obj, fn) => obj.forEach(fn);

  function eachProp(obj, fn, ctx) {
    for (const key in obj) {
      fn.call(ctx, obj[key], key);
    }
  }

  const toArray = a => is.und(a) ? [] : is.arr(a) ? a : [a];

  function flush(queue, iterator) {
    if (queue.size) {
      const items = Array.from(queue);
      queue.clear();
      each(items, iterator);
    }
  }

  const flushCalls = (queue, ...args) => flush(queue, fn => fn(...args));

  let createStringInterpolator$1;
  let to;
  let colors$1 = null;
  let skipAnimation = false;
  let willAdvance = noop;

  const assign = globals => {
    if (globals.to) to = globals.to;
    if (globals.now) raf.now = globals.now;
    if (globals.colors !== undefined) colors$1 = globals.colors;
    if (globals.skipAnimation != null) skipAnimation = globals.skipAnimation;
    if (globals.createStringInterpolator) createStringInterpolator$1 = globals.createStringInterpolator;
    if (globals.requestAnimationFrame) raf.use(globals.requestAnimationFrame);
    if (globals.batchedUpdates) raf.batchedUpdates = globals.batchedUpdates;
    if (globals.willAdvance) willAdvance = globals.willAdvance;
    if (globals.frameLoop) raf.frameLoop = globals.frameLoop;
  };

  var globals = /*#__PURE__*/Object.freeze({
    __proto__: null,

    get createStringInterpolator() {
      return createStringInterpolator$1;
    },

    get to() {
      return to;
    },

    get colors() {
      return colors$1;
    },

    get skipAnimation() {
      return skipAnimation;
    },

    get willAdvance() {
      return willAdvance;
    },

    assign: assign
  });
  const startQueue = new Set();
  let currentFrame = [];
  let prevFrame = [];
  let priority = 0;
  const frameLoop = {
    get idle() {
      return !startQueue.size && !currentFrame.length;
    },

    start(animation) {
      if (priority > animation.priority) {
        startQueue.add(animation);
        raf.onStart(flushStartQueue);
      } else {
        startSafely(animation);
        raf(advance);
      }
    },

    advance,

    sort(animation) {
      if (priority) {
        raf.onFrame(() => frameLoop.sort(animation));
      } else {
        const prevIndex = currentFrame.indexOf(animation);

        if (~prevIndex) {
          currentFrame.splice(prevIndex, 1);
          startUnsafely(animation);
        }
      }
    },

    clear() {
      currentFrame = [];
      startQueue.clear();
    }

  };

  function flushStartQueue() {
    startQueue.forEach(startSafely);
    startQueue.clear();
    raf(advance);
  }

  function startSafely(animation) {
    if (!currentFrame.includes(animation)) startUnsafely(animation);
  }

  function startUnsafely(animation) {
    currentFrame.splice(findIndex(currentFrame, other => other.priority > animation.priority), 0, animation);
  }

  function advance(dt) {
    const nextFrame = prevFrame;

    for (let i = 0; i < currentFrame.length; i++) {
      const animation = currentFrame[i];
      priority = animation.priority;

      if (!animation.idle) {
        willAdvance(animation);
        animation.advance(dt);

        if (!animation.idle) {
          nextFrame.push(animation);
        }
      }
    }

    priority = 0;
    prevFrame = currentFrame;
    prevFrame.length = 0;
    currentFrame = nextFrame;
    return currentFrame.length > 0;
  }

  function findIndex(arr, test) {
    const index = arr.findIndex(test);
    return index < 0 ? arr.length : index;
  }

  const colors = {
    transparent: 0x00000000,
    aliceblue: 0xf0f8ffff,
    antiquewhite: 0xfaebd7ff,
    aqua: 0x00ffffff,
    aquamarine: 0x7fffd4ff,
    azure: 0xf0ffffff,
    beige: 0xf5f5dcff,
    bisque: 0xffe4c4ff,
    black: 0x000000ff,
    blanchedalmond: 0xffebcdff,
    blue: 0x0000ffff,
    blueviolet: 0x8a2be2ff,
    brown: 0xa52a2aff,
    burlywood: 0xdeb887ff,
    burntsienna: 0xea7e5dff,
    cadetblue: 0x5f9ea0ff,
    chartreuse: 0x7fff00ff,
    chocolate: 0xd2691eff,
    coral: 0xff7f50ff,
    cornflowerblue: 0x6495edff,
    cornsilk: 0xfff8dcff,
    crimson: 0xdc143cff,
    cyan: 0x00ffffff,
    darkblue: 0x00008bff,
    darkcyan: 0x008b8bff,
    darkgoldenrod: 0xb8860bff,
    darkgray: 0xa9a9a9ff,
    darkgreen: 0x006400ff,
    darkgrey: 0xa9a9a9ff,
    darkkhaki: 0xbdb76bff,
    darkmagenta: 0x8b008bff,
    darkolivegreen: 0x556b2fff,
    darkorange: 0xff8c00ff,
    darkorchid: 0x9932ccff,
    darkred: 0x8b0000ff,
    darksalmon: 0xe9967aff,
    darkseagreen: 0x8fbc8fff,
    darkslateblue: 0x483d8bff,
    darkslategray: 0x2f4f4fff,
    darkslategrey: 0x2f4f4fff,
    darkturquoise: 0x00ced1ff,
    darkviolet: 0x9400d3ff,
    deeppink: 0xff1493ff,
    deepskyblue: 0x00bfffff,
    dimgray: 0x696969ff,
    dimgrey: 0x696969ff,
    dodgerblue: 0x1e90ffff,
    firebrick: 0xb22222ff,
    floralwhite: 0xfffaf0ff,
    forestgreen: 0x228b22ff,
    fuchsia: 0xff00ffff,
    gainsboro: 0xdcdcdcff,
    ghostwhite: 0xf8f8ffff,
    gold: 0xffd700ff,
    goldenrod: 0xdaa520ff,
    gray: 0x808080ff,
    green: 0x008000ff,
    greenyellow: 0xadff2fff,
    grey: 0x808080ff,
    honeydew: 0xf0fff0ff,
    hotpink: 0xff69b4ff,
    indianred: 0xcd5c5cff,
    indigo: 0x4b0082ff,
    ivory: 0xfffff0ff,
    khaki: 0xf0e68cff,
    lavender: 0xe6e6faff,
    lavenderblush: 0xfff0f5ff,
    lawngreen: 0x7cfc00ff,
    lemonchiffon: 0xfffacdff,
    lightblue: 0xadd8e6ff,
    lightcoral: 0xf08080ff,
    lightcyan: 0xe0ffffff,
    lightgoldenrodyellow: 0xfafad2ff,
    lightgray: 0xd3d3d3ff,
    lightgreen: 0x90ee90ff,
    lightgrey: 0xd3d3d3ff,
    lightpink: 0xffb6c1ff,
    lightsalmon: 0xffa07aff,
    lightseagreen: 0x20b2aaff,
    lightskyblue: 0x87cefaff,
    lightslategray: 0x778899ff,
    lightslategrey: 0x778899ff,
    lightsteelblue: 0xb0c4deff,
    lightyellow: 0xffffe0ff,
    lime: 0x00ff00ff,
    limegreen: 0x32cd32ff,
    linen: 0xfaf0e6ff,
    magenta: 0xff00ffff,
    maroon: 0x800000ff,
    mediumaquamarine: 0x66cdaaff,
    mediumblue: 0x0000cdff,
    mediumorchid: 0xba55d3ff,
    mediumpurple: 0x9370dbff,
    mediumseagreen: 0x3cb371ff,
    mediumslateblue: 0x7b68eeff,
    mediumspringgreen: 0x00fa9aff,
    mediumturquoise: 0x48d1ccff,
    mediumvioletred: 0xc71585ff,
    midnightblue: 0x191970ff,
    mintcream: 0xf5fffaff,
    mistyrose: 0xffe4e1ff,
    moccasin: 0xffe4b5ff,
    navajowhite: 0xffdeadff,
    navy: 0x000080ff,
    oldlace: 0xfdf5e6ff,
    olive: 0x808000ff,
    olivedrab: 0x6b8e23ff,
    orange: 0xffa500ff,
    orangered: 0xff4500ff,
    orchid: 0xda70d6ff,
    palegoldenrod: 0xeee8aaff,
    palegreen: 0x98fb98ff,
    paleturquoise: 0xafeeeeff,
    palevioletred: 0xdb7093ff,
    papayawhip: 0xffefd5ff,
    peachpuff: 0xffdab9ff,
    peru: 0xcd853fff,
    pink: 0xffc0cbff,
    plum: 0xdda0ddff,
    powderblue: 0xb0e0e6ff,
    purple: 0x800080ff,
    rebeccapurple: 0x663399ff,
    red: 0xff0000ff,
    rosybrown: 0xbc8f8fff,
    royalblue: 0x4169e1ff,
    saddlebrown: 0x8b4513ff,
    salmon: 0xfa8072ff,
    sandybrown: 0xf4a460ff,
    seagreen: 0x2e8b57ff,
    seashell: 0xfff5eeff,
    sienna: 0xa0522dff,
    silver: 0xc0c0c0ff,
    skyblue: 0x87ceebff,
    slateblue: 0x6a5acdff,
    slategray: 0x708090ff,
    slategrey: 0x708090ff,
    snow: 0xfffafaff,
    springgreen: 0x00ff7fff,
    steelblue: 0x4682b4ff,
    tan: 0xd2b48cff,
    teal: 0x008080ff,
    thistle: 0xd8bfd8ff,
    tomato: 0xff6347ff,
    turquoise: 0x40e0d0ff,
    violet: 0xee82eeff,
    wheat: 0xf5deb3ff,
    white: 0xffffffff,
    whitesmoke: 0xf5f5f5ff,
    yellow: 0xffff00ff,
    yellowgreen: 0x9acd32ff
  };
  const NUMBER = '[-+]?\\d*\\.?\\d+';
  const PERCENTAGE = NUMBER + '%';

  function call(...parts) {
    return '\\(\\s*(' + parts.join(')\\s*,\\s*(') + ')\\s*\\)';
  }

  const rgb = new RegExp('rgb' + call(NUMBER, NUMBER, NUMBER));
  const rgba = new RegExp('rgba' + call(NUMBER, NUMBER, NUMBER, NUMBER));
  const hsl = new RegExp('hsl' + call(NUMBER, PERCENTAGE, PERCENTAGE));
  const hsla = new RegExp('hsla' + call(NUMBER, PERCENTAGE, PERCENTAGE, NUMBER));
  const hex3 = /^#([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/;
  const hex4 = /^#([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/;
  const hex6 = /^#([0-9a-fA-F]{6})$/;
  const hex8 = /^#([0-9a-fA-F]{8})$/;

  function normalizeColor(color) {
    let match;

    if (typeof color === 'number') {
      return color >>> 0 === color && color >= 0 && color <= 0xffffffff ? color : null;
    }

    if (match = hex6.exec(color)) return parseInt(match[1] + 'ff', 16) >>> 0;

    if (colors$1 && colors$1[color] !== undefined) {
      return colors$1[color];
    }

    if (match = rgb.exec(color)) {
      return (parse255(match[1]) << 24 | parse255(match[2]) << 16 | parse255(match[3]) << 8 | 0x000000ff) >>> 0;
    }

    if (match = rgba.exec(color)) {
      return (parse255(match[1]) << 24 | parse255(match[2]) << 16 | parse255(match[3]) << 8 | parse1(match[4])) >>> 0;
    }

    if (match = hex3.exec(color)) {
      return parseInt(match[1] + match[1] + match[2] + match[2] + match[3] + match[3] + 'ff', 16) >>> 0;
    }

    if (match = hex8.exec(color)) return parseInt(match[1], 16) >>> 0;

    if (match = hex4.exec(color)) {
      return parseInt(match[1] + match[1] + match[2] + match[2] + match[3] + match[3] + match[4] + match[4], 16) >>> 0;
    }

    if (match = hsl.exec(color)) {
      return (hslToRgb(parse360(match[1]), parsePercentage(match[2]), parsePercentage(match[3])) | 0x000000ff) >>> 0;
    }

    if (match = hsla.exec(color)) {
      return (hslToRgb(parse360(match[1]), parsePercentage(match[2]), parsePercentage(match[3])) | parse1(match[4])) >>> 0;
    }

    return null;
  }

  function hue2rgb(p, q, t) {
    if (t < 0) t += 1;
    if (t > 1) t -= 1;
    if (t < 1 / 6) return p + (q - p) * 6 * t;
    if (t < 1 / 2) return q;
    if (t < 2 / 3) return p + (q - p) * (2 / 3 - t) * 6;
    return p;
  }

  function hslToRgb(h, s, l) {
    const q = l < 0.5 ? l * (1 + s) : l + s - l * s;
    const p = 2 * l - q;
    const r = hue2rgb(p, q, h + 1 / 3);
    const g = hue2rgb(p, q, h);
    const b = hue2rgb(p, q, h - 1 / 3);
    return Math.round(r * 255) << 24 | Math.round(g * 255) << 16 | Math.round(b * 255) << 8;
  }

  function parse255(str) {
    const int = parseInt(str, 10);
    if (int < 0) return 0;
    if (int > 255) return 255;
    return int;
  }

  function parse360(str) {
    const int = parseFloat(str);
    return (int % 360 + 360) % 360 / 360;
  }

  function parse1(str) {
    const num = parseFloat(str);
    if (num < 0) return 0;
    if (num > 1) return 255;
    return Math.round(num * 255);
  }

  function parsePercentage(str) {
    const int = parseFloat(str);
    if (int < 0) return 0;
    if (int > 100) return 1;
    return int / 100;
  }

  function colorToRgba(input) {
    let int32Color = normalizeColor(input);
    if (int32Color === null) return input;
    int32Color = int32Color || 0;
    let r = (int32Color & 0xff000000) >>> 24;
    let g = (int32Color & 0x00ff0000) >>> 16;
    let b = (int32Color & 0x0000ff00) >>> 8;
    let a = (int32Color & 0x000000ff) / 255;
    return `rgba(${r}, ${g}, ${b}, ${a})`;
  }

  const createInterpolator = (range, output, extrapolate) => {
    if (is.fun(range)) {
      return range;
    }

    if (is.arr(range)) {
      return createInterpolator({
        range,
        output: output,
        extrapolate
      });
    }

    if (is.str(range.output[0])) {
      return createStringInterpolator$1(range);
    }

    const config = range;
    const outputRange = config.output;
    const inputRange = config.range || [0, 1];
    const extrapolateLeft = config.extrapolateLeft || config.extrapolate || 'extend';
    const extrapolateRight = config.extrapolateRight || config.extrapolate || 'extend';

    const easing = config.easing || (t => t);

    return input => {
      const range = findRange(input, inputRange);
      return interpolate(input, inputRange[range], inputRange[range + 1], outputRange[range], outputRange[range + 1], easing, extrapolateLeft, extrapolateRight, config.map);
    };
  };

  function interpolate(input, inputMin, inputMax, outputMin, outputMax, easing, extrapolateLeft, extrapolateRight, map) {
    let result = map ? map(input) : input;

    if (result < inputMin) {
      if (extrapolateLeft === 'identity') return result;else if (extrapolateLeft === 'clamp') result = inputMin;
    }

    if (result > inputMax) {
      if (extrapolateRight === 'identity') return result;else if (extrapolateRight === 'clamp') result = inputMax;
    }

    if (outputMin === outputMax) return outputMin;
    if (inputMin === inputMax) return input <= inputMin ? outputMin : outputMax;
    if (inputMin === -Infinity) result = -result;else if (inputMax === Infinity) result = result - inputMin;else result = (result - inputMin) / (inputMax - inputMin);
    result = easing(result);
    if (outputMin === -Infinity) result = -result;else if (outputMax === Infinity) result = result + outputMin;else result = result * (outputMax - outputMin) + outputMin;
    return result;
  }

  function findRange(input, inputRange) {
    for (var i = 1; i < inputRange.length - 1; ++i) if (inputRange[i] >= input) break;

    return i - 1;
  }

  function _extends$2() {
    _extends$2 = Object.assign || function (target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i];

        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }

      return target;
    };

    return _extends$2.apply(this, arguments);
  }

  const $get = Symbol.for('FluidValue.get');
  const $observers = Symbol.for('FluidValue.observers');

  const hasFluidValue = arg => Boolean(arg && arg[$get]);

  const getFluidValue = arg => arg && arg[$get] ? arg[$get]() : arg;

  const getFluidObservers = target => target[$observers] || null;

  function callFluidObserver(observer, event) {
    if (observer.eventObserved) {
      observer.eventObserved(event);
    } else {
      observer(event);
    }
  }

  function callFluidObservers(target, event) {
    let observers = target[$observers];

    if (observers) {
      observers.forEach(observer => {
        callFluidObserver(observer, event);
      });
    }
  }

  class FluidValue {
    constructor(get) {
      this[$get] = void 0;
      this[$observers] = void 0;

      if (!get && !(get = this.get)) {
        throw Error('Unknown getter');
      }

      setFluidGetter(this, get);
    }

  }

  const setFluidGetter = (target, get) => setHidden(target, $get, get);

  function addFluidObserver(target, observer) {
    if (target[$get]) {
      let observers = target[$observers];

      if (!observers) {
        setHidden(target, $observers, observers = new Set());
      }

      if (!observers.has(observer)) {
        observers.add(observer);

        if (target.observerAdded) {
          target.observerAdded(observers.size, observer);
        }
      }
    }

    return observer;
  }

  function removeFluidObserver(target, observer) {
    let observers = target[$observers];

    if (observers && observers.has(observer)) {
      const count = observers.size - 1;

      if (count) {
        observers.delete(observer);
      } else {
        target[$observers] = null;
      }

      if (target.observerRemoved) {
        target.observerRemoved(count, observer);
      }
    }
  }

  const setHidden = (target, key, value) => Object.defineProperty(target, key, {
    value,
    writable: true,
    configurable: true
  });

  const numberRegex = /[+\-]?(?:0|[1-9]\d*)(?:\.\d*)?(?:[eE][+\-]?\d+)?/g;
  const colorRegex = /(#(?:[0-9a-f]{2}){2,4}|(#[0-9a-f]{3})|(rgb|hsl)a?\((-?\d+%?[,\s]+){2,3}\s*[\d\.]+%?\))/gi;
  let namedColorRegex;
  const rgbaRegex = /rgba\(([0-9\.-]+), ([0-9\.-]+), ([0-9\.-]+), ([0-9\.-]+)\)/gi;

  const rgbaRound = (_, p1, p2, p3, p4) => `rgba(${Math.round(p1)}, ${Math.round(p2)}, ${Math.round(p3)}, ${p4})`;

  const createStringInterpolator = config => {
    if (!namedColorRegex) namedColorRegex = colors$1 ? new RegExp(`(${Object.keys(colors$1).join('|')})(?!\\w)`, 'g') : /^\b$/;
    const output = config.output.map(value => getFluidValue(value).replace(colorRegex, colorToRgba).replace(namedColorRegex, colorToRgba));
    const keyframes = output.map(value => value.match(numberRegex).map(Number));
    const outputRanges = keyframes[0].map((_, i) => keyframes.map(values => {
      if (!(i in values)) {
        throw Error('The arity of each "output" value must be equal');
      }

      return values[i];
    }));
    const interpolators = outputRanges.map(output => createInterpolator(_extends$2({}, config, {
      output
    })));
    return input => {
      let i = 0;
      return output[0].replace(numberRegex, () => String(interpolators[i++](input))).replace(rgbaRegex, rgbaRound);
    };
  };

  const prefix = 'react-spring: ';

  const once = fn => {
    const func = fn;
    let called = false;

    if (typeof func != 'function') {
      throw new TypeError(`${prefix}once requires a function parameter`);
    }

    return (...args) => {
      if (!called) {
        func(...args);
        called = true;
      }
    };
  };

  const warnInterpolate = once(console.warn);

  function deprecateInterpolate() {
    warnInterpolate(`${prefix}The "interpolate" function is deprecated in v9 (use "to" instead)`);
  }

  const warnDirectCall = once(console.warn);

  function deprecateDirectCall() {
    warnDirectCall(`${prefix}Directly calling start instead of using the api object is deprecated in v9 (use ".start" instead), this will be removed in later 0.X.0 versions`);
  }

  function isAnimatedString(value) {
    return is.str(value) && (value[0] == '#' || /\d/.test(value) || value in (colors$1 || {}));
  }

  const useOnce = effect => React.useEffect(effect, emptyDeps);

  const emptyDeps = [];

  function useForceUpdate() {
    const update = React.useState()[1];
    const mounted = React.useState(makeMountedRef)[0];
    useOnce(mounted.unmount);
    return () => {
      if (mounted.current) {
        update({});
      }
    };
  }

  function makeMountedRef() {
    const mounted = {
      current: true,
      unmount: () => () => {
        mounted.current = false;
      }
    };
    return mounted;
  }

  function useMemoOne(getResult, inputs) {
    const [initial] = React.useState(() => ({
      inputs,
      result: getResult()
    }));
    const committed = React.useRef();
    const prevCache = committed.current;
    let cache = prevCache;

    if (cache) {
      const useCache = Boolean(inputs && cache.inputs && areInputsEqual(inputs, cache.inputs));

      if (!useCache) {
        cache = {
          inputs,
          result: getResult()
        };
      }
    } else {
      cache = initial;
    }

    React.useEffect(() => {
      committed.current = cache;

      if (prevCache == initial) {
        initial.inputs = initial.result = undefined;
      }
    }, [cache]);
    return cache.result;
  }

  function areInputsEqual(next, prev) {
    if (next.length !== prev.length) {
      return false;
    }

    for (let i = 0; i < next.length; i++) {
      if (next[i] !== prev[i]) {
        return false;
      }
    }

    return true;
  }

  function usePrev(value) {
    const prevRef = React.useRef();
    React.useEffect(() => {
      prevRef.current = value;
    });
    return prevRef.current;
  }

  const useLayoutEffect = typeof window !== 'undefined' && window.document && window.document.createElement ? React__namespace.useLayoutEffect : React__namespace.useEffect;

  const $node = Symbol.for('Animated:node');

  const isAnimated = value => !!value && value[$node] === value;

  const getAnimated = owner => owner && owner[$node];

  const setAnimated = (owner, node) => defineHidden(owner, $node, node);

  const getPayload = owner => owner && owner[$node] && owner[$node].getPayload();

  class Animated {
    constructor() {
      this.payload = void 0;
      setAnimated(this, this);
    }

    getPayload() {
      return this.payload || [];
    }

  }

  class AnimatedValue extends Animated {
    constructor(_value) {
      super();
      this.done = true;
      this.elapsedTime = void 0;
      this.lastPosition = void 0;
      this.lastVelocity = void 0;
      this.v0 = void 0;
      this.durationProgress = 0;
      this._value = _value;

      if (is.num(this._value)) {
        this.lastPosition = this._value;
      }
    }

    static create(value) {
      return new AnimatedValue(value);
    }

    getPayload() {
      return [this];
    }

    getValue() {
      return this._value;
    }

    setValue(value, step) {
      if (is.num(value)) {
        this.lastPosition = value;

        if (step) {
          value = Math.round(value / step) * step;

          if (this.done) {
            this.lastPosition = value;
          }
        }
      }

      if (this._value === value) {
        return false;
      }

      this._value = value;
      return true;
    }

    reset() {
      const {
        done
      } = this;
      this.done = false;

      if (is.num(this._value)) {
        this.elapsedTime = 0;
        this.durationProgress = 0;
        this.lastPosition = this._value;
        if (done) this.lastVelocity = null;
        this.v0 = null;
      }
    }

  }

  class AnimatedString extends AnimatedValue {
    constructor(value) {
      super(0);
      this._string = null;
      this._toString = void 0;
      this._toString = createInterpolator({
        output: [value, value]
      });
    }

    static create(value) {
      return new AnimatedString(value);
    }

    getValue() {
      let value = this._string;
      return value == null ? this._string = this._toString(this._value) : value;
    }

    setValue(value) {
      if (is.str(value)) {
        if (value == this._string) {
          return false;
        }

        this._string = value;
        this._value = 1;
      } else if (super.setValue(value)) {
        this._string = null;
      } else {
        return false;
      }

      return true;
    }

    reset(goal) {
      if (goal) {
        this._toString = createInterpolator({
          output: [this.getValue(), goal]
        });
      }

      this._value = 0;
      super.reset();
    }

  }

  const TreeContext = {
    dependencies: null
  };

  class AnimatedObject extends Animated {
    constructor(source) {
      super();
      this.source = source;
      this.setValue(source);
    }

    getValue(animated) {
      const values = {};
      eachProp(this.source, (source, key) => {
        if (isAnimated(source)) {
          values[key] = source.getValue(animated);
        } else if (hasFluidValue(source)) {
          values[key] = getFluidValue(source);
        } else if (!animated) {
          values[key] = source;
        }
      });
      return values;
    }

    setValue(source) {
      this.source = source;
      this.payload = this._makePayload(source);
    }

    reset() {
      if (this.payload) {
        each(this.payload, node => node.reset());
      }
    }

    _makePayload(source) {
      if (source) {
        const payload = new Set();
        eachProp(source, this._addToPayload, payload);
        return Array.from(payload);
      }
    }

    _addToPayload(source) {
      if (TreeContext.dependencies && hasFluidValue(source)) {
        TreeContext.dependencies.add(source);
      }

      const payload = getPayload(source);

      if (payload) {
        each(payload, node => this.add(node));
      }
    }

  }

  class AnimatedArray extends AnimatedObject {
    constructor(source) {
      super(source);
    }

    static create(source) {
      return new AnimatedArray(source);
    }

    getValue() {
      return this.source.map(node => node.getValue());
    }

    setValue(source) {
      const payload = this.getPayload();

      if (source.length == payload.length) {
        return payload.map((node, i) => node.setValue(source[i])).some(Boolean);
      }

      super.setValue(source.map(makeAnimated));
      return true;
    }

  }

  function makeAnimated(value) {
    const nodeType = isAnimatedString(value) ? AnimatedString : AnimatedValue;
    return nodeType.create(value);
  }

  function getAnimatedType(value) {
    const parentNode = getAnimated(value);
    return parentNode ? parentNode.constructor : is.arr(value) ? AnimatedArray : isAnimatedString(value) ? AnimatedString : AnimatedValue;
  }

  function _extends$1() {
    _extends$1 = Object.assign || function (target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i];

        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }

      return target;
    };

    return _extends$1.apply(this, arguments);
  }

  const withAnimated = (Component, host) => {
    const hasInstance = !is.fun(Component) || Component.prototype && Component.prototype.isReactComponent;
    return React.forwardRef((givenProps, givenRef) => {
      const instanceRef = React.useRef(null);
      const ref = hasInstance && React.useCallback(value => {
        instanceRef.current = updateRef(givenRef, value);
      }, [givenRef]);
      const [props, deps] = getAnimatedState(givenProps, host);
      const forceUpdate = useForceUpdate();

      const callback = () => {
        const instance = instanceRef.current;

        if (hasInstance && !instance) {
          return;
        }

        const didUpdate = instance ? host.applyAnimatedValues(instance, props.getValue(true)) : false;

        if (didUpdate === false) {
          forceUpdate();
        }
      };

      const observer = new PropsObserver(callback, deps);
      const observerRef = React.useRef();
      useLayoutEffect(() => {
        const lastObserver = observerRef.current;
        observerRef.current = observer;
        each(deps, dep => addFluidObserver(dep, observer));

        if (lastObserver) {
          each(lastObserver.deps, dep => removeFluidObserver(dep, lastObserver));
          raf.cancel(lastObserver.update);
        }
      });
      React.useEffect(callback, []);
      useOnce(() => () => {
        const observer = observerRef.current;
        each(observer.deps, dep => removeFluidObserver(dep, observer));
      });
      const usedProps = host.getComponentProps(props.getValue());
      return React__namespace.createElement(Component, _extends$1({}, usedProps, {
        ref: ref
      }));
    });
  };

  class PropsObserver {
    constructor(update, deps) {
      this.update = update;
      this.deps = deps;
    }

    eventObserved(event) {
      if (event.type == 'change') {
        raf.write(this.update);
      }
    }

  }

  function getAnimatedState(props, host) {
    const dependencies = new Set();
    TreeContext.dependencies = dependencies;
    if (props.style) props = _extends$1({}, props, {
      style: host.createAnimatedStyle(props.style)
    });
    props = new AnimatedObject(props);
    TreeContext.dependencies = null;
    return [props, dependencies];
  }

  function updateRef(ref, value) {
    if (ref) {
      if (is.fun(ref)) ref(value);else ref.current = value;
    }

    return value;
  }

  const cacheKey = Symbol.for('AnimatedComponent');

  const createHost = (components, {
    applyAnimatedValues: _applyAnimatedValues = () => false,
    createAnimatedStyle: _createAnimatedStyle = style => new AnimatedObject(style),
    getComponentProps: _getComponentProps = props => props
  } = {}) => {
    const hostConfig = {
      applyAnimatedValues: _applyAnimatedValues,
      createAnimatedStyle: _createAnimatedStyle,
      getComponentProps: _getComponentProps
    };

    const animated = Component => {
      const displayName = getDisplayName(Component) || 'Anonymous';

      if (is.str(Component)) {
        Component = animated[Component] || (animated[Component] = withAnimated(Component, hostConfig));
      } else {
        Component = Component[cacheKey] || (Component[cacheKey] = withAnimated(Component, hostConfig));
      }

      Component.displayName = `Animated(${displayName})`;
      return Component;
    };

    eachProp(components, (Component, key) => {
      if (is.arr(components)) {
        key = getDisplayName(Component);
      }

      animated[key] = animated(Component);
    });
    return {
      animated
    };
  };

  const getDisplayName = arg => is.str(arg) ? arg : arg && is.str(arg.displayName) ? arg.displayName : is.fun(arg) && arg.name || null;

  function _extends() {
    _extends = Object.assign || function (target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i];

        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }

      return target;
    };

    return _extends.apply(this, arguments);
  }

  function callProp(value, ...args) {
    return is.fun(value) ? value(...args) : value;
  }

  const matchProp = (value, key) => value === true || !!(key && value && (is.fun(value) ? value(key) : toArray(value).includes(key)));

  const resolveProp = (prop, key) => is.obj(prop) ? key && prop[key] : prop;

  const getDefaultProp = (props, key) => props.default === true ? props[key] : props.default ? props.default[key] : undefined;

  const noopTransform = value => value;

  const getDefaultProps = (props, transform = noopTransform) => {
    let keys = DEFAULT_PROPS;

    if (props.default && props.default !== true) {
      props = props.default;
      keys = Object.keys(props);
    }

    const defaults = {};

    for (const key of keys) {
      const value = transform(props[key], key);

      if (!is.und(value)) {
        defaults[key] = value;
      }
    }

    return defaults;
  };

  const DEFAULT_PROPS = ['config', 'onProps', 'onStart', 'onChange', 'onPause', 'onResume', 'onRest'];
  const RESERVED_PROPS = {
    config: 1,
    from: 1,
    to: 1,
    ref: 1,
    loop: 1,
    reset: 1,
    pause: 1,
    cancel: 1,
    reverse: 1,
    immediate: 1,
    default: 1,
    delay: 1,
    onProps: 1,
    onStart: 1,
    onChange: 1,
    onPause: 1,
    onResume: 1,
    onRest: 1,
    onResolve: 1,
    items: 1,
    trail: 1,
    sort: 1,
    expires: 1,
    initial: 1,
    enter: 1,
    update: 1,
    leave: 1,
    children: 1,
    onDestroyed: 1,
    keys: 1,
    callId: 1,
    parentId: 1
  };

  function getForwardProps(props) {
    const forward = {};
    let count = 0;
    eachProp(props, (value, prop) => {
      if (!RESERVED_PROPS[prop]) {
        forward[prop] = value;
        count++;
      }
    });

    if (count) {
      return forward;
    }
  }

  function inferTo(props) {
    const to = getForwardProps(props);

    if (to) {
      const out = {
        to
      };
      eachProp(props, (val, key) => key in to || (out[key] = val));
      return out;
    }

    return _extends({}, props);
  }

  function computeGoal(value) {
    value = getFluidValue(value);
    return is.arr(value) ? value.map(computeGoal) : isAnimatedString(value) ? globals.createStringInterpolator({
      range: [0, 1],
      output: [value, value]
    })(1) : value;
  }

  function hasProps(props) {
    for (const _ in props) return true;

    return false;
  }

  function isAsyncTo(to) {
    return is.fun(to) || is.arr(to) && is.obj(to[0]);
  }

  function detachRefs(ctrl, ref) {
    var _ctrl$ref;

    (_ctrl$ref = ctrl.ref) == null ? void 0 : _ctrl$ref.delete(ctrl);
    ref == null ? void 0 : ref.delete(ctrl);
  }

  function replaceRef(ctrl, ref) {
    if (ref && ctrl.ref !== ref) {
      var _ctrl$ref2;

      (_ctrl$ref2 = ctrl.ref) == null ? void 0 : _ctrl$ref2.delete(ctrl);
      ref.add(ctrl);
      ctrl.ref = ref;
    }
  }

  const config = {
    default: {
      tension: 170,
      friction: 26
    },
    gentle: {
      tension: 120,
      friction: 14
    },
    wobbly: {
      tension: 180,
      friction: 12
    },
    stiff: {
      tension: 210,
      friction: 20
    },
    slow: {
      tension: 280,
      friction: 60
    },
    molasses: {
      tension: 280,
      friction: 120
    }
  };

  const linear = t => t;

  const defaults = _extends({}, config.default, {
    mass: 1,
    damping: 1,
    easing: linear,
    clamp: false
  });

  class AnimationConfig {
    constructor() {
      this.tension = void 0;
      this.friction = void 0;
      this.frequency = void 0;
      this.damping = void 0;
      this.mass = void 0;
      this.velocity = 0;
      this.restVelocity = void 0;
      this.precision = void 0;
      this.progress = void 0;
      this.duration = void 0;
      this.easing = void 0;
      this.clamp = void 0;
      this.bounce = void 0;
      this.decay = void 0;
      this.round = void 0;
      Object.assign(this, defaults);
    }

  }

  function mergeConfig(config, newConfig, defaultConfig) {
    if (defaultConfig) {
      defaultConfig = _extends({}, defaultConfig);
      sanitizeConfig(defaultConfig, newConfig);
      newConfig = _extends({}, defaultConfig, newConfig);
    }

    sanitizeConfig(config, newConfig);
    Object.assign(config, newConfig);

    for (const key in defaults) {
      if (config[key] == null) {
        config[key] = defaults[key];
      }
    }

    let {
      mass,
      frequency,
      damping
    } = config;

    if (!is.und(frequency)) {
      if (frequency < 0.01) frequency = 0.01;
      if (damping < 0) damping = 0;
      config.tension = Math.pow(2 * Math.PI / frequency, 2) * mass;
      config.friction = 4 * Math.PI * damping * mass / frequency;
    }

    return config;
  }

  function sanitizeConfig(config, props) {
    if (!is.und(props.decay)) {
      config.duration = undefined;
    } else {
      const isTensionConfig = !is.und(props.tension) || !is.und(props.friction);

      if (isTensionConfig || !is.und(props.frequency) || !is.und(props.damping) || !is.und(props.mass)) {
        config.duration = undefined;
        config.decay = undefined;
      }

      if (isTensionConfig) {
        config.frequency = undefined;
      }
    }
  }

  const emptyArray = [];

  class Animation {
    constructor() {
      this.changed = false;
      this.values = emptyArray;
      this.toValues = null;
      this.fromValues = emptyArray;
      this.to = void 0;
      this.from = void 0;
      this.config = new AnimationConfig();
      this.immediate = false;
    }

  }

  function scheduleProps(callId, {
    key,
    props,
    defaultProps,
    state,
    actions
  }) {
    return new Promise((resolve, reject) => {
      var _props$cancel;

      let delay;
      let timeout;
      let cancel = matchProp((_props$cancel = props.cancel) != null ? _props$cancel : defaultProps == null ? void 0 : defaultProps.cancel, key);

      if (cancel) {
        onStart();
      } else {
        if (!is.und(props.pause)) {
          state.paused = matchProp(props.pause, key);
        }

        let pause = defaultProps == null ? void 0 : defaultProps.pause;

        if (pause !== true) {
          pause = state.paused || matchProp(pause, key);
        }

        delay = callProp(props.delay || 0, key);

        if (pause) {
          state.resumeQueue.add(onResume);
          actions.pause();
        } else {
          actions.resume();
          onResume();
        }
      }

      function onPause() {
        state.resumeQueue.add(onResume);
        state.timeouts.delete(timeout);
        timeout.cancel();
        delay = timeout.time - raf.now();
      }

      function onResume() {
        if (delay > 0) {
          timeout = raf.setTimeout(onStart, delay);
          state.pauseQueue.add(onPause);
          state.timeouts.add(timeout);
        } else {
          onStart();
        }
      }

      function onStart() {
        state.pauseQueue.delete(onPause);
        state.timeouts.delete(timeout);

        if (callId <= (state.cancelId || 0)) {
          cancel = true;
        }

        try {
          actions.start(_extends({}, props, {
            callId,
            cancel
          }), resolve);
        } catch (err) {
          reject(err);
        }
      }
    });
  }

  const getCombinedResult = (target, results) => results.length == 1 ? results[0] : results.some(result => result.cancelled) ? getCancelledResult(target.get()) : results.every(result => result.noop) ? getNoopResult(target.get()) : getFinishedResult(target.get(), results.every(result => result.finished));

  const getNoopResult = value => ({
    value,
    noop: true,
    finished: true,
    cancelled: false
  });

  const getFinishedResult = (value, finished, cancelled = false) => ({
    value,
    finished,
    cancelled
  });

  const getCancelledResult = value => ({
    value,
    cancelled: true,
    finished: false
  });

  function runAsync(to, props, state, target) {
    const {
      callId,
      parentId,
      onRest
    } = props;
    const {
      asyncTo: prevTo,
      promise: prevPromise
    } = state;

    if (!parentId && to === prevTo && !props.reset) {
      return prevPromise;
    }

    return state.promise = (async () => {
      state.asyncId = callId;
      state.asyncTo = to;
      const defaultProps = getDefaultProps(props, (value, key) => key === 'onRest' ? undefined : value);
      let preventBail;
      let bail;
      const bailPromise = new Promise((resolve, reject) => (preventBail = resolve, bail = reject));

      const bailIfEnded = bailSignal => {
        const bailResult = callId <= (state.cancelId || 0) && getCancelledResult(target) || callId !== state.asyncId && getFinishedResult(target, false);

        if (bailResult) {
          bailSignal.result = bailResult;
          bail(bailSignal);
          throw bailSignal;
        }
      };

      const animate = (arg1, arg2) => {
        const bailSignal = new BailSignal();
        const skipAnimationSignal = new SkipAniamtionSignal();
        return (async () => {
          if (globals.skipAnimation) {
            stopAsync(state);
            skipAnimationSignal.result = getFinishedResult(target, false);
            bail(skipAnimationSignal);
            throw skipAnimationSignal;
          }

          bailIfEnded(bailSignal);
          const props = is.obj(arg1) ? _extends({}, arg1) : _extends({}, arg2, {
            to: arg1
          });
          props.parentId = callId;
          eachProp(defaultProps, (value, key) => {
            if (is.und(props[key])) {
              props[key] = value;
            }
          });
          const result = await target.start(props);
          bailIfEnded(bailSignal);

          if (state.paused) {
            await new Promise(resume => {
              state.resumeQueue.add(resume);
            });
          }

          return result;
        })();
      };

      let result;

      if (globals.skipAnimation) {
        stopAsync(state);
        return getFinishedResult(target, false);
      }

      try {
        let animating;

        if (is.arr(to)) {
          animating = (async queue => {
            for (const props of queue) {
              await animate(props);
            }
          })(to);
        } else {
          animating = Promise.resolve(to(animate, target.stop.bind(target)));
        }

        await Promise.all([animating.then(preventBail), bailPromise]);
        result = getFinishedResult(target.get(), true, false);
      } catch (err) {
        if (err instanceof BailSignal) {
          result = err.result;
        } else if (err instanceof SkipAniamtionSignal) {
          result = err.result;
        } else {
          throw err;
        }
      } finally {
        if (callId == state.asyncId) {
          state.asyncId = parentId;
          state.asyncTo = parentId ? prevTo : undefined;
          state.promise = parentId ? prevPromise : undefined;
        }
      }

      if (is.fun(onRest)) {
        raf.batchedUpdates(() => {
          onRest(result, target, target.item);
        });
      }

      return result;
    })();
  }

  function stopAsync(state, cancelId) {
    flush(state.timeouts, t => t.cancel());
    state.pauseQueue.clear();
    state.resumeQueue.clear();
    state.asyncId = state.asyncTo = state.promise = undefined;
    if (cancelId) state.cancelId = cancelId;
  }

  class BailSignal extends Error {
    constructor() {
      super('An async animation has been interrupted. You see this error because you ' + 'forgot to use `await` or `.catch(...)` on its returned promise.');
      this.result = void 0;
    }

  }

  class SkipAniamtionSignal extends Error {
    constructor() {
      super('SkipAnimationSignal');
      this.result = void 0;
    }

  }

  const isFrameValue = value => value instanceof FrameValue;

  let nextId$1 = 1;

  class FrameValue extends FluidValue {
    constructor(...args) {
      super(...args);
      this.id = nextId$1++;
      this.key = void 0;
      this._priority = 0;
    }

    get priority() {
      return this._priority;
    }

    set priority(priority) {
      if (this._priority != priority) {
        this._priority = priority;

        this._onPriorityChange(priority);
      }
    }

    get() {
      const node = getAnimated(this);
      return node && node.getValue();
    }

    to(...args) {
      return globals.to(this, args);
    }

    interpolate(...args) {
      deprecateInterpolate();
      return globals.to(this, args);
    }

    toJSON() {
      return this.get();
    }

    observerAdded(count) {
      if (count == 1) this._attach();
    }

    observerRemoved(count) {
      if (count == 0) this._detach();
    }

    _attach() {}

    _detach() {}

    _onChange(value, idle = false) {
      callFluidObservers(this, {
        type: 'change',
        parent: this,
        value,
        idle
      });
    }

    _onPriorityChange(priority) {
      if (!this.idle) {
        frameLoop.sort(this);
      }

      callFluidObservers(this, {
        type: 'priority',
        parent: this,
        priority
      });
    }

  }

  const $P = Symbol.for('SpringPhase');
  const HAS_ANIMATED = 1;
  const IS_ANIMATING = 2;
  const IS_PAUSED = 4;

  const hasAnimated = target => (target[$P] & HAS_ANIMATED) > 0;

  const isAnimating = target => (target[$P] & IS_ANIMATING) > 0;

  const isPaused = target => (target[$P] & IS_PAUSED) > 0;

  const setActiveBit = (target, active) => active ? target[$P] |= IS_ANIMATING | HAS_ANIMATED : target[$P] &= ~IS_ANIMATING;

  const setPausedBit = (target, paused) => paused ? target[$P] |= IS_PAUSED : target[$P] &= ~IS_PAUSED;

  class SpringValue extends FrameValue {
    constructor(arg1, arg2) {
      super();
      this.key = void 0;
      this.animation = new Animation();
      this.queue = void 0;
      this.defaultProps = {};
      this._state = {
        paused: false,
        pauseQueue: new Set(),
        resumeQueue: new Set(),
        timeouts: new Set()
      };
      this._pendingCalls = new Set();
      this._lastCallId = 0;
      this._lastToId = 0;
      this._memoizedDuration = 0;

      if (!is.und(arg1) || !is.und(arg2)) {
        const props = is.obj(arg1) ? _extends({}, arg1) : _extends({}, arg2, {
          from: arg1
        });

        if (is.und(props.default)) {
          props.default = true;
        }

        this.start(props);
      }
    }

    get idle() {
      return !(isAnimating(this) || this._state.asyncTo) || isPaused(this);
    }

    get goal() {
      return getFluidValue(this.animation.to);
    }

    get velocity() {
      const node = getAnimated(this);
      return node instanceof AnimatedValue ? node.lastVelocity || 0 : node.getPayload().map(node => node.lastVelocity || 0);
    }

    get hasAnimated() {
      return hasAnimated(this);
    }

    get isAnimating() {
      return isAnimating(this);
    }

    get isPaused() {
      return isPaused(this);
    }

    advance(dt) {
      let idle = true;
      let changed = false;
      const anim = this.animation;
      let {
        config,
        toValues
      } = anim;
      const payload = getPayload(anim.to);

      if (!payload && hasFluidValue(anim.to)) {
        toValues = toArray(getFluidValue(anim.to));
      }

      anim.values.forEach((node, i) => {
        if (node.done) return;
        const to = node.constructor == AnimatedString ? 1 : payload ? payload[i].lastPosition : toValues[i];
        let finished = anim.immediate;
        let position = to;

        if (!finished) {
          position = node.lastPosition;

          if (config.tension <= 0) {
            node.done = true;
            return;
          }

          let elapsed = node.elapsedTime += dt;
          const from = anim.fromValues[i];
          const v0 = node.v0 != null ? node.v0 : node.v0 = is.arr(config.velocity) ? config.velocity[i] : config.velocity;
          let velocity;

          if (!is.und(config.duration)) {
            let p = 1;

            if (config.duration > 0) {
              if (this._memoizedDuration !== config.duration) {
                this._memoizedDuration = config.duration;

                if (node.durationProgress > 0) {
                  node.elapsedTime = config.duration * node.durationProgress;
                  elapsed = node.elapsedTime += dt;
                }
              }

              p = (config.progress || 0) + elapsed / this._memoizedDuration;
              p = p > 1 ? 1 : p < 0 ? 0 : p;
              node.durationProgress = p;
            }

            position = from + config.easing(p) * (to - from);
            velocity = (position - node.lastPosition) / dt;
            finished = p == 1;
          } else if (config.decay) {
            const decay = config.decay === true ? 0.998 : config.decay;
            const e = Math.exp(-(1 - decay) * elapsed);
            position = from + v0 / (1 - decay) * (1 - e);
            finished = Math.abs(node.lastPosition - position) < 0.1;
            velocity = v0 * e;
          } else {
            velocity = node.lastVelocity == null ? v0 : node.lastVelocity;
            const precision = config.precision || (from == to ? 0.005 : Math.min(1, Math.abs(to - from) * 0.001));
            const restVelocity = config.restVelocity || precision / 10;
            const bounceFactor = config.clamp ? 0 : config.bounce;
            const canBounce = !is.und(bounceFactor);
            const isGrowing = from == to ? node.v0 > 0 : from < to;
            let isMoving;
            let isBouncing = false;
            const step = 1;
            const numSteps = Math.ceil(dt / step);

            for (let n = 0; n < numSteps; ++n) {
              isMoving = Math.abs(velocity) > restVelocity;

              if (!isMoving) {
                finished = Math.abs(to - position) <= precision;

                if (finished) {
                  break;
                }
              }

              if (canBounce) {
                isBouncing = position == to || position > to == isGrowing;

                if (isBouncing) {
                  velocity = -velocity * bounceFactor;
                  position = to;
                }
              }

              const springForce = -config.tension * 0.000001 * (position - to);
              const dampingForce = -config.friction * 0.001 * velocity;
              const acceleration = (springForce + dampingForce) / config.mass;
              velocity = velocity + acceleration * step;
              position = position + velocity * step;
            }
          }

          node.lastVelocity = velocity;

          if (Number.isNaN(position)) {
            console.warn(`Got NaN while animating:`, this);
            finished = true;
          }
        }

        if (payload && !payload[i].done) {
          finished = false;
        }

        if (finished) {
          node.done = true;
        } else {
          idle = false;
        }

        if (node.setValue(position, config.round)) {
          changed = true;
        }
      });
      const node = getAnimated(this);
      const currVal = node.getValue();

      if (idle) {
        const finalVal = getFluidValue(anim.to);

        if ((currVal !== finalVal || changed) && !config.decay) {
          node.setValue(finalVal);

          this._onChange(finalVal);
        } else if (changed && config.decay) {
          this._onChange(currVal);
        }

        this._stop();
      } else if (changed) {
        this._onChange(currVal);
      }
    }

    set(value) {
      raf.batchedUpdates(() => {
        this._stop();

        this._focus(value);

        this._set(value);
      });
      return this;
    }

    pause() {
      this._update({
        pause: true
      });
    }

    resume() {
      this._update({
        pause: false
      });
    }

    finish() {
      if (isAnimating(this)) {
        const {
          to,
          config
        } = this.animation;
        raf.batchedUpdates(() => {
          this._onStart();

          if (!config.decay) {
            this._set(to, false);
          }

          this._stop();
        });
      }

      return this;
    }

    update(props) {
      const queue = this.queue || (this.queue = []);
      queue.push(props);
      return this;
    }

    start(to, arg2) {
      let queue;

      if (!is.und(to)) {
        queue = [is.obj(to) ? to : _extends({}, arg2, {
          to
        })];
      } else {
        queue = this.queue || [];
        this.queue = [];
      }

      return Promise.all(queue.map(props => this._update(props))).then(results => getCombinedResult(this, results));
    }

    stop(cancel) {
      const {
        to
      } = this.animation;

      this._focus(this.get());

      stopAsync(this._state, cancel && this._lastCallId);
      raf.batchedUpdates(() => this._stop(to, cancel));
      return this;
    }

    reset() {
      this._update({
        reset: true
      });
    }

    eventObserved(event) {
      if (event.type == 'change') {
        this._start();
      } else if (event.type == 'priority') {
        this.priority = event.priority + 1;
      }
    }

    _prepareNode(props) {
      const key = this.key || '';
      let {
        to,
        from
      } = props;
      to = is.obj(to) ? to[key] : to;

      if (to == null || isAsyncTo(to)) {
        to = undefined;
      }

      from = is.obj(from) ? from[key] : from;

      if (from == null) {
        from = undefined;
      }

      const range = {
        to,
        from
      };

      if (!hasAnimated(this)) {
        if (props.reverse) [to, from] = [from, to];
        from = getFluidValue(from);

        if (!is.und(from)) {
          this._set(from);
        } else if (!getAnimated(this)) {
          this._set(to);
        }
      }

      return range;
    }

    _update(_ref, isLoop) {
      let props = _extends({}, _ref);

      const {
        key,
        defaultProps
      } = this;
      if (props.default) Object.assign(defaultProps, getDefaultProps(props, (value, prop) => /^on/.test(prop) ? resolveProp(value, key) : value));
      mergeActiveFn(this, props, 'onProps');
      sendEvent(this, 'onProps', props, this);

      const range = this._prepareNode(props);

      if (Object.isFrozen(this)) {
        throw Error('Cannot animate a `SpringValue` object that is frozen. ' + 'Did you forget to pass your component to `animated(...)` before animating its props?');
      }

      const state = this._state;
      return scheduleProps(++this._lastCallId, {
        key,
        props,
        defaultProps,
        state,
        actions: {
          pause: () => {
            if (!isPaused(this)) {
              setPausedBit(this, true);
              flushCalls(state.pauseQueue);
              sendEvent(this, 'onPause', getFinishedResult(this, checkFinished(this, this.animation.to)), this);
            }
          },
          resume: () => {
            if (isPaused(this)) {
              setPausedBit(this, false);

              if (isAnimating(this)) {
                this._resume();
              }

              flushCalls(state.resumeQueue);
              sendEvent(this, 'onResume', getFinishedResult(this, checkFinished(this, this.animation.to)), this);
            }
          },
          start: this._merge.bind(this, range)
        }
      }).then(result => {
        if (props.loop && result.finished && !(isLoop && result.noop)) {
          const nextProps = createLoopUpdate(props);

          if (nextProps) {
            return this._update(nextProps, true);
          }
        }

        return result;
      });
    }

    _merge(range, props, resolve) {
      if (props.cancel) {
        this.stop(true);
        return resolve(getCancelledResult(this));
      }

      const hasToProp = !is.und(range.to);
      const hasFromProp = !is.und(range.from);

      if (hasToProp || hasFromProp) {
        if (props.callId > this._lastToId) {
          this._lastToId = props.callId;
        } else {
          return resolve(getCancelledResult(this));
        }
      }

      const {
        key,
        defaultProps,
        animation: anim
      } = this;
      const {
        to: prevTo,
        from: prevFrom
      } = anim;
      let {
        to = prevTo,
        from = prevFrom
      } = range;

      if (hasFromProp && !hasToProp && (!props.default || is.und(to))) {
        to = from;
      }

      if (props.reverse) [to, from] = [from, to];
      const hasFromChanged = !isEqual(from, prevFrom);

      if (hasFromChanged) {
        anim.from = from;
      }

      from = getFluidValue(from);
      const hasToChanged = !isEqual(to, prevTo);

      if (hasToChanged) {
        this._focus(to);
      }

      const hasAsyncTo = isAsyncTo(props.to);
      const {
        config
      } = anim;
      const {
        decay,
        velocity
      } = config;

      if (hasToProp || hasFromProp) {
        config.velocity = 0;
      }

      if (props.config && !hasAsyncTo) {
        mergeConfig(config, callProp(props.config, key), props.config !== defaultProps.config ? callProp(defaultProps.config, key) : void 0);
      }

      let node = getAnimated(this);

      if (!node || is.und(to)) {
        return resolve(getFinishedResult(this, true));
      }

      const reset = is.und(props.reset) ? hasFromProp && !props.default : !is.und(from) && matchProp(props.reset, key);
      const value = reset ? from : this.get();
      const goal = computeGoal(to);
      const isAnimatable = is.num(goal) || is.arr(goal) || isAnimatedString(goal);
      const immediate = !hasAsyncTo && (!isAnimatable || matchProp(defaultProps.immediate || props.immediate, key));

      if (hasToChanged) {
        const nodeType = getAnimatedType(to);

        if (nodeType !== node.constructor) {
          if (immediate) {
            node = this._set(goal);
          } else throw Error(`Cannot animate between ${node.constructor.name} and ${nodeType.name}, as the "to" prop suggests`);
        }
      }

      const goalType = node.constructor;
      let started = hasFluidValue(to);
      let finished = false;

      if (!started) {
        const hasValueChanged = reset || !hasAnimated(this) && hasFromChanged;

        if (hasToChanged || hasValueChanged) {
          finished = isEqual(computeGoal(value), goal);
          started = !finished;
        }

        if (!isEqual(anim.immediate, immediate) && !immediate || !isEqual(config.decay, decay) || !isEqual(config.velocity, velocity)) {
          started = true;
        }
      }

      if (finished && isAnimating(this)) {
        if (anim.changed && !reset) {
          started = true;
        } else if (!started) {
          this._stop(prevTo);
        }
      }

      if (!hasAsyncTo) {
        if (started || hasFluidValue(prevTo)) {
          anim.values = node.getPayload();
          anim.toValues = hasFluidValue(to) ? null : goalType == AnimatedString ? [1] : toArray(goal);
        }

        if (anim.immediate != immediate) {
          anim.immediate = immediate;

          if (!immediate && !reset) {
            this._set(prevTo);
          }
        }

        if (started) {
          const {
            onRest
          } = anim;
          each(ACTIVE_EVENTS, type => mergeActiveFn(this, props, type));
          const result = getFinishedResult(this, checkFinished(this, prevTo));
          flushCalls(this._pendingCalls, result);

          this._pendingCalls.add(resolve);

          if (anim.changed) raf.batchedUpdates(() => {
            anim.changed = !reset;
            onRest == null ? void 0 : onRest(result, this);

            if (reset) {
              callProp(defaultProps.onRest, result);
            } else {
              anim.onStart == null ? void 0 : anim.onStart(result, this);
            }
          });
        }
      }

      if (reset) {
        this._set(value);
      }

      if (hasAsyncTo) {
        resolve(runAsync(props.to, props, this._state, this));
      } else if (started) {
        this._start();
      } else if (isAnimating(this) && !hasToChanged) {
        this._pendingCalls.add(resolve);
      } else {
        resolve(getNoopResult(value));
      }
    }

    _focus(value) {
      const anim = this.animation;

      if (value !== anim.to) {
        if (getFluidObservers(this)) {
          this._detach();
        }

        anim.to = value;

        if (getFluidObservers(this)) {
          this._attach();
        }
      }
    }

    _attach() {
      let priority = 0;
      const {
        to
      } = this.animation;

      if (hasFluidValue(to)) {
        addFluidObserver(to, this);

        if (isFrameValue(to)) {
          priority = to.priority + 1;
        }
      }

      this.priority = priority;
    }

    _detach() {
      const {
        to
      } = this.animation;

      if (hasFluidValue(to)) {
        removeFluidObserver(to, this);
      }
    }

    _set(arg, idle = true) {
      const value = getFluidValue(arg);

      if (!is.und(value)) {
        const oldNode = getAnimated(this);

        if (!oldNode || !isEqual(value, oldNode.getValue())) {
          const nodeType = getAnimatedType(value);

          if (!oldNode || oldNode.constructor != nodeType) {
            setAnimated(this, nodeType.create(value));
          } else {
            oldNode.setValue(value);
          }

          if (oldNode) {
            raf.batchedUpdates(() => {
              this._onChange(value, idle);
            });
          }
        }
      }

      return getAnimated(this);
    }

    _onStart() {
      const anim = this.animation;

      if (!anim.changed) {
        anim.changed = true;
        sendEvent(this, 'onStart', getFinishedResult(this, checkFinished(this, anim.to)), this);
      }
    }

    _onChange(value, idle) {
      if (!idle) {
        this._onStart();

        callProp(this.animation.onChange, value, this);
      }

      callProp(this.defaultProps.onChange, value, this);

      super._onChange(value, idle);
    }

    _start() {
      const anim = this.animation;
      getAnimated(this).reset(getFluidValue(anim.to));

      if (!anim.immediate) {
        anim.fromValues = anim.values.map(node => node.lastPosition);
      }

      if (!isAnimating(this)) {
        setActiveBit(this, true);

        if (!isPaused(this)) {
          this._resume();
        }
      }
    }

    _resume() {
      if (globals.skipAnimation) {
        this.finish();
      } else {
        frameLoop.start(this);
      }
    }

    _stop(goal, cancel) {
      if (isAnimating(this)) {
        setActiveBit(this, false);
        const anim = this.animation;
        each(anim.values, node => {
          node.done = true;
        });

        if (anim.toValues) {
          anim.onChange = anim.onPause = anim.onResume = undefined;
        }

        callFluidObservers(this, {
          type: 'idle',
          parent: this
        });
        const result = cancel ? getCancelledResult(this.get()) : getFinishedResult(this.get(), checkFinished(this, goal != null ? goal : anim.to));
        flushCalls(this._pendingCalls, result);

        if (anim.changed) {
          anim.changed = false;
          sendEvent(this, 'onRest', result, this);
        }
      }
    }

  }

  function checkFinished(target, to) {
    const goal = computeGoal(to);
    const value = computeGoal(target.get());
    return isEqual(value, goal);
  }

  function createLoopUpdate(props, loop = props.loop, to = props.to) {
    let loopRet = callProp(loop);

    if (loopRet) {
      const overrides = loopRet !== true && inferTo(loopRet);
      const reverse = (overrides || props).reverse;
      const reset = !overrides || overrides.reset;
      return createUpdate(_extends({}, props, {
        loop,
        default: false,
        pause: undefined,
        to: !reverse || isAsyncTo(to) ? to : undefined,
        from: reset ? props.from : undefined,
        reset
      }, overrides));
    }
  }

  function createUpdate(props) {
    const {
      to,
      from
    } = props = inferTo(props);
    const keys = new Set();
    if (is.obj(to)) findDefined(to, keys);
    if (is.obj(from)) findDefined(from, keys);
    props.keys = keys.size ? Array.from(keys) : null;
    return props;
  }

  function declareUpdate(props) {
    const update = createUpdate(props);

    if (is.und(update.default)) {
      update.default = getDefaultProps(update);
    }

    return update;
  }

  function findDefined(values, keys) {
    eachProp(values, (value, key) => value != null && keys.add(key));
  }

  const ACTIVE_EVENTS = ['onStart', 'onRest', 'onChange', 'onPause', 'onResume'];

  function mergeActiveFn(target, props, type) {
    target.animation[type] = props[type] !== getDefaultProp(props, type) ? resolveProp(props[type], target.key) : undefined;
  }

  function sendEvent(target, type, ...args) {
    var _target$animation$typ, _target$animation, _target$defaultProps$, _target$defaultProps;

    (_target$animation$typ = (_target$animation = target.animation)[type]) == null ? void 0 : _target$animation$typ.call(_target$animation, ...args);
    (_target$defaultProps$ = (_target$defaultProps = target.defaultProps)[type]) == null ? void 0 : _target$defaultProps$.call(_target$defaultProps, ...args);
  }

  const BATCHED_EVENTS = ['onStart', 'onChange', 'onRest'];
  let nextId = 1;

  class Controller {
    constructor(props, flush) {
      this.id = nextId++;
      this.springs = {};
      this.queue = [];
      this.ref = void 0;
      this._flush = void 0;
      this._initialProps = void 0;
      this._lastAsyncId = 0;
      this._active = new Set();
      this._changed = new Set();
      this._started = false;
      this._item = void 0;
      this._state = {
        paused: false,
        pauseQueue: new Set(),
        resumeQueue: new Set(),
        timeouts: new Set()
      };
      this._events = {
        onStart: new Map(),
        onChange: new Map(),
        onRest: new Map()
      };
      this._onFrame = this._onFrame.bind(this);

      if (flush) {
        this._flush = flush;
      }

      if (props) {
        this.start(_extends({
          default: true
        }, props));
      }
    }

    get idle() {
      return !this._state.asyncTo && Object.values(this.springs).every(spring => spring.idle);
    }

    get item() {
      return this._item;
    }

    set item(item) {
      this._item = item;
    }

    get() {
      const values = {};
      this.each((spring, key) => values[key] = spring.get());
      return values;
    }

    set(values) {
      for (const key in values) {
        const value = values[key];

        if (!is.und(value)) {
          this.springs[key].set(value);
        }
      }
    }

    update(props) {
      if (props) {
        this.queue.push(createUpdate(props));
      }

      return this;
    }

    start(props) {
      let {
        queue
      } = this;

      if (props) {
        queue = toArray(props).map(createUpdate);
      } else {
        this.queue = [];
      }

      if (this._flush) {
        return this._flush(this, queue);
      }

      prepareKeys(this, queue);
      return flushUpdateQueue(this, queue);
    }

    stop(arg, keys) {
      if (arg !== !!arg) {
        keys = arg;
      }

      if (keys) {
        const springs = this.springs;
        each(toArray(keys), key => springs[key].stop(!!arg));
      } else {
        stopAsync(this._state, this._lastAsyncId);
        this.each(spring => spring.stop(!!arg));
      }

      return this;
    }

    pause(keys) {
      if (is.und(keys)) {
        this.start({
          pause: true
        });
      } else {
        const springs = this.springs;
        each(toArray(keys), key => springs[key].pause());
      }

      return this;
    }

    resume(keys) {
      if (is.und(keys)) {
        this.start({
          pause: false
        });
      } else {
        const springs = this.springs;
        each(toArray(keys), key => springs[key].resume());
      }

      return this;
    }

    each(iterator) {
      eachProp(this.springs, iterator);
    }

    _onFrame() {
      const {
        onStart,
        onChange,
        onRest
      } = this._events;
      const active = this._active.size > 0;
      const changed = this._changed.size > 0;

      if (active && !this._started || changed && !this._started) {
        this._started = true;
        flush(onStart, ([onStart, result]) => {
          result.value = this.get();
          onStart(result, this, this._item);
        });
      }

      const idle = !active && this._started;
      const values = changed || idle && onRest.size ? this.get() : null;

      if (changed && onChange.size) {
        flush(onChange, ([onChange, result]) => {
          result.value = values;
          onChange(result, this, this._item);
        });
      }

      if (idle) {
        this._started = false;
        flush(onRest, ([onRest, result]) => {
          result.value = values;
          onRest(result, this, this._item);
        });
      }
    }

    eventObserved(event) {
      if (event.type == 'change') {
        this._changed.add(event.parent);

        if (!event.idle) {
          this._active.add(event.parent);
        }
      } else if (event.type == 'idle') {
        this._active.delete(event.parent);
      } else return;

      raf.onFrame(this._onFrame);
    }

  }

  function flushUpdateQueue(ctrl, queue) {
    return Promise.all(queue.map(props => flushUpdate(ctrl, props))).then(results => getCombinedResult(ctrl, results));
  }

  async function flushUpdate(ctrl, props, isLoop) {
    const {
      keys,
      to,
      from,
      loop,
      onRest,
      onResolve
    } = props;
    const defaults = is.obj(props.default) && props.default;

    if (loop) {
      props.loop = false;
    }

    if (to === false) props.to = null;
    if (from === false) props.from = null;
    const asyncTo = is.arr(to) || is.fun(to) ? to : undefined;

    if (asyncTo) {
      props.to = undefined;
      props.onRest = undefined;

      if (defaults) {
        defaults.onRest = undefined;
      }
    } else {
      each(BATCHED_EVENTS, key => {
        const handler = props[key];

        if (is.fun(handler)) {
          const queue = ctrl['_events'][key];

          props[key] = ({
            finished,
            cancelled
          }) => {
            const result = queue.get(handler);

            if (result) {
              if (!finished) result.finished = false;
              if (cancelled) result.cancelled = true;
            } else {
              queue.set(handler, {
                value: null,
                finished: finished || false,
                cancelled: cancelled || false
              });
            }
          };

          if (defaults) {
            defaults[key] = props[key];
          }
        }
      });
    }

    const state = ctrl['_state'];

    if (props.pause === !state.paused) {
      state.paused = props.pause;
      flushCalls(props.pause ? state.pauseQueue : state.resumeQueue);
    } else if (state.paused) {
      props.pause = true;
    }

    const promises = (keys || Object.keys(ctrl.springs)).map(key => ctrl.springs[key].start(props));
    const cancel = props.cancel === true || getDefaultProp(props, 'cancel') === true;

    if (asyncTo || cancel && state.asyncId) {
      promises.push(scheduleProps(++ctrl['_lastAsyncId'], {
        props,
        state,
        actions: {
          pause: noop,
          resume: noop,

          start(props, resolve) {
            if (cancel) {
              stopAsync(state, ctrl['_lastAsyncId']);
              resolve(getCancelledResult(ctrl));
            } else {
              props.onRest = onRest;
              resolve(runAsync(asyncTo, props, state, ctrl));
            }
          }

        }
      }));
    }

    if (state.paused) {
      await new Promise(resume => {
        state.resumeQueue.add(resume);
      });
    }

    const result = getCombinedResult(ctrl, await Promise.all(promises));

    if (loop && result.finished && !(isLoop && result.noop)) {
      const nextProps = createLoopUpdate(props, loop, to);

      if (nextProps) {
        prepareKeys(ctrl, [nextProps]);
        return flushUpdate(ctrl, nextProps, true);
      }
    }

    if (onResolve) {
      raf.batchedUpdates(() => onResolve(result, ctrl, ctrl.item));
    }

    return result;
  }

  function getSprings(ctrl, props) {
    const springs = _extends({}, ctrl.springs);

    if (props) {
      each(toArray(props), props => {
        if (is.und(props.keys)) {
          props = createUpdate(props);
        }

        if (!is.obj(props.to)) {
          props = _extends({}, props, {
            to: undefined
          });
        }

        prepareSprings(springs, props, key => {
          return createSpring(key);
        });
      });
    }

    setSprings(ctrl, springs);
    return springs;
  }

  function setSprings(ctrl, springs) {
    eachProp(springs, (spring, key) => {
      if (!ctrl.springs[key]) {
        ctrl.springs[key] = spring;
        addFluidObserver(spring, ctrl);
      }
    });
  }

  function createSpring(key, observer) {
    const spring = new SpringValue();
    spring.key = key;

    if (observer) {
      addFluidObserver(spring, observer);
    }

    return spring;
  }

  function prepareSprings(springs, props, create) {
    if (props.keys) {
      each(props.keys, key => {
        const spring = springs[key] || (springs[key] = create(key));
        spring['_prepareNode'](props);
      });
    }
  }

  function prepareKeys(ctrl, queue) {
    each(queue, props => {
      prepareSprings(ctrl.springs, props, key => {
        return createSpring(key, ctrl);
      });
    });
  }

  function _objectWithoutPropertiesLoose$1(source, excluded) {
    if (source == null) return {};
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;

    for (i = 0; i < sourceKeys.length; i++) {
      key = sourceKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      target[key] = source[key];
    }

    return target;
  }

  const _excluded$3$1 = ["children"];

  const SpringContext = _ref => {
    let {
      children
    } = _ref,
        props = _objectWithoutPropertiesLoose$1(_ref, _excluded$3$1);

    const inherited = React.useContext(ctx);
    const pause = props.pause || !!inherited.pause,
          immediate = props.immediate || !!inherited.immediate;
    props = useMemoOne(() => ({
      pause,
      immediate
    }), [pause, immediate]);
    const {
      Provider
    } = ctx;
    return React__namespace.createElement(Provider, {
      value: props
    }, children);
  };

  const ctx = makeContext(SpringContext, {});
  SpringContext.Provider = ctx.Provider;
  SpringContext.Consumer = ctx.Consumer;

  function makeContext(target, init) {
    Object.assign(target, React__namespace.createContext(init));
    target.Provider._context = target;
    target.Consumer._context = target;
    return target;
  }

  const SpringRef = () => {
    const current = [];

    const SpringRef = function SpringRef(props) {
      deprecateDirectCall();
      const results = [];
      each(current, (ctrl, i) => {
        if (is.und(props)) {
          results.push(ctrl.start());
        } else {
          const update = _getProps(props, ctrl, i);

          if (update) {
            results.push(ctrl.start(update));
          }
        }
      });
      return results;
    };

    SpringRef.current = current;

    SpringRef.add = function (ctrl) {
      if (!current.includes(ctrl)) {
        current.push(ctrl);
      }
    };

    SpringRef.delete = function (ctrl) {
      const i = current.indexOf(ctrl);
      if (~i) current.splice(i, 1);
    };

    SpringRef.pause = function () {
      each(current, ctrl => ctrl.pause(...arguments));
      return this;
    };

    SpringRef.resume = function () {
      each(current, ctrl => ctrl.resume(...arguments));
      return this;
    };

    SpringRef.set = function (values) {
      each(current, ctrl => ctrl.set(values));
    };

    SpringRef.start = function (props) {
      const results = [];
      each(current, (ctrl, i) => {
        if (is.und(props)) {
          results.push(ctrl.start());
        } else {
          const update = this._getProps(props, ctrl, i);

          if (update) {
            results.push(ctrl.start(update));
          }
        }
      });
      return results;
    };

    SpringRef.stop = function () {
      each(current, ctrl => ctrl.stop(...arguments));
      return this;
    };

    SpringRef.update = function (props) {
      each(current, (ctrl, i) => ctrl.update(this._getProps(props, ctrl, i)));
      return this;
    };

    const _getProps = function _getProps(arg, ctrl, index) {
      return is.fun(arg) ? arg(index, ctrl) : arg;
    };

    SpringRef._getProps = _getProps;
    return SpringRef;
  };

  function useSprings(length, props, deps) {
    const propsFn = is.fun(props) && props;
    if (propsFn && !deps) deps = [];
    const ref = React.useMemo(() => propsFn || arguments.length == 3 ? SpringRef() : void 0, []);
    const layoutId = React.useRef(0);
    const forceUpdate = useForceUpdate();
    const state = React.useMemo(() => ({
      ctrls: [],
      queue: [],

      flush(ctrl, updates) {
        const springs = getSprings(ctrl, updates);
        const canFlushSync = layoutId.current > 0 && !state.queue.length && !Object.keys(springs).some(key => !ctrl.springs[key]);
        return canFlushSync ? flushUpdateQueue(ctrl, updates) : new Promise(resolve => {
          setSprings(ctrl, springs);
          state.queue.push(() => {
            resolve(flushUpdateQueue(ctrl, updates));
          });
          forceUpdate();
        });
      }

    }), []);
    const ctrls = React.useRef([...state.ctrls]);
    const updates = [];
    const prevLength = usePrev(length) || 0;
    const oldCtrls = ctrls.current.slice(length, prevLength);
    React.useMemo(() => {
      ctrls.current.length = length;
      declareUpdates(prevLength, length);
    }, [length]);
    React.useMemo(() => {
      declareUpdates(0, Math.min(prevLength, length));
    }, deps);

    function declareUpdates(startIndex, endIndex) {
      for (let i = startIndex; i < endIndex; i++) {
        const ctrl = ctrls.current[i] || (ctrls.current[i] = new Controller(null, state.flush));
        const update = propsFn ? propsFn(i, ctrl) : props[i];

        if (update) {
          updates[i] = declareUpdate(update);
        }
      }
    }

    const springs = ctrls.current.map((ctrl, i) => getSprings(ctrl, updates[i]));
    const context = React.useContext(SpringContext);
    const prevContext = usePrev(context);
    const hasContext = context !== prevContext && hasProps(context);
    useLayoutEffect(() => {
      layoutId.current++;
      state.ctrls = ctrls.current;
      const {
        queue
      } = state;

      if (queue.length) {
        state.queue = [];
        each(queue, cb => cb());
      }

      each(oldCtrls, ctrl => {
        detachRefs(ctrl, ref);
        ctrl.stop(true);
      });
      each(ctrls.current, (ctrl, i) => {
        ref == null ? void 0 : ref.add(ctrl);

        if (hasContext) {
          ctrl.start({
            default: context
          });
        }

        const update = updates[i];

        if (update) {
          replaceRef(ctrl, update.ref);

          if (ctrl.ref) {
            ctrl.queue.push(update);
          } else {
            ctrl.start(update);
          }
        }
      });
    });
    useOnce(() => () => {
      each(state.ctrls, ctrl => ctrl.stop(true));
    });
    const values = springs.map(x => _extends({}, x));
    return ref ? [values, ref] : values;
  }

  function useSpring(props, deps) {
    const isFn = is.fun(props);
    const [[values], ref] = useSprings(1, isFn ? props : [props], isFn ? deps || [] : deps);
    return isFn || arguments.length == 2 ? [values, ref] : values;
  }

  let TransitionPhase;

  (function (TransitionPhase) {
    TransitionPhase["MOUNT"] = "mount";
    TransitionPhase["ENTER"] = "enter";
    TransitionPhase["UPDATE"] = "update";
    TransitionPhase["LEAVE"] = "leave";
  })(TransitionPhase || (TransitionPhase = {}));

  class Interpolation extends FrameValue {
    constructor(source, args) {
      super();
      this.key = void 0;
      this.idle = true;
      this.calc = void 0;
      this._active = new Set();
      this.source = source;
      this.calc = createInterpolator(...args);

      const value = this._get();

      const nodeType = getAnimatedType(value);
      setAnimated(this, nodeType.create(value));
    }

    advance(_dt) {
      const value = this._get();

      const oldValue = this.get();

      if (!isEqual(value, oldValue)) {
        getAnimated(this).setValue(value);

        this._onChange(value, this.idle);
      }

      if (!this.idle && checkIdle(this._active)) {
        becomeIdle(this);
      }
    }

    _get() {
      const inputs = is.arr(this.source) ? this.source.map(getFluidValue) : toArray(getFluidValue(this.source));
      return this.calc(...inputs);
    }

    _start() {
      if (this.idle && !checkIdle(this._active)) {
        this.idle = false;
        each(getPayload(this), node => {
          node.done = false;
        });

        if (globals.skipAnimation) {
          raf.batchedUpdates(() => this.advance());
          becomeIdle(this);
        } else {
          frameLoop.start(this);
        }
      }
    }

    _attach() {
      let priority = 1;
      each(toArray(this.source), source => {
        if (hasFluidValue(source)) {
          addFluidObserver(source, this);
        }

        if (isFrameValue(source)) {
          if (!source.idle) {
            this._active.add(source);
          }

          priority = Math.max(priority, source.priority + 1);
        }
      });
      this.priority = priority;

      this._start();
    }

    _detach() {
      each(toArray(this.source), source => {
        if (hasFluidValue(source)) {
          removeFluidObserver(source, this);
        }
      });

      this._active.clear();

      becomeIdle(this);
    }

    eventObserved(event) {
      if (event.type == 'change') {
        if (event.idle) {
          this.advance();
        } else {
          this._active.add(event.parent);

          this._start();
        }
      } else if (event.type == 'idle') {
        this._active.delete(event.parent);
      } else if (event.type == 'priority') {
        this.priority = toArray(this.source).reduce((highest, parent) => Math.max(highest, (isFrameValue(parent) ? parent.priority : 0) + 1), 0);
      }
    }

  }

  function isIdle(source) {
    return source.idle !== false;
  }

  function checkIdle(active) {
    return !active.size || Array.from(active).every(isIdle);
  }

  function becomeIdle(self) {
    if (!self.idle) {
      self.idle = true;
      each(getPayload(self), node => {
        node.done = true;
      });
      callFluidObservers(self, {
        type: 'idle',
        parent: self
      });
    }
  }

  globals.assign({
    createStringInterpolator,
    to: (source, args) => new Interpolation(source, args)
  });

  function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {};
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;

    for (i = 0; i < sourceKeys.length; i++) {
      key = sourceKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      target[key] = source[key];
    }

    return target;
  }

  const _excluded$2 = ["style", "children", "scrollTop", "scrollLeft"];
  const isCustomPropRE = /^--/;

  function dangerousStyleValue(name, value) {
    if (value == null || typeof value === 'boolean' || value === '') return '';
    if (typeof value === 'number' && value !== 0 && !isCustomPropRE.test(name) && !(isUnitlessNumber.hasOwnProperty(name) && isUnitlessNumber[name])) return value + 'px';
    return ('' + value).trim();
  }

  const attributeCache = {};

  function applyAnimatedValues(instance, props) {
    if (!instance.nodeType || !instance.setAttribute) {
      return false;
    }

    const isFilterElement = instance.nodeName === 'filter' || instance.parentNode && instance.parentNode.nodeName === 'filter';

    const _ref = props,
          {
      style,
      children,
      scrollTop,
      scrollLeft
    } = _ref,
          attributes = _objectWithoutPropertiesLoose(_ref, _excluded$2);

    const values = Object.values(attributes);
    const names = Object.keys(attributes).map(name => isFilterElement || instance.hasAttribute(name) ? name : attributeCache[name] || (attributeCache[name] = name.replace(/([A-Z])/g, n => '-' + n.toLowerCase())));

    if (children !== void 0) {
      instance.textContent = children;
    }

    for (let name in style) {
      if (style.hasOwnProperty(name)) {
        const value = dangerousStyleValue(name, style[name]);
        if (name === 'float') name = 'cssFloat';else if (isCustomPropRE.test(name)) {
          instance.style.setProperty(name, value);
        } else {
          instance.style[name] = value;
        }
      }
    }

    names.forEach((name, i) => {
      instance.setAttribute(name, values[i]);
    });

    if (scrollTop !== void 0) {
      instance.scrollTop = scrollTop;
    }

    if (scrollLeft !== void 0) {
      instance.scrollLeft = scrollLeft;
    }
  }

  let isUnitlessNumber = {
    animationIterationCount: true,
    borderImageOutset: true,
    borderImageSlice: true,
    borderImageWidth: true,
    boxFlex: true,
    boxFlexGroup: true,
    boxOrdinalGroup: true,
    columnCount: true,
    columns: true,
    flex: true,
    flexGrow: true,
    flexPositive: true,
    flexShrink: true,
    flexNegative: true,
    flexOrder: true,
    gridRow: true,
    gridRowEnd: true,
    gridRowSpan: true,
    gridRowStart: true,
    gridColumn: true,
    gridColumnEnd: true,
    gridColumnSpan: true,
    gridColumnStart: true,
    fontWeight: true,
    lineClamp: true,
    lineHeight: true,
    opacity: true,
    order: true,
    orphans: true,
    tabSize: true,
    widows: true,
    zIndex: true,
    zoom: true,
    fillOpacity: true,
    floodOpacity: true,
    stopOpacity: true,
    strokeDasharray: true,
    strokeDashoffset: true,
    strokeMiterlimit: true,
    strokeOpacity: true,
    strokeWidth: true
  };

  const prefixKey = (prefix, key) => prefix + key.charAt(0).toUpperCase() + key.substring(1);

  const prefixes = ['Webkit', 'Ms', 'Moz', 'O'];
  isUnitlessNumber = Object.keys(isUnitlessNumber).reduce((acc, prop) => {
    prefixes.forEach(prefix => acc[prefixKey(prefix, prop)] = acc[prop]);
    return acc;
  }, isUnitlessNumber);
  const _excluded$1$1 = ["x", "y", "z"];
  const domTransforms = /^(matrix|translate|scale|rotate|skew)/;
  const pxTransforms = /^(translate)/;
  const degTransforms = /^(rotate|skew)/;

  const addUnit = (value, unit) => is.num(value) && value !== 0 ? value + unit : value;

  const isValueIdentity = (value, id) => is.arr(value) ? value.every(v => isValueIdentity(v, id)) : is.num(value) ? value === id : parseFloat(value) === id;

  class AnimatedStyle extends AnimatedObject {
    constructor(_ref) {
      let {
        x,
        y,
        z
      } = _ref,
          style = _objectWithoutPropertiesLoose(_ref, _excluded$1$1);

      const inputs = [];
      const transforms = [];

      if (x || y || z) {
        inputs.push([x || 0, y || 0, z || 0]);
        transforms.push(xyz => [`translate3d(${xyz.map(v => addUnit(v, 'px')).join(',')})`, isValueIdentity(xyz, 0)]);
      }

      eachProp(style, (value, key) => {
        if (key === 'transform') {
          inputs.push([value || '']);
          transforms.push(transform => [transform, transform === '']);
        } else if (domTransforms.test(key)) {
          delete style[key];
          if (is.und(value)) return;
          const unit = pxTransforms.test(key) ? 'px' : degTransforms.test(key) ? 'deg' : '';
          inputs.push(toArray(value));
          transforms.push(key === 'rotate3d' ? ([x, y, z, deg]) => [`rotate3d(${x},${y},${z},${addUnit(deg, unit)})`, isValueIdentity(deg, 0)] : input => [`${key}(${input.map(v => addUnit(v, unit)).join(',')})`, isValueIdentity(input, key.startsWith('scale') ? 1 : 0)]);
        }
      });

      if (inputs.length) {
        style.transform = new FluidTransform(inputs, transforms);
      }

      super(style);
    }

  }

  class FluidTransform extends FluidValue {
    constructor(inputs, transforms) {
      super();
      this._value = null;
      this.inputs = inputs;
      this.transforms = transforms;
    }

    get() {
      return this._value || (this._value = this._get());
    }

    _get() {
      let transform = '';
      let identity = true;
      each(this.inputs, (input, i) => {
        const arg1 = getFluidValue(input[0]);
        const [t, id] = this.transforms[i](is.arr(arg1) ? arg1 : input.map(getFluidValue));
        transform += ' ' + t;
        identity = identity && id;
      });
      return identity ? 'none' : transform;
    }

    observerAdded(count) {
      if (count == 1) each(this.inputs, input => each(input, value => hasFluidValue(value) && addFluidObserver(value, this)));
    }

    observerRemoved(count) {
      if (count == 0) each(this.inputs, input => each(input, value => hasFluidValue(value) && removeFluidObserver(value, this)));
    }

    eventObserved(event) {
      if (event.type == 'change') {
        this._value = null;
      }

      callFluidObservers(this, event);
    }

  }

  const primitives = ['a', 'abbr', 'address', 'area', 'article', 'aside', 'audio', 'b', 'base', 'bdi', 'bdo', 'big', 'blockquote', 'body', 'br', 'button', 'canvas', 'caption', 'cite', 'code', 'col', 'colgroup', 'data', 'datalist', 'dd', 'del', 'details', 'dfn', 'dialog', 'div', 'dl', 'dt', 'em', 'embed', 'fieldset', 'figcaption', 'figure', 'footer', 'form', 'h1', 'h2', 'h3', 'h4', 'h5', 'h6', 'head', 'header', 'hgroup', 'hr', 'html', 'i', 'iframe', 'img', 'input', 'ins', 'kbd', 'keygen', 'label', 'legend', 'li', 'link', 'main', 'map', 'mark', 'menu', 'menuitem', 'meta', 'meter', 'nav', 'noscript', 'object', 'ol', 'optgroup', 'option', 'output', 'p', 'param', 'picture', 'pre', 'progress', 'q', 'rp', 'rt', 'ruby', 's', 'samp', 'script', 'section', 'select', 'small', 'source', 'span', 'strong', 'style', 'sub', 'summary', 'sup', 'table', 'tbody', 'td', 'textarea', 'tfoot', 'th', 'thead', 'time', 'title', 'tr', 'track', 'u', 'ul', 'var', 'video', 'wbr', 'circle', 'clipPath', 'defs', 'ellipse', 'foreignObject', 'g', 'image', 'line', 'linearGradient', 'mask', 'path', 'pattern', 'polygon', 'polyline', 'radialGradient', 'rect', 'stop', 'svg', 'text', 'tspan'];
  const _excluded$3 = ["scrollTop", "scrollLeft"];
  globals.assign({
    batchedUpdates: ReactDOM.unstable_batchedUpdates,
    createStringInterpolator,
    colors
  });
  const host = createHost(primitives, {
    applyAnimatedValues,
    createAnimatedStyle: style => new AnimatedStyle(style),
    getComponentProps: _ref => {
      let props = _objectWithoutPropertiesLoose(_ref, _excluded$3);

      return props;
    }
  });
  const animated = host.animated;

  function usePrevious(val) {
    var ref = React__default['default'].useRef();
    useIsomorphicLayoutEffect(function () {
      ref.current = val;
    }, [val]);
    return ref.current;
  }

  function useLatestWhen(obj, when) {
    if (when === void 0) {
      when = true;
    }

    var ref = React__default['default'].useRef(when ? obj : null);

    if (when) {
      ref.current = obj;
    }

    return ref.current;
  }

  function usePortalElement() {
    var _React$useState = React__namespace.useState(),
        portalEl = _React$useState[0],
        setPortalEl = _React$useState[1];

    useIsomorphicLayoutEffect(function () {
      if (!portalEl) {
        var element = document.getElementById('react-charts-portal');

        if (!element) {
          element = document.createElement('div');
          element.setAttribute('id', 'react-charts-portal');
          Object.assign(element.style, {
            pointerEvents: 'none',
            position: 'fixed',
            left: 0,
            right: 0,
            top: 0,
            bottom: 0,
            'z-index': 99999999999
          });
          document.body.append(element);
        }

        setPortalEl(element);
      }
    });
    return portalEl;
  }

  var props = ["bottom", "height", "left", "right", "top", "width"];

  var rectChanged = function rectChanged(a, b) {
    if (a === void 0) {
      a = {};
    }

    if (b === void 0) {
      b = {};
    }

    return props.some(function (prop) {
      return a[prop] !== b[prop];
    });
  };

  var observedNodes = /*#__PURE__*/new Map();
  var rafId;

  var run = function run() {
    var changedStates = [];
    observedNodes.forEach(function (state, node) {
      var newRect = node.getBoundingClientRect();

      if (rectChanged(newRect, state.rect)) {
        state.rect = newRect;
        changedStates.push(state);
      }
    });
    changedStates.forEach(function (state) {
      state.callbacks.forEach(function (cb) {
        return cb(state.rect);
      });
    });
    rafId = window.requestAnimationFrame(run);
  };

  function observeRect(node, cb) {
    return {
      observe: function observe() {
        var wasEmpty = observedNodes.size === 0;

        if (observedNodes.has(node)) {
          observedNodes.get(node).callbacks.push(cb);
        } else {
          observedNodes.set(node, {
            rect: undefined,
            hasRectChanged: false,
            callbacks: [cb]
          });
        }

        if (wasEmpty) run();
      },
      unobserve: function unobserve() {
        var state = observedNodes.get(node);

        if (state) {
          // Remove the callback
          var index = state.callbacks.indexOf(cb);
          if (index >= 0) state.callbacks.splice(index, 1); // Remove the node reference

          if (!state.callbacks.length) observedNodes["delete"](node); // Stop the loop

          if (!observedNodes.size) cancelAnimationFrame(rafId);
        }
      }
    };
  }

  function useRect(node, enabled) {
    var _React$useState = React__default['default'].useState(node),
        element = _React$useState[0],
        setElement = _React$useState[1];

    var _React$useState2 = React__default['default'].useState({
      width: 0,
      height: 0
    }),
        rect = _React$useState2[0],
        setRect = _React$useState2[1];

    var rectRef = React__default['default'].useRef(rect);
    rectRef.current = rect;
    useIsomorphicLayoutEffect(function () {
      if (node !== element) {
        setElement(node);
      }
    });
    useIsomorphicLayoutEffect(function () {
      if (enabled && element) {
        setRect(element.getBoundingClientRect());
      }
    }, [element, enabled]);
    React__default['default'].useEffect(function () {
      if (!element || !enabled) {
        return;
      }

      var observer = observeRect(element, function (newRect) {
        setRect(newRect);
      });
      observer.observe();
      return function () {
        observer.unobserve();
      };
    }, [element, enabled]); // const resolvedRect = React.useMemo(() => {
    //   if (!element || !(element as Element).tagName) {
    //     return rect
    //   }
    //   const styles = window.getComputedStyle(element as Element)
    //   return {
    //     x: rect.x,
    //     y: rect.y,
    //     width:
    //       rect.width -
    //       parseInt(styles.borderLeftWidth) -
    //       parseInt(styles.borderRightWidth),
    //     height:
    //       rect.height -
    //       parseInt(styles.borderTopWidth) -
    //       parseInt(styles.borderBottomWidth),
    //     top: rect.top,
    //     right: rect.right,
    //     bottom: rect.bottom,
    //     left: rect.left,
    //   }
    // }, [element, rect])

    return rect;
  }

  //
  var getLineBackgroundColor = function getLineBackgroundColor(dark) {
    return dark ? 'rgba(255,255,255,.3)' : 'rgba(0, 26, 39, 0.3)';
  };

  var getBackgroundColor$1 = function getBackgroundColor(dark) {
    return dark ? 'rgba(255,255,255,.9)' : 'rgba(0, 26, 39, 0.9)';
  };

  function defaultCursor(options) {
    var _options$show, _options$showLine, _options$showLabel;

    return _extends$3({}, options, {
      show: (_options$show = options.show) != null ? _options$show : true,
      showLine: (_options$showLine = options.showLine) != null ? _options$showLine : true,
      showLabel: (_options$showLabel = options.showLabel) != null ? _options$showLabel : true
    });
  }

  function Cursors() {
    var _getOptions$primaryCu, _getOptions$secondary;

    var _useChartContext = useChartContext(),
        getOptions = _useChartContext.getOptions;

    var primaryOptions = (_getOptions$primaryCu = getOptions().primaryCursor) != null ? _getOptions$primaryCu : true;
    var secondaryOptions = (_getOptions$secondary = getOptions().secondaryCursor) != null ? _getOptions$secondary : true;
    var resolvedPrimaryOptions = React__default['default'].useMemo(function () {
      return defaultCursor(!primaryOptions ? {
        show: false
      } : typeof primaryOptions === 'boolean' ? {} : primaryOptions);
    }, [primaryOptions]);
    var resolvedSecondaryOptions = React__default['default'].useMemo(function () {
      return defaultCursor(!secondaryOptions ? {
        show: false
      } : typeof secondaryOptions === 'boolean' ? {} : secondaryOptions);
    }, [secondaryOptions]);
    return /*#__PURE__*/React__default['default'].createElement(React__default['default'].Fragment, null, /*#__PURE__*/React__default['default'].createElement(Cursor, {
      primary: true,
      options: resolvedPrimaryOptions
    }), /*#__PURE__*/React__default['default'].createElement(Cursor, {
      options: resolvedSecondaryOptions
    }));
  }

  function Cursor(props) {
    var _useChartContext2 = useChartContext(),
        getOptions = _useChartContext2.getOptions,
        svgRef = _useChartContext2.svgRef,
        gridDimensions = _useChartContext2.gridDimensions,
        useFocusedDatumAtom = _useChartContext2.useFocusedDatumAtom,
        primaryAxis = _useChartContext2.primaryAxis,
        secondaryAxes = _useChartContext2.secondaryAxes;

    var _useFocusedDatumAtom = useFocusedDatumAtom(),
        focusedDatum = _useFocusedDatumAtom[0];

    var latestFocusedDatum = useLatestWhen(focusedDatum, !!focusedDatum);
    var secondaryAxis = secondaryAxes.find(function (d) {
      return d.id === props.options.axisId || (latestFocusedDatum == null ? void 0 : latestFocusedDatum.secondaryAxisId);
    });
    var axis = props.primary ? primaryAxis : secondaryAxis;
    var siblingAxis = props.primary ? secondaryAxis : primaryAxis;

    var resolveValue = function resolveValue(d) {
      var _props$options$value, _d$stackData;

      return (_props$options$value = props.options.value) != null ? _props$options$value : d ? axis.stacked ? (_d$stackData = d.stackData) == null ? void 0 : _d$stackData[1] : axis.getValue(d == null ? void 0 : d.originalDatum) : undefined;
    };

    var value = resolveValue(focusedDatum);
    var latestValue = resolveValue(latestFocusedDatum); // Get the sibling range

    var siblingRange = siblingAxis.scale.range();
    var x;
    var y;
    var x1;
    var x2;
    var y1;
    var y2;
    var alignPctX;
    var alignPctY;
    var bandWidth = axis.axisFamily === 'band' ? axis.scale.bandwidth() : 1;
    var px = axis.scale(latestValue);
    var show = typeof value !== 'undefined' && !Number.isNaN(value); // Vertical alignment

    if (axis.isVertical) {
      var _y, _y2;

      y = px;
      y1 = ((_y = y) != null ? _y : 0) - 1;
      y2 = ((_y2 = y) != null ? _y2 : 0) + bandWidth;

      if (axis.position === 'left') {
        x1 = siblingRange[0];
        x2 = siblingRange[1];
      } else {
        x1 = siblingRange[1];
        x2 = siblingRange[0];
      }
    } else {
      var _x, _x2;

      x = px;
      x1 = ((_x = x) != null ? _x : 0) - 1;
      x2 = ((_x2 = x) != null ? _x2 : 0) + bandWidth;

      if (axis.position === 'top') {
        y1 = siblingRange[0];
        y2 = siblingRange[1];
      } else {
        y1 = siblingRange[1];
        y2 = siblingRange[0];
      }
    }

    var lineStartX = Math.min(x1, x2);
    var lineStartY = Math.min(y1, y2);
    var lineEndX = Math.max(x1, x2);
    var lineEndY = Math.max(y1, y2);
    var lineHeight = Math.max(lineEndY - lineStartY, 0);
    var lineWidth = Math.max(lineEndX - lineStartX, 0);
    var bubbleX;
    var bubbleY; // Bubble placement

    if (axis.isVertical) {
      if (axis.position === 'left') {
        bubbleX = lineStartX;
      } else {
        bubbleX = lineEndX;
      }

      bubbleY = lineStartY + lineHeight / 2;
    } else {
      if (axis.position === 'top') {
        bubbleY = lineStartY;
      } else {
        bubbleY = lineEndY;
      }

      bubbleX = lineStartX + lineWidth / 2;
    } // Bubble anchoring


    if (axis.isVertical) {
      alignPctY = -50;

      if (axis.position === 'left') {
        alignPctX = -100;
      } else {
        alignPctX = 0;
      }
    } else {
      alignPctX = -50;

      if (axis.position === 'top') {
        alignPctY = -100;
      } else {
        alignPctY = 0;
      }
    }

    var formattedValue = axis.formatters.cursor(latestValue);
    var svgRect = useRect(svgRef.current, show);
    var immediatePos = !axis.isVertical ? lineStartX : lineStartY;

    var _immediate = usePrevious(immediatePos) === -1 && immediatePos > -1;

    var lineSpring = useSpring({
      transform: translate(lineStartX, lineStartY),
      width: lineWidth + "px",
      height: lineHeight + "px",
      config: config.stiff,
      immediate: function immediate(key) {
        return key === 'transform' ? _immediate : false;
      }
    });
    var bubbleSpring = useSpring({
      transform: translate(bubbleX, bubbleY),
      config: config.stiff,
      immediate: function immediate(key) {
        return key === 'transform' ? _immediate : false;
      }
    });
    var portalEl = usePortalElement();
    return portalEl ? /*#__PURE__*/ReactDOM__default['default'].createPortal( /*#__PURE__*/React__default['default'].createElement("div", {
      style: {
        fontFamily: 'sans-serif',
        pointerEvents: 'none',
        position: 'absolute',
        top: 0,
        left: 0,
        transform: translate(svgRect.left + gridDimensions.gridX, svgRect.top + gridDimensions.gridY),
        opacity: show ? 1 : 0,
        transition: 'opacity .3s ease'
      },
      className: "Cursor"
    }, props.options.showLine ? /*#__PURE__*/React__default['default'].createElement(animated.div, {
      style: _extends$3({}, lineSpring, {
        position: 'absolute',
        top: 0,
        left: 0,
        background: getLineBackgroundColor(getOptions().dark)
      })
    }) : null, props.options.showLabel ? /*#__PURE__*/React__default['default'].createElement(animated.div, {
      style: _extends$3({}, bubbleSpring, {
        position: 'absolute',
        top: 0,
        left: 0
      })
    }, /*#__PURE__*/React__default['default'].createElement("div", {
      style: {
        padding: '5px',
        fontSize: '10px',
        background: getBackgroundColor$1(getOptions().dark),
        color: getBackgroundColor$1(!getOptions().dark),
        borderRadius: '3px',
        position: 'relative',
        transform: "translate3d(" + alignPctX + "%, " + alignPctY + "%, 0)",
        whiteSpace: 'nowrap'
      }
    }, formattedValue)) : null), portalEl) : null;
  }

  //

  // These are the keys used internally to look up and measure
  // different sides of a bounding box within another
  var sideSchemas = {
    left: {
      side: 'left',
      startKey: 'left',
      lengthKey: 'width',
      crossStartKey: 'top',
      crossLengthKey: 'height',
      fromEnd: false
    },
    right: {
      side: 'right',
      startKey: 'left',
      lengthKey: 'width',
      crossStartKey: 'top',
      crossLengthKey: 'height',
      fromEnd: true
    },
    top: {
      side: 'top',
      startKey: 'top',
      lengthKey: 'height',
      crossStartKey: 'left',
      crossLengthKey: 'width',
      fromEnd: false
    },
    bottom: {
      side: 'bottom',
      startKey: 'top',
      lengthKey: 'height',
      crossStartKey: 'left',
      crossLengthKey: 'width',
      fromEnd: true
    }
  }; // This is the final Tootlip component. It's a render prop
  // that lets you attach handlers to elements, and render a tooltip
  // anchored to them in relation to the parent portal container (either the only
  // one defined or the one referenced by Id).

  function useAnchor(options) {
    var portalDims = useRect(options.portalEl, options.show);
    var anchorDims = useRect(options.anchorEl, options.show);
    var tooltipDims = useRect(options.tooltipEl, options.show);
    var sides = React__default['default'].useMemo(function () {
      var preSides = Array.isArray(options.side) ? options.side : [options.side];
      return preSides.map(function (alignStr) {
        var _ref = alignStr.split(' '),
            side = _ref[0],
            _ref$ = _ref[1],
            align = _ref$ === void 0 ? 'center' : _ref$;

        var incompatibleSide = !['top', 'right', 'bottom', 'left'].find(function (d) {
          return side === d;
        });

        if (incompatibleSide) {
          throw new Error("react-sticker: \"" + side + "\" is not a valid side! Must be one of ['top', 'right', 'bottom', 'left'].");
        }

        var incompatibleAlign = !['center', 'start', 'end', 'top', 'right', 'bottom', 'left'].find(function (d) {
          return align === d;
        });

        if (incompatibleAlign) {
          throw new Error("react-sticker: \"" + align + "\" is not a valid side-alignment! Must be one of ['center', 'start', 'end', 'top', 'right', 'bottom', 'left'].");
        }

        return [side, align];
      }); // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [JSON.stringify(options.side)]); // IF we have all of the dimensions needed to calculate
    // fits, then calculate the fit

    var ready = portalDims && tooltipDims && anchorDims;
    var fit = React__default['default'].useMemo(function () {
      return ready && options.show ? fitOnBestSide({
        portalDims: portalDims,
        tooltipDims: tooltipDims,
        anchorDims: anchorDims,
        sides: sides,
        useLargest: options.useLargest
      }) : null;
    }, [anchorDims, options.show, options.useLargest, portalDims, ready, sides, tooltipDims]);
    return {
      fit: fit,
      style: _extends$3({
        position: 'absolute',
        visibility: ready ? 'visible' : 'hidden'
      }, fit == null ? void 0 : fit.style)
    };
  } // This function selects the best side for the tooltip by using
  // the ranked fits.

  function fitOnBestSide(_ref2) {
    var portalDims = _ref2.portalDims,
        tooltipDims = _ref2.tooltipDims,
        anchorDims = _ref2.anchorDims,
        sides = _ref2.sides,
        useLargest = _ref2.useLargest;
    var fits = sides.map(function (_ref3) {
      var side = _ref3[0],
          align = _ref3[1];
      return measureFit(_extends$3({}, sideSchemas[side], {
        align: align,
        portalDims: portalDims,
        tooltipDims: tooltipDims,
        anchorDims: anchorDims
      }));
    });

    if (useLargest) {
      fits.sort(function (a, b) {
        return b.fitRatio - a.fitRatio;
      });
      return fits[0];
    }

    return fits.find(function (fit) {
      return fit.fitRatio >= 1;
    }) || fits[0];
  } // This function takes a side and bunch of calculated dimensions from
  // the portal, tooltip and target. Then it returns
  // the percentage fit and the style to achieve this specific fit


  function measureFit(_ref4) {
    var _style;

    var side = _ref4.side,
        align = _ref4.align,
        startKey = _ref4.startKey,
        lengthKey = _ref4.lengthKey,
        crossStartKey = _ref4.crossStartKey,
        crossLengthKey = _ref4.crossLengthKey,
        fromEnd = _ref4.fromEnd,
        portalDims = _ref4.portalDims,
        tooltipDims = _ref4.tooltipDims,
        anchorDims = _ref4.anchorDims;
    var parentStart = portalDims[startKey];
    var parentLength = portalDims[lengthKey];
    var crossParentStart = portalDims[crossStartKey];
    var crossParentLength = portalDims[crossLengthKey];
    var anchorStart = anchorDims[startKey] - portalDims[startKey];
    var anchorLength = anchorDims[lengthKey];
    var crossAnchorStart = anchorDims[crossStartKey];
    var crossAnchorLength = anchorDims[crossLengthKey];
    var crossAnchorWidth = anchorDims[crossLengthKey];
    var targetLength = tooltipDims[lengthKey];
    var crossTargetLength = tooltipDims[crossLengthKey];
    var targetStart;
    var fitRatio;

    if (!fromEnd) {
      targetStart = anchorStart - targetLength;
      fitRatio = Math.min(anchorStart / targetLength);
    } else {
      targetStart = anchorStart + anchorLength;
      fitRatio = (parentLength - (anchorStart + anchorLength)) / targetLength;
    }

    targetStart = Math.max(parentStart, Math.min(targetStart, parentLength));
    var crossTargetStart;

    if (startKey === 'left') {
      if (align === 'top') {
        align = 'start';
      } else if (align === 'bottom') {
        align = 'end';
      }
    } else {
      if (align === 'left') {
        align = 'start';
      } else if (align === 'right') {
        align = 'end';
      }
    }

    if (!['start', 'center', 'end'].includes(align)) {
      align = 'center';
    }

    if (align === 'start') {
      crossTargetStart = crossAnchorStart;
    } else if (align === 'end') {
      crossTargetStart = crossAnchorStart + crossAnchorWidth - crossTargetLength;
    } else {
      crossTargetStart = crossAnchorStart + crossAnchorLength / 2 - crossTargetLength / 2;
    }

    crossTargetStart = Math.max(crossParentStart, Math.min(crossTargetStart, crossParentLength - crossTargetLength));
    return {
      side: side,
      align: align,
      startKey: startKey,
      lengthKey: lengthKey,
      crossStartKey: crossStartKey,
      crossLengthKey: crossLengthKey,
      fromEnd: fromEnd,
      portalDims: portalDims,
      tooltipDims: tooltipDims,
      anchorDims: anchorDims,
      fitRatio: fitRatio,
      style: (_style = {}, _style[startKey] = targetStart, _style[crossStartKey] = crossTargetStart, _style)
    };
  }

  //
  //
  var showCount = 10;
  var triangleSize = 7;

  var getBackgroundColor = function getBackgroundColor(dark) {
    return dark ? 'rgba(255,255,255,.9)' : 'rgba(0, 26, 39, 0.9)';
  };

  function tooltipRenderer(props) {
    return /*#__PURE__*/React__default['default'].createElement(TooltipRenderer, props);
  }

  function TooltipRenderer(props) {
    var _props$focusedDatum$g, _props$focusedDatum, _focusedDatum$group, _focusedDatum$group2;

    var latestFit = useLatestWhen(props.anchor.fit, !!props.anchor.fit);

    if (!props.focusedDatum) {
      return null;
    }

    var primaryAxis = props.primaryAxis,
        secondaryAxis = props.secondaryAxis,
        getDatumStyle = props.getDatumStyle,
        focusedDatum = props.focusedDatum;

    var _props$getOptions = props.getOptions(),
        groupingMode = _props$getOptions.groupingMode,
        dark = _props$getOptions.dark;

    var groupDatums = (_props$focusedDatum$g = (_props$focusedDatum = props.focusedDatum) == null ? void 0 : _props$focusedDatum.group) != null ? _props$focusedDatum$g : [];
    var resolvedShowCount = showCount ;
    var length = groupDatums.length; // Get the focused series' index

    var activeIndex = groupDatums.findIndex(function (d) {
      return d === focusedDatum;
    }); // Get the start by going back half of the showCount

    var start = activeIndex > -1 ? activeIndex - resolvedShowCount / 2 : 0; // Make sure it's at least 0

    start = Math.max(start, 0); // Use the start and add the showCount to get the end

    var end = activeIndex > -1 ? start + resolvedShowCount : length; // Don't let the end go passed the length

    end = Math.min(end, length); // Double check we aren't clipping the start

    start = Math.max(end - resolvedShowCount, 0); // Slice the datums by start and end

    var visibleSortedGroupDatums = groupDatums.slice(start, end); // Detect if we have previous items

    var hasPrevious = start > 0; // Or next items

    var hasNext = end < length;
    var finalAlign = (latestFit == null ? void 0 : latestFit.side) + "-" + (latestFit == null ? void 0 : latestFit.align);
    var arrowPosition;
    var triangleStyles;

    if (!arrowPosition) {
      if (finalAlign === 'left-center') {
        arrowPosition = 'right';
      } else if (finalAlign === 'right-center') {
        arrowPosition = 'left';
      } else if (finalAlign === 'top-center') {
        arrowPosition = 'bottom';
      } else if (finalAlign === 'bottom-center') {
        arrowPosition = 'top';
      } else if (finalAlign === 'right-start') {
        arrowPosition = 'bottomLeft';
      } else if (finalAlign === 'right-end') {
        arrowPosition = 'topLeft';
      } else if (finalAlign === 'left-start') {
        arrowPosition = 'bottomRight';
      } else if (finalAlign === 'left-end') {
        arrowPosition = 'topRight';
      }
    }

    var backgroundColor = getBackgroundColor(dark);

    if (arrowPosition === 'bottom') {
      triangleStyles = {
        top: '100%',
        left: '50%',
        transform: 'translate3d(-50%, 0%, 0)',
        borderLeft: triangleSize * 0.8 + "px solid transparent",
        borderRight: triangleSize * 0.8 + "px solid transparent",
        borderTop: triangleSize + "px solid " + backgroundColor
      };
    } else if (arrowPosition === 'top') {
      triangleStyles = {
        top: '0%',
        left: '50%',
        transform: 'translate3d(-50%, -100%, 0)',
        borderLeft: triangleSize * 0.8 + "px solid transparent",
        borderRight: triangleSize * 0.8 + "px solid transparent",
        borderBottom: triangleSize + "px solid " + backgroundColor
      };
    } else if (arrowPosition === 'right') {
      triangleStyles = {
        top: '50%',
        left: '100%',
        transform: 'translate3d(0%, -50%, 0)',
        borderTop: triangleSize * 0.8 + "px solid transparent",
        borderBottom: triangleSize * 0.8 + "px solid transparent",
        borderLeft: triangleSize + "px solid " + backgroundColor
      };
    } else if (arrowPosition === 'left') {
      triangleStyles = {
        top: '50%',
        left: '0%',
        transform: 'translate3d(-100%, -50%, 0)',
        borderTop: triangleSize * 0.8 + "px solid transparent",
        borderBottom: triangleSize * 0.8 + "px solid transparent",
        borderRight: triangleSize + "px solid " + backgroundColor
      };
    } else if (arrowPosition === 'topRight') {
      triangleStyles = {
        top: '0%',
        left: '100%',
        transform: 'translate3d(-50%, -50%, 0) rotate(-45deg)',
        borderTop: triangleSize * 0.8 + "px solid transparent",
        borderBottom: triangleSize * 0.8 + "px solid transparent",
        borderLeft: triangleSize * 2 + "px solid " + backgroundColor
      };
    } else if (arrowPosition === 'bottomRight') {
      triangleStyles = {
        top: '100%',
        left: '100%',
        transform: 'translate3d(-50%, -50%, 0) rotate(45deg)',
        borderTop: triangleSize * 0.8 + "px solid transparent",
        borderBottom: triangleSize * 0.8 + "px solid transparent",
        borderLeft: triangleSize * 2 + "px solid " + backgroundColor
      };
    } else if (arrowPosition === 'topLeft') {
      triangleStyles = {
        top: '0%',
        left: '0%',
        transform: 'translate3d(-50%, -50%, 0) rotate(45deg)',
        borderTop: triangleSize * 0.8 + "px solid transparent",
        borderBottom: triangleSize * 0.8 + "px solid transparent",
        borderRight: triangleSize * 2 + "px solid " + backgroundColor
      };
    } else if (arrowPosition === 'bottomLeft') {
      triangleStyles = {
        top: '100%',
        left: '0%',
        transform: 'translate3d(-50%, -50%, 0) rotate(-45deg)',
        borderTop: triangleSize * 0.8 + "px solid transparent",
        borderBottom: triangleSize * 0.8 + "px solid transparent",
        borderRight: triangleSize * 2 + "px solid " + backgroundColor
      };
    } else {
      triangleStyles = {
        opacity: 0
      };
    }

    return /*#__PURE__*/React__default['default'].createElement("div", {
      style: {
        position: 'relative',
        fontSize: '10px',
        padding: '5px',
        background: getBackgroundColor(dark),
        color: dark ? 'black' : 'white',
        borderRadius: '3px'
      }
    }, /*#__PURE__*/React__default['default'].createElement("div", {
      style: _extends$3({
        position: 'absolute',
        width: 0,
        height: 0
      }, triangleStyles)
    }), /*#__PURE__*/React__default['default'].createElement("div", null, /*#__PURE__*/React__default['default'].createElement("div", {
      style: {
        marginBottom: '3px',
        textAlign: 'center'
      }
    }, groupingMode === 'series' ? /*#__PURE__*/React__default['default'].createElement("strong", null, focusedDatum.seriesLabel) : groupingMode === 'secondary' ? /*#__PURE__*/React__default['default'].createElement("strong", null, secondaryAxis.formatters.tooltip(secondaryAxis.getValue(focusedDatum.originalDatum))) : /*#__PURE__*/React__default['default'].createElement("strong", null, primaryAxis.formatters.tooltip(primaryAxis.getValue(focusedDatum.originalDatum)))), /*#__PURE__*/React__default['default'].createElement("table", {
      style: {
        whiteSpace: 'nowrap'
      }
    }, /*#__PURE__*/React__default['default'].createElement("tbody", null, hasPrevious ? /*#__PURE__*/React__default['default'].createElement("tr", {
      style: {
        opacity: 0.8
      }
    }, /*#__PURE__*/React__default['default'].createElement("td", null), /*#__PURE__*/React__default['default'].createElement("td", null, "..."), /*#__PURE__*/React__default['default'].createElement("td", null)) : null, visibleSortedGroupDatums.map(function (sortedDatum, i) {
      var active = sortedDatum === focusedDatum;
      return /*#__PURE__*/React__default['default'].createElement("tr", {
        key: i,
        style: {
          opacity: active ? 1 : 0.8,
          fontWeight: active ? 'bold' : undefined
        }
      }, /*#__PURE__*/React__default['default'].createElement("td", {
        style: {
          display: 'flex',
          alignItems: 'center',
          justifyContent: 'center'
        }
      }, /*#__PURE__*/React__default['default'].createElement("svg", {
        width: "14",
        height: "14"
      }, /*#__PURE__*/React__default['default'].createElement("circle", {
        cx: "7",
        cy: "7",
        r: "5",
        style: _extends$3({}, getDatumStyle(sortedDatum), {
          stroke: dark ? 'black' : 'white',
          strokeWidth: active ? 2 : 1
        })
      }))), groupingMode === 'series' ? /*#__PURE__*/React__default['default'].createElement(React__default['default'].Fragment, null, /*#__PURE__*/React__default['default'].createElement("td", null, primaryAxis.formatters.tooltip(primaryAxis.getValue(sortedDatum.originalDatum)), ": \xA0"), /*#__PURE__*/React__default['default'].createElement("td", {
        style: {
          textAlign: 'right'
        }
      }, secondaryAxis.formatters.tooltip(secondaryAxis.getValue(sortedDatum.originalDatum)))) : groupingMode === 'secondary' ? /*#__PURE__*/React__default['default'].createElement(React__default['default'].Fragment, null, /*#__PURE__*/React__default['default'].createElement("td", null, sortedDatum.seriesLabel, ": \xA0"), /*#__PURE__*/React__default['default'].createElement("td", {
        style: {
          textAlign: 'right'
        }
      }, primaryAxis.formatters.tooltip(primaryAxis.getValue(sortedDatum.originalDatum)))) : /*#__PURE__*/React__default['default'].createElement(React__default['default'].Fragment, null, /*#__PURE__*/React__default['default'].createElement("td", null, sortedDatum.seriesLabel, ": \xA0"), /*#__PURE__*/React__default['default'].createElement("td", {
        style: {
          textAlign: 'right'
        }
      }, secondaryAxis.formatters.tooltip(secondaryAxis.getValue(sortedDatum.originalDatum)))));
    }), hasNext ? /*#__PURE__*/React__default['default'].createElement("tr", {
      style: {
        opacity: 0.8
      }
    }, /*#__PURE__*/React__default['default'].createElement("td", null), /*#__PURE__*/React__default['default'].createElement("td", null, "..."), /*#__PURE__*/React__default['default'].createElement("td", null)) : null, secondaryAxis.stacked && ((_focusedDatum$group = focusedDatum.group) != null ? _focusedDatum$group : []).length > 1 ? /*#__PURE__*/React__default['default'].createElement("tr", null, /*#__PURE__*/React__default['default'].createElement("td", {
      style: {
        paddingTop: '5px'
      }
    }, /*#__PURE__*/React__default['default'].createElement("div", {
      style: {
        width: '12px',
        height: '12px',
        backgroundColor: dark ? 'rgba(0, 26, 39, 0.3)' : 'rgba(255,255,255,.2)',
        borderRadius: '50px'
      }
    })), /*#__PURE__*/React__default['default'].createElement("td", {
      style: {
        paddingTop: '5px'
      }
    }, "Total: \xA0"), /*#__PURE__*/React__default['default'].createElement("td", {
      style: {
        paddingTop: '5px'
      }
    }, sum((_focusedDatum$group2 = focusedDatum.group) != null ? _focusedDatum$group2 : [], function (d) {
      return secondaryAxis.getValue(d.originalDatum);
    }))) : null))));
  }

  var _excluded$1 = ["visibility"];

  function defaultTooltip(options) {
    var _options$align, _options$alignPriorit, _options$padding, _options$tooltipArrow, _options$render;

    if (options === void 0) {
      options = {};
    }

    return _extends$3({}, options, {
      align: (_options$align = options.align) != null ? _options$align : 'auto',
      alignPriority: (_options$alignPriorit = options.alignPriority) != null ? _options$alignPriorit : ['right', 'topRight', 'bottomRight', 'left', 'topLeft', 'bottomLeft', 'top', 'bottom'],
      padding: (_options$padding = options.padding) != null ? _options$padding : 5,
      tooltipArrowPadding: (_options$tooltipArrow = options.tooltipArrowPadding) != null ? _options$tooltipArrow : 7,
      // anchor: options.anchor ?? 'closest',
      render: (_options$render = options.render) != null ? _options$render : tooltipRenderer
    });
  }

  function Tooltip() {
    var _getOptions$tooltip, _secondaryAxes$find, _useLatestWhen;

    var _useChartContext = useChartContext(),
        useFocusedDatumAtom = _useChartContext.useFocusedDatumAtom,
        getOptions = _useChartContext.getOptions,
        primaryAxis = _useChartContext.primaryAxis,
        secondaryAxes = _useChartContext.secondaryAxes,
        getDatumStatusStyle = _useChartContext.getDatumStatusStyle,
        svgRef = _useChartContext.svgRef;

    var _useFocusedDatumAtom = useFocusedDatumAtom(),
        focusedDatum = _useFocusedDatumAtom[0];

    var latestFocusedDatum = useLatestWhen(focusedDatum, !!focusedDatum);
    var preTooltipOptions = (_getOptions$tooltip = getOptions().tooltip) != null ? _getOptions$tooltip : true;
    var secondaryAxis = (_secondaryAxes$find = secondaryAxes.find(function (d) {
      return d.id === (latestFocusedDatum == null ? void 0 : latestFocusedDatum.secondaryAxisId);
    })) != null ? _secondaryAxes$find : secondaryAxes[0];
    var tooltipOptions = React__default['default'].useMemo(function () {
      return defaultTooltip(typeof preTooltipOptions === 'boolean' ? {} : preTooltipOptions);
    }, [preTooltipOptions]);
    var portalEl = usePortalElement();

    var _React$useState = React__default['default'].useState(),
        tooltipEl = _React$useState[0],
        setTooltipEl = _React$useState[1];

    var svgRect = useRect(svgRef.current, !!(focusedDatum != null && focusedDatum.element));
    var anchorEl = React__default['default'].useMemo(function () {
      var _latestFocusedDatum$e, _latestFocusedDatum$e2, _anchorRect$left, _anchorRect$top, _anchorRect$width, _anchorRect$height;

      var anchorRect = (_latestFocusedDatum$e = latestFocusedDatum == null ? void 0 : (_latestFocusedDatum$e2 = latestFocusedDatum.element) == null ? void 0 : _latestFocusedDatum$e2.getBoundingClientRect()) != null ? _latestFocusedDatum$e : null;

      if (!anchorRect) {
        return null;
      }

      if (!svgRect) return;
      var translateX = (_anchorRect$left = anchorRect.left) != null ? _anchorRect$left : 0;
      var translateY = (_anchorRect$top = anchorRect.top) != null ? _anchorRect$top : 0;
      var width = (_anchorRect$width = anchorRect.width) != null ? _anchorRect$width : 0;
      var height = (_anchorRect$height = anchorRect.height) != null ? _anchorRect$height : 0;
      var box = {
        x: translateY,
        y: translateX,
        top: translateY,
        left: translateX,
        bottom: translateY + width,
        right: translateX + height,
        width: width,
        height: height,
        toJSON: function toJSON() {
          return {};
        }
      };

      box.toJSON = function () {
        return box;
      };

      return {
        getBoundingClientRect: function getBoundingClientRect() {
          return box;
        }
      };
    }, [latestFocusedDatum == null ? void 0 : latestFocusedDatum.element, svgRect]);
    var anchor = useAnchor({
      show: !!focusedDatum,
      portalEl: portalEl,
      anchorEl: anchorEl,
      tooltipEl: tooltipEl,
      side: ['right', 'left', 'top', 'bottom']
    });
    var previousAnchor = usePrevious(anchor);
    var latestStableAnchor = (_useLatestWhen = useLatestWhen(anchor, !!anchor.fit)) != null ? _useLatestWhen : anchor;

    var _latestStableAnchor$s = latestStableAnchor.style;
        _latestStableAnchor$s.visibility;
        var anchorStyle = _objectWithoutPropertiesLoose$2(_latestStableAnchor$s, _excluded$1);

    var springProps = useSpring(_extends$3({}, anchorStyle, {
      left: anchorStyle.left || 0,
      top: anchorStyle.top || 0,
      opacity: !!focusedDatum ? 1 : 0,
      config: {
        mass: 1,
        tension: 210,
        friction: 30
      },
      immediate: function immediate(key) {
        if (['left', 'top'].includes(key)) {
          return Number.isNaN(previousAnchor == null ? void 0 : previousAnchor.style.left);
        }

        return false;
      }
    }));
    var show = !!preTooltipOptions;
    var latestFit = useLatestWhen(anchor.fit, !!anchor.fit);
    return show && portalEl ? /*#__PURE__*/ReactDOM__default['default'].createPortal( /*#__PURE__*/React__default['default'].createElement(animated.div, {
      style: springProps
    }, /*#__PURE__*/React__default['default'].createElement("div", {
      ref: function ref(el) {
        return setTooltipEl(el);
      },
      style: _extends$3({
        fontFamily: 'sans-serif'
      }, (latestFit == null ? void 0 : latestFit.startKey) === 'left' ? {
        padding: '0 10px'
      } : {
        padding: '10px 0'
      })
    }, tooltipOptions.render({
      getOptions: getOptions,
      focusedDatum: latestFocusedDatum,
      primaryAxis: primaryAxis,
      secondaryAxis: secondaryAxis,
      getDatumStyle: function getDatumStyle(datum) {
        return getDatumStatusStyle(datum, focusedDatum);
      },
      anchor: anchor
    }))), portalEl) : null;
  }

  function Voronoi() {
    var _useChartContext = useChartContext(),
        getOptions = _useChartContext.getOptions,
        useFocusedDatumAtom = _useChartContext.useFocusedDatumAtom;

    var _useFocusedDatumAtom = useFocusedDatumAtom(),
        setFocusedDatum = _useFocusedDatumAtom[1];

    var _getOptions = getOptions(),
        onFocusDatum = _getOptions.onFocusDatum,
        onClickDatum = _getOptions.onClickDatum,
        tooltip = _getOptions.tooltip,
        primaryCursor = _getOptions.primaryCursor,
        secondaryCursor = _getOptions.secondaryCursor,
        showVoronoi = _getOptions.showVoronoi,
        groupingMode = _getOptions.groupingMode;

    var handleFocus = React__default['default'].useCallback(function (datum) {
      var _getOptions$onFocusDa, _getOptions2;

      (_getOptions$onFocusDa = (_getOptions2 = getOptions()).onFocusDatum) == null ? void 0 : _getOptions$onFocusDa.call(_getOptions2, datum);
      setFocusedDatum(datum);
    }, [getOptions, setFocusedDatum]);
    var needsVoronoi = onFocusDatum || onClickDatum || tooltip || primaryCursor || secondaryCursor || showVoronoi; // Don't render until we have all dependencies

    if (!needsVoronoi) {
      return null;
    }

    var props = {
      handleFocus: handleFocus
    };

    if (groupingMode === 'primary') {
      return /*#__PURE__*/React__default['default'].createElement(PrimaryVoronoi, props);
    }

    return null; // return <ClosestVoronoi {...props} />
  }

  function PrimaryVoronoi(_ref) {
    var handleFocus = _ref.handleFocus;

    var _useChartContext2 = useChartContext(),
        primaryAxis = _useChartContext2.primaryAxis,
        series = _useChartContext2.series,
        secondaryAxes = _useChartContext2.secondaryAxes,
        getOptions = _useChartContext2.getOptions,
        gridDimensions = _useChartContext2.gridDimensions,
        groupedDatums = _useChartContext2.groupedDatums;

    return React__default['default'].useMemo(function () {
      var columns = series[0].datums.filter(function (datum) {
        var primaryValue = primaryAxis.getValue(datum.originalDatum);
        return primaryValue !== 'undefined' && primaryValue !== null;
      }).map(function (datum, i, all) {
        var _primaryAxis$scale$ra, _groupedDatums$get;

        var prev = all[i - 1];
        var next = all[i + 1];
        var primaryValue = primaryAxis.getValue(datum.originalDatum);
        var primaryPx = getPrimary(datum, primaryAxis);
        var range = (_primaryAxis$scale$ra = primaryAxis == null ? void 0 : primaryAxis.scale.range()) != null ? _primaryAxis$scale$ra : [0, 0];
        var primaryStart = range[0],
            primaryEnd = range[1];

        if (prev) {
          var prevPx = getPrimary(prev, primaryAxis);
          primaryStart = primaryPx - (primaryPx - prevPx) / 2;
        }

        if (next) {
          var nextPx = getPrimary(next, primaryAxis);
          primaryEnd = primaryPx + (nextPx - primaryPx) / 2;
        }

        var datums = (_groupedDatums$get = groupedDatums.get("" + primaryValue)) != null ? _groupedDatums$get : [];
        datums.sort(function (a, b) {
          var _aAxis$scale, _a$stackData, _bAxis$scale, _b$stackData;

          var aAxis = secondaryAxes.find(function (d) {
            return d.id === a.secondaryAxisId;
          });
          var bAxis = secondaryAxes.find(function (d) {
            return d.id === b.secondaryAxisId;
          });
          var aPx = (_aAxis$scale = aAxis == null ? void 0 : aAxis.scale(aAxis.stacked ? (_a$stackData = a.stackData) == null ? void 0 : _a$stackData[1] : aAxis == null ? void 0 : aAxis.getValue(a.originalDatum))) != null ? _aAxis$scale : NaN;
          var bPx = (_bAxis$scale = bAxis == null ? void 0 : bAxis.scale(bAxis.stacked ? (_b$stackData = b.stackData) == null ? void 0 : _b$stackData[1] : bAxis == null ? void 0 : bAxis.getValue(b.originalDatum))) != null ? _bAxis$scale : NaN;
          return aPx - bPx;
        });
        return {
          primaryStart: primaryStart,
          primaryEnd: primaryEnd,
          primaryPx: primaryPx,
          datumBoundaries: datums.filter(function (datum) {
            var secondaryAxis = secondaryAxes.find(function (d) {
              return d.id === datum.secondaryAxisId;
            });
            var secondaryValue = secondaryAxis == null ? void 0 : secondaryAxis.getValue(datum.originalDatum);
            return typeof secondaryValue !== 'undefined' && secondaryValue !== null;
          }).map(function (datum, i, all) {
            var _secondaryAxis$scale3, _secondaryAxis$scale$2;

            var prev = all[i - 1];
            var next = all[i + 1];
            var secondaryAxis = secondaryAxes.find(function (d) {
              return d.id === datum.secondaryAxisId;
            });

            if (secondaryAxis != null && secondaryAxis.stacked) {
              var _secondaryAxis$scale$, _datum$stackData, _datum$stackData2;

              var _range = (_secondaryAxis$scale$ = secondaryAxis == null ? void 0 : secondaryAxis.scale.range()) != null ? _secondaryAxis$scale$ : [0, 0];

              var stackData = [(_datum$stackData = datum.stackData) == null ? void 0 : _datum$stackData[0], (_datum$stackData2 = datum.stackData) == null ? void 0 : _datum$stackData2[1]];

              if (secondaryAxis != null && secondaryAxis.isVertical) {
                _range.reverse();

                stackData.reverse();
              }

              var _secondaryStart = _range[0],
                  _secondaryEnd = _range[1];

              if (prev) {
                var _secondaryAxis$scale, _stackData$;

                _secondaryStart = (_secondaryAxis$scale = secondaryAxis == null ? void 0 : secondaryAxis.scale((_stackData$ = stackData[0]) != null ? _stackData$ : NaN)) != null ? _secondaryAxis$scale : NaN;
              }

              if (next) {
                var _secondaryAxis$scale2, _stackData$2;

                _secondaryEnd = (_secondaryAxis$scale2 = secondaryAxis == null ? void 0 : secondaryAxis.scale((_stackData$2 = stackData[1]) != null ? _stackData$2 : NaN)) != null ? _secondaryAxis$scale2 : NaN;
              }

              return {
                secondaryStart: _secondaryStart,
                secondaryEnd: _secondaryEnd,
                datum: datum
              };
            }

            var value = (_secondaryAxis$scale3 = secondaryAxis == null ? void 0 : secondaryAxis.scale(secondaryAxis == null ? void 0 : secondaryAxis.getValue(datum.originalDatum))) != null ? _secondaryAxis$scale3 : NaN;
            var range = (_secondaryAxis$scale$2 = secondaryAxis == null ? void 0 : secondaryAxis.scale.range()) != null ? _secondaryAxis$scale$2 : [0, 0];

            if (secondaryAxis != null && secondaryAxis.isVertical) {
              range.reverse();
            }

            var secondaryStart = range[0],
                secondaryEnd = range[1];

            if (prev) {
              var _prevAxis$scale;

              var prevAxis = secondaryAxes.find(function (d) {
                return d.id === (prev == null ? void 0 : prev.secondaryAxisId);
              });
              var prevValue = (_prevAxis$scale = prevAxis == null ? void 0 : prevAxis.scale(prevAxis == null ? void 0 : prevAxis.getValue(prev.originalDatum))) != null ? _prevAxis$scale : NaN;
              secondaryStart = value - (value - prevValue) / 2;
            }

            if (next) {
              var _nextAxis$scale;

              var nextAxis = secondaryAxes.find(function (d) {
                return d.id === (next == null ? void 0 : next.secondaryAxisId);
              });
              var nextValue = (_nextAxis$scale = nextAxis == null ? void 0 : nextAxis.scale(nextAxis == null ? void 0 : nextAxis.getValue(next.originalDatum))) != null ? _nextAxis$scale : NaN;
              secondaryEnd = value + (nextValue - value) / 2;
            }

            return {
              secondaryStart: secondaryStart,
              secondaryEnd: secondaryEnd,
              datum: datum
            };
          })
        };
      });
      return /*#__PURE__*/React__default['default'].createElement("g", {
        onMouseLeave: function onMouseLeave() {
          return handleFocus(null);
        },
        style: {
          transform: translate(gridDimensions.gridX, gridDimensions.gridY)
        }
      }, columns.map(function (column) {
        return /*#__PURE__*/React__default['default'].createElement(React__default['default'].Fragment, {
          key: column.primaryPx
        }, column.datumBoundaries.map(function (datumBoundary) {
          var x1 = !primaryAxis.isVertical ? column.primaryStart : datumBoundary.secondaryStart;
          var x2 = !primaryAxis.isVertical ? column.primaryEnd : datumBoundary.secondaryEnd;
          var y1 = !primaryAxis.isVertical ? datumBoundary.secondaryStart : column.primaryStart;
          var y2 = !primaryAxis.isVertical ? datumBoundary.secondaryEnd : column.primaryEnd;
          var x = Math.min(x1, x2);
          var y = Math.min(y1, y2);
          var xEnd = Math.max(x1, x2);
          var yEnd = Math.max(y1, y2);
          var height = Math.max(yEnd - y, 0);
          var width = Math.max(xEnd - x, 0);
          return /*#__PURE__*/React__default['default'].createElement("rect", {
            key: column.primaryPx + "_" + datumBoundary.datum.seriesIndex,
            x: x,
            y: y,
            width: width,
            height: height,
            className: 'action-voronoi',
            onMouseEnter: function onMouseEnter() {
              return handleFocus(datumBoundary.datum);
            },
            style: {
              fill: getOptions().dark ? '#ffffff33' : 'rgba(0,0,0,0.2)',
              strokeWidth: 1,
              stroke: getOptions().dark ? 'white' : 'black',
              opacity: getOptions().showVoronoi ? 1 : 0
            }
          });
        }));
      }));
    }, [getOptions, gridDimensions.gridX, gridDimensions.gridY, groupedDatums, handleFocus, primaryAxis, secondaryAxes, series]);
  } // function ClosestVoronoi({
  //   stackData,
  //   extent,
  //   handleFocus,
  //   showVoronoi,
  // }: {
  //   stackData: Series[]
  //   extent: number[][]
  //   handleFocus: (datum: Datum | null) => void
  //   showVoronoi: boolean
  // }) {
  //   let polygons = null
  //   const voronoiData: { x: number; y: number; datum: Datum }[] = []
  //   stackData.forEach(series => {
  //     series.datums
  //       .filter(d => d.defined)
  //       .forEach(datum => {
  //         datum.boundingPoints.forEach(boundingPoint => {
  //           if (
  //             typeof datum.x !== 'number' ||
  //             typeof datum.y !== 'number' ||
  //             Number.isNaN(datum.y) ||
  //             Number.isNaN(datum.x)
  //           ) {
  //             return
  //           }
  //           voronoiData.push({
  //             x: boundingPoint.x,
  //             y: boundingPoint.y,
  //             datum,
  //           })
  //         })
  //       })
  //   })
  //   const delaunay = Delaunay.from(
  //     voronoiData,
  //     d => Math.max(d.x, 0),
  //     d => Math.max(d.y, 0)
  //   )
  //   const flatExtent = extent.flat().map(d => Math.max(d, 0))
  //   const voronoi = delaunay.voronoi(flatExtent)
  //   polygons = voronoi.cellPolygons()
  //   polygons = Array.from(polygons)
  //   return (
  //     <g>
  //       {polygons.map((points, i) => {
  //         const index = points.index
  //         const datum = voronoiData[index].datum
  //         const path = lineFn(points as any) || undefined
  //         return (
  //           <Path
  //             key={i}
  //             d={path}
  //             className="action-voronoi"
  //             onMouseEnter={() => handleFocus(datum)}
  //             onMouseLeave={() => handleFocus(null)}
  //             style={{
  //               fill: randomFill(),
  //               opacity: showVoronoi ? 1 : 0,
  //             }}
  //           />
  //         )
  //       })}
  //     </g>
  //   )
  // }

  var _excluded = ["options", "className", "style"];
  //

  var defaultColorScheme = ['#0f83ab', '#faa43a', '#ff4e4e', '#53cfc9', '#a2d925', '#decf3f', '#734fe9', '#cd82ad', '#006d92', '#de7c00', '#f33232', '#3f9a80', '#53c200', '#d7af00', '#4c26c9', '#d44d99'];

  function defaultChartOptions(options) {
    var _options$initialWidth, _options$initialHeigh, _options$getSeriesSty, _options$getDatumStyl, _options$getSeriesOrd, _options$groupingMode, _options$showVoronoi, _options$defaultColor, _options$useIntersect, _options$intersection, _options$tooltip, _options$primaryCurso, _options$secondaryCur;

    return _extends$3({}, options, {
      initialWidth: (_options$initialWidth = options.initialWidth) != null ? _options$initialWidth : 300,
      initialHeight: (_options$initialHeigh = options.initialHeight) != null ? _options$initialHeigh : 200,
      getSeriesStyle: (_options$getSeriesSty = options.getSeriesStyle) != null ? _options$getSeriesSty : function () {
        return {};
      },
      getDatumStyle: (_options$getDatumStyl = options.getDatumStyle) != null ? _options$getDatumStyl : function () {
        return {};
      },
      getSeriesOrder: (_options$getSeriesOrd = options.getSeriesOrder) != null ? _options$getSeriesOrd : function (series) {
        return series;
      },
      groupingMode: (_options$groupingMode = options.groupingMode) != null ? _options$groupingMode : 'primary',
      showVoronoi: (_options$showVoronoi = options.showVoronoi) != null ? _options$showVoronoi : false,
      defaultColors: (_options$defaultColor = options.defaultColors) != null ? _options$defaultColor : defaultColorScheme,
      useIntersectionObserver: (_options$useIntersect = options.useIntersectionObserver) != null ? _options$useIntersect : true,
      intersectionObserverRootMargin: (_options$intersection = options.intersectionObserverRootMargin) != null ? _options$intersection : '1000px',
      tooltip: (_options$tooltip = options.tooltip) != null ? _options$tooltip : true,
      primaryCursor: (_options$primaryCurso = options.primaryCursor) != null ? _options$primaryCurso : true,
      secondaryCursor: (_options$secondaryCur = options.secondaryCursor) != null ? _options$secondaryCur : true
    });
  }

  function Chart(_ref) {
    var userOptions = _ref.options,
        className = _ref.className,
        _ref$style = _ref.style,
        style = _ref$style === void 0 ? {} : _ref$style,
        rest = _objectWithoutPropertiesLoose$2(_ref, _excluded);

    var options = defaultChartOptions(userOptions);

    var _React$useState = React__default['default'].useState(null),
        chartElement = _React$useState[0],
        setContainerElement = _React$useState[1];

    var containerEl = chartElement == null ? void 0 : chartElement.parentElement;
    var nearestScrollableParent = React__default['default'].useMemo(function () {
      var run = function run(el) {
        if (!el) {
          return null;
        }

        var grandParent = el.parentElement;

        if (!grandParent) {
          return null;
        }

        if (grandParent.scrollHeight > grandParent.clientHeight) {
          var _window$getComputedSt = window.getComputedStyle(grandParent),
              overflow = _window$getComputedSt.overflow;

          if (overflow.includes('scroll') || overflow.includes('auto')) {
            return grandParent;
          }
        }

        return run(grandParent);
      };

      return run(containerEl);
    }, [containerEl]);

    var _React$useState2 = React__default['default'].useState({
      width: options.initialWidth,
      height: options.initialHeight
    }),
        _React$useState2$ = _React$useState2[0],
        width = _React$useState2$.width,
        height = _React$useState2$.height,
        setDims = _React$useState2[1];

    useIsomorphicLayoutEffect(function () {
      if (containerEl) {
        var computed = window.getComputedStyle(containerEl);

        if (!['relative', 'absolute', 'fixed'].includes(computed.position)) {
          containerEl.style.position = 'relative';
        }
      }
    }, [containerEl]);
    React__default['default'].useEffect(function () {
      if (!containerEl) {
        return;
      }

      var observer = new ResizeObserver(function () {
        var rect = containerEl == null ? void 0 : containerEl.getBoundingClientRect();

        if (rect) {
          setDims({
            width: rect.width,
            height: rect.height
          });
        }
      });
      observer.observe(containerEl);
      return function () {
        observer.unobserve(containerEl);
      };
    }, [containerEl]);

    var _React$useState3 = React__default['default'].useState(true),
        isIntersecting = _React$useState3[0],
        setIsIntersecting = _React$useState3[1];

    React__default['default'].useEffect(function () {
      if (!containerEl || !options.useIntersectionObserver) return;
      var observer = new IntersectionObserver(function (entries) {
        for (var _iterator = _createForOfIteratorHelperLoose(entries), _step; !(_step = _iterator()).done;) {
          var entry = _step.value;

          if (entry.isIntersecting) {
            setIsIntersecting(true);
          } else {
            setIsIntersecting(false);
          }
        }
      }, {
        root: nearestScrollableParent,
        rootMargin: options.intersectionObserverRootMargin
      });
      observer.observe(containerEl);
      return function () {
        observer.unobserve(containerEl);
      };
    }, [containerEl, nearestScrollableParent, options.intersectionObserverRootMargin, options.useIntersectionObserver]);
    return /*#__PURE__*/React__default['default'].createElement("div", _extends$3({
      ref: setContainerElement
    }, rest, {
      className: "ReactChart " + (className || ''),
      style: _extends$3({}, style, {
        position: 'absolute',
        width: width,
        height: height
      })
    }), isIntersecting ? /*#__PURE__*/React__default['default'].createElement(ChartInner, {
      options: options,
      width: width,
      height: height
    }) : null);
  }

  function ChartInner(_ref2) {
    var _options$renderSVG;

    var options = _ref2.options,
        width = _ref2.width,
        height = _ref2.height;

    if (!options.primaryAxis) {
      throw new Error('A primaryAxis is required');
    }

    if (!options.secondaryAxes.length) {
      throw new Error('At least one secondaryAxis is required');
    }

    var svgRef = React__default['default'].useRef(null);
    var getOptions = useGetLatest(options);
    var axisDimensionsAtom = React__default['default'].useMemo(function () {
      return atom({
        left: {},
        right: {},
        top: {},
        bottom: {}
      });
    }, []);
    var focusedDatumAtom = React__default['default'].useMemo(function () {
      return atom(null);
    }, []);
    var useAxisDimensionsAtom = React__default['default'].useCallback(function () {
      // eslint-disable-next-line
      return useAtom(axisDimensionsAtom);
    }, [axisDimensionsAtom]);
    var useFocusedDatumAtom = React__default['default'].useCallback(function () {
      // eslint-disable-next-line
      return useAtom(focusedDatumAtom);
    }, [focusedDatumAtom]); // useAtom<Datum<TDatum> | null>(focusedDatumAtom)

    var _useAxisDimensionsAto = useAxisDimensionsAtom(),
        axisDimensions = _useAxisDimensionsAto[0];

    var _useFocusedDatumAtom = useFocusedDatumAtom(),
        focusedDatum = _useFocusedDatumAtom[0];

    var gridDimensions = React__default['default'].useMemo(function () {
      // Left
      var _map = ['width', 'top', 'bottom'].map(function (prop) {
        return sumAllDimensionProperties(axisDimensions.left, prop);
      }),
          axesLeftWidth = _map[0],
          axesLeftTop = _map[1],
          axesLeftBottom = _map[2];

      var _map2 = ['width', 'top', 'bottom'].map(function (prop) {
        return sumAllDimensionProperties(axisDimensions.right, prop);
      }),
          axesRightWidth = _map2[0],
          axesRightTop = _map2[1],
          axesRightBottom = _map2[2];

      var _map3 = ['height', 'left', 'right'].map(function (prop) {
        return sumAllDimensionProperties(axisDimensions.top, prop);
      }),
          axesTopHeight = _map3[0],
          axesTopLeft = _map3[1],
          axesTopRight = _map3[2];

      var _map4 = ['height', 'left', 'right'].map(function (prop) {
        return sumAllDimensionProperties(axisDimensions.bottom, prop);
      }),
          axesBottomHeight = _map4[0],
          axesBottomLeft = _map4[1],
          axesBottomRight = _map4[2];

      var gridX = Math.max(axesLeftWidth, axesTopLeft, axesBottomLeft);
      var gridY = Math.max(axesTopHeight, axesLeftTop, axesRightTop);
      var gridWidth = Math.max(0, width - Math.max(axesLeftWidth, axesTopLeft, axesBottomLeft) - Math.max(axesRightWidth, axesTopRight, axesBottomRight));
      var gridHeight = Math.max(0, height - Math.max(axesTopHeight, axesLeftTop, axesRightTop) - Math.max(axesBottomHeight, axesLeftBottom, axesRightBottom));
      return {
        gridX: gridX,
        gridY: gridY,
        gridWidth: gridWidth,
        gridHeight: gridHeight
      };
    }, [width, height, axisDimensions]);
    var series = React__default['default'].useMemo(function () {
      var series = [];

      for (var seriesIndex = 0; seriesIndex < options.data.length; seriesIndex++) {
        var _originalSeries$id, _originalSeries$label;

        var originalSeries = options.data[seriesIndex];
        var seriesId = (_originalSeries$id = originalSeries.id) != null ? _originalSeries$id : seriesIndex + '';
        var seriesLabel = (_originalSeries$label = originalSeries.label) != null ? _originalSeries$label : "Series " + (seriesIndex + 1);
        var secondaryAxisId = originalSeries.secondaryAxisId;
        var originalDatums = originalSeries.data;
        var datums = [];

        for (var datumIndex = 0; datumIndex < originalDatums.length; datumIndex++) {
          var originalDatum = originalDatums[datumIndex];
          datums[datumIndex] = {
            originalSeries: originalSeries,
            seriesIndex: seriesIndex,
            seriesId: seriesId,
            seriesLabel: seriesLabel,
            secondaryAxisId: secondaryAxisId,
            index: datumIndex,
            originalDatum: originalDatum
          };
        }

        series[seriesIndex] = {
          originalSeries: originalSeries,
          index: seriesIndex,
          id: seriesId,
          label: seriesLabel,
          secondaryAxisId: secondaryAxisId,
          datums: datums
        };
      }

      if (options.secondaryAxes.some(function (axisOptions) {
        return axisOptions.stacked;
      })) {
        options.secondaryAxes.filter(function (d) {
          return d.stacked;
        }).forEach(function (secondaryAxis) {
          var _secondaryAxis$stackO;

          var axisSeries = series.filter(function (s) {
            return s.secondaryAxisId === secondaryAxis.id;
          });
          var seriesIndices = Object.keys(axisSeries);
          var stacker = stack().keys(seriesIndices).value(function (_, seriesIndex, index) {
            var val = secondaryAxis.getValue(axisSeries[Number(seriesIndex)].datums[index].originalDatum);

            if (typeof val === 'undefined' || val === null) {
              return 0;
            }

            return val;
          }).offset((_secondaryAxis$stackO = secondaryAxis.stackOffset) != null ? _secondaryAxis$stackO : stackOffsetNone);
          var stacked = stacker(Array.from({
            length: axisSeries.sort(function (a, b) {
              return b.datums.length - a.datums.length;
            })[0].datums.length
          }));
          stacked.forEach(function (s, sIndex) {
            s.forEach(function (datum, i) {
              // @ts-ignore
              datum.data = axisSeries[sIndex].datums[i];
              axisSeries[sIndex].datums[i].stackData = datum;
            });
          });
        });
      }

      return series;
    }, [options.data, options.secondaryAxes]);
    var primaryAxis = React__default['default'].useMemo(function () {
      return buildAxisLinear(options.primaryAxis, series, gridDimensions, width, height);
    }, [gridDimensions, height, options.primaryAxis, series, width]);
    var secondaryAxes = React__default['default'].useMemo(function () {
      return options.secondaryAxes.map(function (secondaryAxis) {
        return buildAxisLinear(secondaryAxis, series, gridDimensions, width, height);
      });
    }, [gridDimensions, height, options.secondaryAxes, series, width]);
    var axesInfo = React__default['default'].useMemo(function () {
      // Make sure we're mapping x and y to the correct axes
      var xKey = primaryAxis.isVertical ? 'secondary' : 'primary';
      var yKey = primaryAxis.isVertical ? 'primary' : 'secondary';
      return {
        xKey: xKey,
        yKey: yKey
      };
    }, [primaryAxis]);
    var groupedDatums = React__default['default'].useMemo(function () {
      var groupedDatums = new Map();
      var allDatums = series.map(function (s) {
        return s.datums;
      }).flat(2);
      allDatums.forEach(function (datum) {
        var primaryValue = "" + primaryAxis.getValue(datum.originalDatum);

        if (!groupedDatums.has(primaryValue)) {
          groupedDatums.set(primaryValue, []);
        }

        groupedDatums.get(primaryValue).push(datum);
      });
      allDatums.forEach(function (datum) {
        var primaryValue = "" + primaryAxis.getValue(datum.originalDatum);
        datum.group = groupedDatums.get(primaryValue);
      });
      return groupedDatums;
    }, [primaryAxis, series]);
    var getSeriesStatusStyle = React__default['default'].useCallback(function (series, focusedDatum) {
      var base = {
        color: getOptions().defaultColors[series.index % (getOptions().defaultColors.length - 1)]
      };
      var status = getSeriesStatus(series, focusedDatum);
      var statusStyles = getOptions().getSeriesStyle(series, status);
      series.style = materializeStyles(statusStyles, base);
      return series.style;
    }, [getOptions]);
    var getDatumStatusStyle = React__default['default'].useCallback(function (datum, focusedDatum) {
      var base = _extends$3({}, series[datum.seriesIndex].style, {
        color: getOptions().defaultColors[datum.seriesIndex % (getOptions().defaultColors.length - 1)]
      });

      var status = getDatumStatus(datum, focusedDatum);
      var statusStyles = getOptions().getDatumStyle(datum, status);
      datum.style = materializeStyles(statusStyles, base);
      return datum.style;
    }, [getOptions, series]); // const mouseMoveRafRef = React.useRef<number | null>()
    // const onMouseMove = (
    //   e: React.MouseEvent<SVGSVGElement, MouseEvent> | MouseEvent
    // ) => {
    //   if (mouseMoveRafRef.current) {
    //     Raf.cancel(mouseMoveRafRef.current)
    //   }
    //   mouseMoveRafRef.current = Raf(() => {
    //     mouseMoveRafRef.current = null
    //     const { clientX, clientY } = e
    //     setPointer(old => {
    //       const x = clientX - svgRect.left - gridDimensions.gridX
    //       const y = clientY - svgRect.top - gridDimensions.gridY
    //       return {
    //         ...old,
    //         svgHovered: true,
    //         x,
    //         y,
    //       }
    //     })
    //   })
    // }
    // const onMouseUp = () => {
    //   document.removeEventListener('mouseup', onMouseUp)
    //   document.removeEventListener('mousemove', onMouseMove)
    //   // if (options.brush?.onSelect && pointer.dragging) {
    //   //   if (Math.abs(pointer.startX - pointer.x) >= 20) {
    //   //     options.brush.onSelect({
    //   //       pointer,
    //   //       start: (axesInfo.primaryAxes[0].scale as ScaleLinear<
    //   //         number,
    //   //         number
    //   //       >).invert(pointer.startX),
    //   //       end: (axesInfo.primaryAxes[0].scale as ScaleLinear<
    //   //         number,
    //   //         number
    //   //       >).invert(pointer.x),
    //   //     })
    //   //   }
    //   // }
    //   setPointer(
    //     (old): Pointer => {
    //       return {
    //         ...old,
    //         dragging: false,
    //       }
    //     }
    //   )
    // }
    // const onMouseDown = () => {
    //   document.addEventListener('mouseup', onMouseUp)
    //   document.addEventListener('mousemove', onMouseMove)
    //   setPointer(
    //     (old): Pointer => {
    //       return {
    //         ...old,
    //         startX: old.x,
    //         startY: old.y,
    //         dragging: true,
    //       }
    //     }
    //   )
    // }
    // Reverse the stack order for proper z-indexing

    var reversedSeries = [].concat(series).reverse();
    var orderedSeries = options.getSeriesOrder(reversedSeries); // const focusedSeriesIndex = focusedDatum
    //   ? orderedSeries.findIndex(series => series.id === focusedDatum.seriesId)
    //   : -1
    // Bring focused series to the front
    // orderedSeries = focusedDatum
    //   ? [
    //       ...orderedSeries.slice(0, focusedSeriesIndex),
    //       ...orderedSeries.slice(focusedSeriesIndex + 1),
    //       orderedSeries[focusedSeriesIndex],
    //     ]
    //   : orderedSeries

    useIsomorphicLayoutEffect(function () {
      if (svgRef.current && svgRef.current.parentElement && !svgRef.current.parentElement.style.position) {
        svgRef.current.parentElement.style.position = 'relative';
      }
    });
    var contextValue = {
      getOptions: getOptions,
      gridDimensions: gridDimensions,
      primaryAxis: primaryAxis,
      secondaryAxes: secondaryAxes,
      axesInfo: axesInfo,
      series: series,
      orderedSeries: orderedSeries,
      groupedDatums: groupedDatums,
      width: width,
      height: height,
      getSeriesStatusStyle: getSeriesStatusStyle,
      getDatumStatusStyle: getDatumStatusStyle,
      useAxisDimensionsAtom: useAxisDimensionsAtom,
      useFocusedDatumAtom: useFocusedDatumAtom,
      svgRef: svgRef
    };
    var seriesByAxisId = sort(groups(orderedSeries, function (d) {
      return d.secondaryAxisId;
    }), function (_ref3) {
      var key = _ref3[0];
      return secondaryAxes.findIndex(function (axis) {
        return axis.id === key;
      });
    });
    return /*#__PURE__*/React__default['default'].createElement(ChartContextProvider, {
      value: useGetLatest(contextValue)
    }, /*#__PURE__*/React__default['default'].createElement("div", {
      style: {
        fontFamily: 'sans-serif'
      }
    }, /*#__PURE__*/React__default['default'].createElement("svg", {
      ref: svgRef,
      style: {
        width: width,
        height: height,
        overflow: options.brush ? 'hidden' : 'visible'
      } // onMouseEnter={e => {
      //   e.persist()
      //   onMouseMove(e)
      // }}
      // onMouseMove={e => {
      //   e.persist()
      //   onMouseMove(e)
      // }}
      // onMouseLeave={e => {
      //   e.persist()
      //   setPointer(old => {
      //     return {
      //       ...old,
      //       svgHovered: false,
      //     }
      //   })
      // }}
      // onMouseDown={e => {
      //   e.persist()
      //   onMouseDown()
      // }}
      ,
      onClick: function onClick(e) {
        return options.onClickDatum == null ? void 0 : options.onClickDatum(focusedDatum, e);
      }
    }, /*#__PURE__*/React__default['default'].createElement("g", {
      className: "Series",
      style: {
        pointerEvents: 'none'
      }
    }, seriesByAxisId.map(function (_ref4) {
      var axisId = _ref4[0],
          series = _ref4[1];
      var secondaryAxis = secondaryAxes.find(function (d) {
        return d.id === axisId;
      });

      if (!secondaryAxis) {
        return null;
      }

      var elementType = secondaryAxis.elementType;

      var Component = function () {
        if (elementType === 'line') {
          return Line;
        }

        if (elementType === 'bar') {
          return BarComponent;
        }

        if (elementType === 'area') {
          return AreaComponent;
        }

        throw new Error('Invalid elementType');
      }();

      return /*#__PURE__*/React__default['default'].createElement(Component, {
        key: axisId != null ? axisId : '__default__',
        primaryAxis: primaryAxis,
        secondaryAxis: secondaryAxis,
        series: series
      });
    })), /*#__PURE__*/React__default['default'].createElement("g", {
      className: "axes"
    }, [primaryAxis].concat(secondaryAxes).map(function (axis) {
      return /*#__PURE__*/React__default['default'].createElement(AxisLinearComp, _extends$3({
        key: [axis.position, axis.id].join('')
      }, axis));
    })), /*#__PURE__*/React__default['default'].createElement(Voronoi, null), (_options$renderSVG = options.renderSVG == null ? void 0 : options.renderSVG()) != null ? _options$renderSVG : null), /*#__PURE__*/React__default['default'].createElement(Cursors, null), /*#__PURE__*/React__default['default'].createElement(Tooltip, null)));
  }

  function sumAllDimensionProperties(axisDimensions, side) {
    var sum = 0;
    Object.keys(axisDimensions).forEach(function (axisId) {
      var _axisDimensions$axisI;

      sum += ((_axisDimensions$axisI = axisDimensions[axisId]) == null ? void 0 : _axisDimensions$axisI[side]) || 0;
    });
    return sum;
  }

  exports.Chart = Chart;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=react-charts.development.js.map
